*DECK AEFREQ
          IDENT  AEFREQ
          B1=1
AEFREQ    TITLE  AEFREQ- SET PRINT FREQUENCY FOR NON FATAL MESSAGES
          COMMENT   SET PRINT FREQUENCY FOR AELIB ERRORS
*
* SUBROUTINE AEFREQ (N,M)
*      SET THE PRINT FREQUENCY OF AELIB ERROR NUMBER -N- TO PRINT ERROR
*      MESSAGE AFTER -M- ERRORS ENCOUNTERED.
          SPACE  4
*CALL ERRORC
D00PRM    EQU    IERWD
          SPACE  2
          USE    /AE$COMM/    BLOCK FOR MISC ARRAYS.
MSGTBL    BSSZ   11           TABLE FOR NON-FATAL ERRORS
*                        FORMAT - 12/NFREQ,12/NMESS,18/NTOT,18/MESS
NONFMSG   DATA   0
PLTMES    BSSZ   14
          USE
          SPACE  4,8
          ENTRY  AEFREQ
TRACE     VFD    42/6HAEFREQ,18/AEFREQ       FOR TRACE BACK.
AEFREQ    DATA   0
          SB3    A0          SAVE A0
          SA0    A1          SAVE A1
*CALL STATC
          SA1    A0          RESTORE A1
          SB1    1
          SA5    PRTJMP
          SA2    A1+B1        ADDRESS OF FREQUENCY
          SA1    X1           MESSAGE NUMBER
          BX6    X5           PUT JUMP TO PRINT SUMMARY
*
*     FTN4 (NOS/BE) - PLANT ADDRESS IN FORSYS= TO GENERATE SUMMARY
*                     AT END OF JOB
*
*     NOS OR FTN5   - DON'T TOUCH FORSYS=, BUT MAKE PRTSUM AN ENTRY POIN
*                     TO BE CALLED BY USER IF SUMMARY IS WANTED.
*
*IF -DEF,NOS
*IF -DEF,AELIB5
          SA6    =XAE$FRSX         INTO FORSYS=.
*ENDIF
*IF DEF,NOS
*IF DEF,AELIB5
          ENTRY PRTSUM
*ENDIF
          SA3    NONFMSG
          SB2    X1
          SA2    X2           FREQUENCY.
          SB7    MSGTBL
          ZR     X3,AEF2      IF NO ENTRYS IN TABLE
          SB6    B7+X3        ADDRESS OF TOP ENTRY IN TABLE
AEF1      SA1    B7           TABLE ENTRY
          SB5    X1           MESSAGE NUMBER
          EQ     B5,B2,AEF4   IF MESSAGE NUMBERS MATCH.
          SB7    B7+B1
          LT     B7,B6,AEF1   LOOP AND GET NEXT ENTRY
AEF2      SX7    X3+B1        STEP MAX NO OF ERRORS
          SX6    X7-11
          NG     X6,AEF3      IF LESS=10 ENTRIES IN TABLE
          SA1    ARG1         ISSUE -NON-FATAL ERROR TABLE OVERFLOW.
          RJ     =XAELERR
AEF3      SA7    A3           STORE INDEX.
          SX1    B2           SET UP TABLE ENTRY
AEF4      LX2    60-12
          MX0    12
          BX4    -X0*X1       CLEAR OUT NFREQ
          BX5    X0*X2        CLEAR EXTRANEOUS BITS FROM NFREQ.
          BX6    X4+X5        ADD NFREQ TO TABLE ENTRY
          SA6    B7           STORE ENTRY
          SA0    B3          RESTORE A0
          EQ     AEFREQ       RETURN.
PRTSUM    SPACE  4,8
* PRTSUM - CALLED AT THE END OF A JOB TO PRINT THE AELIB NON-FATAL
*     ERROR SUMMARY. THIS SUBROUTINE IS CALLED BY FORSYS=. THE ADDRESS
*     IS GIVEN TO FORSYS= BY AEFREQ.
PRTSUM    DATA   0            ENTRY/EXIT LINE
**     TRY TO LOCATE THE OUTPUT FIT.
          SA1    =6LOUTPUT
          BX1    -X1
          RJ     =XGETFIT.      LOCATE OUTPUT FIT
          ZR     X1,PRTS10      IF NO OUTPUT FILE.
          SA0    X1
          BX6    X1
          SA6    PAR            SAVE FIT ADDRESS
          STORE  A0,EX=OUTEX  JUST IN CASE
          FETCH  A0,OC,X5
          SB5    B5-#OPE#
          ZR     B5,PRTS4     IF FILE ALREADY OPEN
          STORE  A0,MRL=150
          STORE  A0,RT=Z
          OPENM  A0,I-O,,SQ   OPEN FILE.
          EQ     PRTS4
PRTS3     STORE  X3,EX=OUTEX
          SA0    X3           SET FIT ADDRESS
PRTS4     SX2    B1+B1
          RJ     CALLD00      GET HEADER MESSAGE
          SB4    PLTMES+1     ADDRESS OF MESSAGE
          SB5    B0
          RJ     PUTMES       WRITE MESSAGE
          SX2    3
          RJ     CALLD00      GET 2ND LINE OF HEADER
          SB5    B0
          SB4    PLTMES+1     ADDRESS OF MESSAGE
          RJ     PUTMES
PRTS5     SA1    NONFMSG      INCREMENT FOR OUTPUT RECORD SITE.
          ZR     X1,PRTS6     IF NO ENTRIES IN TABLE (IE FINISH ISSUING)
          SX6    X1-1         STEP ENTRY COUNT
          SA6    NONFMSG
          SA3    MSGTBL+X6    TABLE ENTRY
          SX2    X3           MESSAGE NUMBER
          LX3    60-18        RIGHT SHIFT I8 BITS
          SB6    X3           MESSAGE COUNT - SAVE FOR LATER
          RJ     CALLD00      GET MESSAGE.
          SB5    B1
          SX4    B6
***** ROUTINE FOR CONVERSION TO DISPLAY CODE CHANGED FROM CDD TO CBD FOR
***** FTN4.5 OCTOBER 1975
          RJ     =XCBD.      CONVERT COUNT TO DISPLAY CODE
          SB1    B5           RESET B1
          SA1    =4L0000
          LX1    B7
          MX0    24
          BX0    X1*X0       GET ZEROS FOR ZERO FILL
          SB4    24
          SB4    B4-B7
          AX6    B4
          BX7    X0+X6       ADD IN STARTING ZEROS
          SB4    PLTMES
          LX7    60-6         SHIFT RIGHT 1 CHARACTER (FOR CARRIAGE CONT
          SA7    B4
          RJ     PUTMES       WRITE LINE.
          EQ     PRTS5        LOOP.
PRTS6     CLOSEM A0,N,FILE,SQ
          EQ     PRTSUM       RETURN
CALLD00   SPACE  2,8
CALLD00   DATA   0            SUBROUTINE TO CALL D00 TO PUT MESSAGE
          SA3    D00PR1       INTO PLTMES
          LX2    36           SHIFT MESSAGE NUMBER
          BX6    X2+X3        PUT INTO D00 CALL
          SA6    D00PRM
          SYSTEM D00,,D00PRM       GET ERROR MESSAGE.
          EQ     CALLD00
PUTMES    SPACE  2,8
PUTMES    DATA   0
          RECALL D00PRM       JUST IN CASE
          SA1    D00PRM
          MX0    48
          LX1    60-12        GET BYTE 2
          SB7    7777B
          BX5    -X0*X1
          ZR     X5,PRTS11    IF NO CHARACTERS IN MESSAGE
          SB6    X5
          EQ     B6,B7,PRTS11 IF TROUBLE WITH MESSAGE
          SX6    B4           ADDRESS OF MESSAGE
          SX4    B6+B5        WORD COUNT
          PUTWR  A0,X6,X4     WRITE MESSAGE
          EQ     PUTMES       RETURN
CALLD00X  SPACE  2,8
CALLD00X  DATA   0            SUBR. TO CALL D00 TO PUT MESSAGE INTO
          RECALL D00PRM       JUST IN CASE
          SX2    B2
          SA3    D00PR2       DAYFILE
          LX2    36           SHIFT MESSAGE NUMBER
          BX6    X2+X3        PUT INTO D00 CALL
          SA6    D00PRM
          SYSTEM D00,,D00PRM       PUT MESSAGE INTO DAYFILE.
          EQ     CALLD00X
ERRORS    SPACE  4,8
OUTEX     DATA   0            SUBR. CALLED IN CASE OF TROUBLE WITH
          SB2    4
          RJ     CALLD00X     PUT -UNUSEABLE OUTPUT FILE- INTO DAYFILE
          EQ     ENDITALL
PRTS10    SB2    5            PUT -NO OUTPUT FILE FOUND- INTO DAYFILE
          RJ     CALLD00X
          EQ     ENDITALL
PRTS11    BSS    0
ENDITALL  MESSAGE   (=C$ TROUBLE IN AELIB ERROR SUMMARY$)
          EQ     PRTSUM       RETURN
*
*  MISC. DATA CELLS
*
PRTJMP    RJ     PRTSUM       JUMP TO PRINT SUMMARY
D00PR1    VFD    1/1,1/0,1/1,1/0,1/0,31/13,18/PLTMES+1,6/0
D00PR2    VFD    1/1,1/1,1/0,1/0,1/0,7/0,12/0,12/0,18/0,6/0
ARG1      VFD    60/FTNO      ARGUEMENT LIST FOR
          VFD    60/FTFLAG    -NON FATAL MESSAGE TABLE OVERFLOW-
          DATA   0
FTNO      CON    1
FTFLAG    CON    1HF
***** PAR CHANGED FROM EXTERNAL TO INTERNAL FOR FTN4.5 OCTOBER 1975
 PAR      BSSZ   1
          END
