*DECK AEISER
      SUBROUTINE AEISER (FORMAT, VALUE, PRFLAG)
      IMPLICIT INTEGER (A-Z)
C*  AEISER
C
C   TITLE
C     ROUTINE TO ISSUE ERROR MESSAGE FOR COMPASS PROGRAMS.
C
C   ENTRY
C     FIELDS IN CALLING SEQUENCE -
C       FORMAT - FORMAT STATEMENT CONTAINING ERROR MESSAGE
C       VALUE  - OPTIONAL VALUE TO BE INSERTED INTO MESSAGE
C       PRFLAG - =0  - VALUE IS NOT USED.
C                 1  - VALUE SHOULD BE PRINTED
C     FIELDS IN COMMON BLOCK /AEERCM/ -
C       ROUTIN - NUMBER OF ROUTINE ISSUING ERROR
C       FLAG   - ERROR NUMBER
C
C   EXIT
C     ERROR MESSAGE HAS BEEN ISSUED
C  COMMON BLOCK. THIS MUST BE SET UP BY CALLING ROUTINE.
      COMMON /AEERCM/ ROUTIN, FLAG
C  DECLARE ALERPR LOGICAL
      LOGICAL ALERPR
*IF DEF,AELIB5
      INTEGER FORMAT(*)
*ENDIF
C  IF WE ARE NOT TO PRINT THIS MESSAGE, RETURN.
      IF (.NOT. ALERPR(ROUTIN, FLAG)) RETURN
C  PRINT ERROR MESSAGE.
*IF -DEF,AELIB5
      IF (PRFLAG.EQ.0) PRINT FORMAT
*ENDIF
*IF DEF,AELIB5
      IF (PRFLAG.EQ.0) PRINT FORMAT
*ENDIF
*IF -DEF,AELIB5
      IF (PRFLAG .NE. 0) PRINT FORMAT, VALUE
*ENDIF
*IF DEF,AELIB5
      IF (PRFLAG .NE. 0) PRINT FORMAT, VALUE
*ENDIF
C  PRINT A TRACEBACK
      CALL TRACEB(0)
      RETURN
      END
