*COMDECK AELERREXT
      SUBROUTINE AELERR(N,FLAG)
C
C   THIS SUBROUTINE REPLACES THE AELIB ERROR MESSAGE HANDLING ROUTINE
C   FOR AELIB ROUTINES THAT ARE TO BE USED ON SYSTEMS OTHER
C   THAN CRNL"S NOS/BE.
C   (THE NOS/BE VERSION OF AELERR RETRIEVES ERROR MESSAGES FROM A SYSTEM
C   TEXT AND PRINTS THEM WITH TRACEBACK BY CALLING THE ROUTINE SYSTEM.)
C
C   THIS ROUTINE WRITES THE ERROR NUMBER TO OUTPUT IN THE
C   FOLLOWING FORMAT -
C        ***AELIB ERROR MESSAGE NUMBER XXXX
C
C   CHECK THE ACCOMPANYING LISTING OF AELERTX FOR TEXT OF MESSAGES.
C
C   ON THE CRNL SYSTEM, NON-FATAL ERRORS (I.E. FLAG=2HNF) ALLOW THE JOB
C   TO CONTINUE ON THE NOS/BE SYSTEM.  FATAL ERRORS (IE. FLAG=2HF )
C   ALLOW THE JOB TO ABORT.
C   TO DO THE SAME ON ANOTHER SYSTEM, SUPPLY A SUBROUTINE CALLED
C   ABORT AND ACTIVATE STATEMENT LABELLED 99 IN AELERR.
C
C        WRITTEN BY B. PURCELL
C        REVISED BY L. EVANS           1978 SEPTEMBER
C
C   REVISED BY  L.E. EVANS / G.L. KLAWITTER      1982  JULY
C        TO MODIFY EXTERNAL VERSION TO USE PRINT STATEMENTS
C        TO INVOKE THIS VERSION FOR NOS AELIB.
C
C
C
      INTEGER FLAG
      DATA IFLAG/1HF/
 2    FORMAT(31H ***AELIB ERROR MESSAGE NUMBER ,I4)
      PRINT 2,N
C99   IF(FLAG.EQ.IFLAG) CALL ABORT
      RETURN
      END
