*DECK CHNGSCM
          IDENT CHNGSCM
          ENTRY CHNGSCM
          EXT    AELERR      AELIB ERROR ROUTINE
*
*  COMMON BLOCK FOR ERROR MESSAGE INSERTIONS FROM COMPASS
*
          USE    /AELERCM/
IERWD     BSS    15
          USE    *
**
*                    FTN   CALL CHNGSCM(FL)
*
*  THIS ROUTINE IS DESIGNED FOR USE BY PROGRAMS WRITTEN IN FTN.
*  IT CHANGES THE SCM OF THE JOB TO FL
*
*  ENTRY-  FL=REQUESTED SCM
*
*  EXIT-   THE FIELD LEGNTH HAS BEEN SET TO THE REQUESTED AMOUNT AND
*          RA+65 ADJUSTED TO REFLECT THIS CHANGE.
*
*  ERROR EXIT-    IF FL IS REAL, NEG., TOO LARGE (>377777B) OR < LWA OF
          SST
          LIST   F
*                 "CHNGSCM" THE RTN. EXITS WITH A FATAL ERROR VIA THE
*                 AELIB ERROR RTN. "AELERR" (20 CHAR. OCTAL
*                 REPRESENTATION OF FL IS PASSED THRU. /AELERCM/)
*
*  CALLS-  AELERR, LIBSTAT
*          AELERR, LIBSTAT
*
*
*       -  W A R N I N G  -
*
*  THIS ROUTINE IS CONSISTENT WITH FORSYS= AND SEGRES AS OF JUNE 6,1975
*
*
*    INTERACTION WITH FORSYS= HAS BEEN TEMP DELETED.
          USE     *
TRACE     VFD    42/0HCHNGSCM,18/CHNGSCM
          BSS    1
*
+         SA5      TRACE+1
          SA0      X5
CHNGSCM   PS
          SX6    A0
          SA6    TRACE+1     SAVE A0
*CALL STATC
          SA1 X1        X1=FL
*                            CHECK FL PARAM., ERROR IF:
*                         1. REAL, NEG OR TOO LARGE (GT 377777B)
          MX6    43
          BX5    X1*X6       MASK OFF UPPER 43 BITS
          NZ     X5,PERR     IF NOT ZERO...ERROR
*                            (NEG, REAL OR TOO LARGE)
*                         2. FL DOES NOT INCLUDE THIS ROUTINE
          SA5    ENDLBL
          SB1    X1
          SB1    A5-B1
          PL     B1,PERR      IF POSITIVE - ERROR
*
*  RESET RA+65
          SA2    RA.LWP       FETCH RA+65
          MX6    -18
          BX6    X6*X2        CLEAR OUT OLD FIELD LENGTH
          BX6    X6+X1        ADD IN NEW FIELD LENGTH
          SA6    A2           RESTORE RA+65
*
*  CALL MEM TO RESET FIELD LENGTH
          SX6    X1+77B
          MX1    -6
          BX6    X1*X6
          LX6    30
          SA6    MEMSTAT
          MEMORY CM,MEMSTAT,RECALL
          EQ     CHNGSCM-1
PERR      MX3    -3
          BX3    -X3         FORM A 3 BIT MASK IN LOW ORDER BITS
          SX4    33B         BASE FOR DISPLAY CODE CONVERSION
          SB1    1
          SB2    2           COMMON BLCK BIAS
          SB3    2           OUTER LOOP (STRT1) COUNTER
STRT1     SB4    10          INNER LOOP (STRT2) COUNTER
          MX6    0           CLEAR X6
STRT2     LX1    3           SHIFT LEFT 1 OCTAL CHAR.
          BX5    X1*X3       MASK 3 BITS FROM FL
          IX5    X5+X4       CONVERT TO DISPLAY CODE
          LX6    6           SHIFT LEFT 1 DISPLAY CODE CHAR.
          BX6    X6+X5       .OR. THIS CHAR. INTO X6
          SB4    B4-B1       DECREMENT LOOP CNTR.
END2      NZ     B4,STRT2
          SA6    IERWD+B2    X6 FILLED, TRANSFER TO COMMON BLCK
          SB2    B2+B1       INCREMENT COMMON BLCK BIAS
          SB3    B3-B1       DECREMENT LOOP CNTR.
END1      NZ     B3,STRT1
          MX6    0           THE ERROR RTN. REQ. THAT THIS STRING BE
          SA6    IERWD+B2    TERMINATED BY A ZERO BYTE
*
          SA1    LIST
+         RJ     AELERR
-         VFD    12/0,18/TRACE
*
*                            AELERR PARAMETERS
ERR       DATA   3930                  ERROR NUMBER
FLAG      VFD    60/10HF               FATAL ERROR FLAG
*                            AELERR PARAMETERS LIST
LIST      VFD    42/0,18/ERR
          VFD    42/0,18/FLAG
          VFD    60/0
*
MEMSTAT   DATA   0           FOR MEMORY REQUEST
ENDLBL    END
