*DECK FLPT
      FUNCTION FLPT(I)
C
C     I-INTEGER
C
C
C     THIS FUNCTION RETURNS VALUES FOR THE FOLLOWING:
C     FOR I= 1-LARGEST FLOATING POINT NUMBER
C            2-SMALLEST POSITIVE NORMALIZED FLOATING POINT NUMBER
C            3-SMALLEST POSITIVE FLOATING POINT NUMBER, WHICH WILL
C              SIGNIFICANTLY ADD TO 1.0
C            4-LARGEST POSITIVE INTEGER SUCH THAT ALL POSITIVE INTEGERS
C              LESS THAN OR EQUAL TO IT CAN BE CONVERTED EXACTLY TO A
C              FLOATING POINT NUMBER.
C
C     PROGRAMMED BY B.E.PURCELL                            JAN.1978
C
C
      DIMENSION VALUE(4)
*IF -DEF,AELIB5
      DATA VALUE/37767777777777777777B,00014000000000000000B,
     ,         16404000000000000000B,20007777777777777777B/
*ENDIF
*IF DEF,AELIB5
      DATA VALUE/O"37767777777777777777",O"00014000000000000000",
     ,           O"16404000000000000000",O"20007777777777777777"/
*ENDIF
      DATA MES/50/
*CALL STATF
*IF -DEF,AELIB5
      IF(I.LT.0 .O. I.GT.4) GO TO 10
*ENDIF
*IF DEF,AELIB5
      IF(I.LT.0 .OR.I.GT.4) GO TO 10
*ENDIF
      FLPT=VALUE(I)
      RETURN
*IF -DEF,AELIB5
  10  CALL AELERR(MES,2HNF)
*ENDIF
*IF DEF,AELIB5
  10  CALL AELERR(MES,'NF')
*ENDIF
      RETURN
      END
