*DECK IGETCCL
      FUNCTION IGETCCL(RGNAME)
C
C FORTRAN CALLABLE ROUTINE TO READ THE VALUES OF CCL REGISTERS.
C
C IVAL = IGETCCL(RGNAME)
C
C PARAMETERS -
C    RGNAME   INTEGER INPUT VARIABLE, SPECIFIES THE REGISTER NAME.
C             IT MUST BE ONE OF THE SET 2LR1, 2LR2, 2LR3, 3LR1G.
C
C    IVAL     INTEGER OUTPUT VARIABLE, IN WHICH THE VALUE READ FROM
C             THE SPECIFIED REGISTER IS STORED.  THE RANGE OF VALUES IS:
C
C                            0 @ IABS(IVAL) @ 131071 (I.E. 377777B)
C
C ERROR CHECKING -
C    IF RGNAME IS NOT ONE OF THE ABOVE SET, TRACEBACK INFORMATION WILL
C    BE WRITTEN TO THE OUTPUT FILE AND THE JOB ABORTED.
C
C THIS ROUTINE CALLS GETCCL WHICH IS AN ENTRY POINT IN THE AELIB
C SUBROUTINE SETCCL.
C
C CODED BY EA OKAZAKI   1979 OCTOBER
C
C
      IMPLICIT INTEGER (A-Z)
C
*CALL STATF
C
      CALL GETCCL(RGNAME,IVAL)
      IGETCCL=IVAL
      RETURN
C
      END
