*DECK PLOT
          IDENT  PLOTF
          SPACE  2
*     THIS PROGRAM CONTAINS THE MAIN ENTRY POINT FOR PLOT.
*     THIS IS BECAUSE SYMPL CAN NOT PROVIDE TRACE BACK INFO.
*     IT ALSO CONTAINS A NUMBER OF SUBROUTINES USED BY PLOT -
*         PT$FIND - CALL GETFIT. TO LOCATE THE FIT FOR PLOT
*         PT$ISSU - CALL SYS= TO ISSUE A MONITOR CALL.
*         PT$ENCD - CALL ENCODI. TO ENCODE PLOT 3 OR PLOT 5 DATA.
*         PT$ERR  - CALL AELERR  TO ISSUE A PLOT ERROR MESSAGE.
*         PT$CHEK - ISSUE CHECK MACRO
*         PT$OPEN  - ISSUE OPEN NOREWIND MACRO
*         PT$WEOR - ISSUE WEOR MACRO
*         PT$PUT - ISSUE PUT MACRO
*         PT$CLOS - ISSUE CLOSE NOREWIND MACRO
*          PLTFLG - SET LOG-LOG FLAG (USED BY LOG PLOT ROUTINES)
          SPACE  2
          USE    /PT$COMM/         COMMON BLOCK FOR PLOT DATA.
PLTPRMS   DATA   0            ADDRESS OF PLOT CONSTANTS ARRAY
PLOTFIT   DATA   0            ADDRESS OF PLOT FIT
LOGL      BSSZ   41           SCRATCH STORAGE FOR PLOT
XYLGFLG   DATA   0              LOG-LOG FLAG
STEPSS    DATA   0.0          STEPS PER UNIT - (USED BY PLOT MODE 1)
XX1       DATA   0
Y1        DATA   0
XX2       DATA   0
Y2        DATA   0
          USE    *
TRACE1.   DATA    0           TRACE BACK INFO. SET BY CALLED ROUTINE.
TEMPA0    DATA   0            TO SAVE A0.
TRPLOT    VFD    42/4HPLOT,18/PLOT      TRACE BACK INFO FOR PLOT.
TRPLOTM   VFD    42/5HPLOTM,18/PLOTM    TRACE BACK INFO FOR PLOTM.
          SPACE  2
          ENTRY  PLOT,PLOT$,PLOTC
PLOTC     BSS    0            ENTRY USED BY CALCOMP ROUTINES
PLOT$     BSS    0            ENTRY POINT USED BY COBOL.
PLOT      DATA   0            ENTRY POINT USED BY FORTRAN
          SX6    A0           SAVE A0
          SA3    TRPLOT
          SA6    TEMPA0
          SA2    =200.0
          BX6    X3
          LX7    X2
          SA6    TRACE1.      SET TRACE BACK INFO.
          SA7    STEPSS       SET STEPS PER INCH
+         RJ     =XPT$MAIN    EXECUTE MAIN PLOT SUBROUTINE
-         VFD    30/TRACE1.
          SA1    TEMPA0       RESTORE A0
          SA0    X1
          EQ     PLOT         RETURN
          SPACE  2
          ENTRY   PLOTM
*  PLOTM IS THE ENTRY POINT FOR METRIC PLOTTING.
PLOTM     DATA   0
          SX6    A0
          SA3    TRPLOTM
          SA6    TEMPA0       SAVE A0
          SA2    =7.874016
          BX6    X3
          LX7    X2
          SA6    TRACE1.      SET TRACE BACK INFO.
          SA7    STEPSS       SET STEPS PER MILLI-METRE.
+         RJ     =XPT$MAIN    EXECUTE MAIN PLOT SUBROUTINE
-         VFD    30/TRACE1.
          SA1    TEMPA0
          SA0    X1           RESTORE A0
          EQ     PLOTM        RETURN
          SPACE  2
*  FUNCTION PT$FIND.
*     NO FORMAL PARAMETERS
*     RETURNS ADDRESS OF PLOT FIT.
           ENTRY  PT$FIND
PT$FIND    DATA   0
           SX1    =4LPLOT
+           RJ    =XGETFIT.     FIND PLOT FIT ADDRESS
-           VFD   30/TRACE1.
            BX6   X1    ADDRESS OF PLOT FIT
            EQ    PT$FIND       RETURN
            SPACE  4,8
*    SUBROUTINE PT$ISSU (PPCALL)
*          CALL SYS= TO ISSUE A MONITOR CALL
*          PPCALL MUST BE A PROPERLY FORMATTED MONITOR CALL.
*
            ENTRY   PT$ISSU
PT$ISSU     DATA    0           ENTRY EXIT LINE
            SA1     X1          GET PPCALL
            BX6     X1
            RJ      =XSYS=      TO ISSUE PP CALL
            EQ      PT$ISSU     RETURN
            SPACE   4,8
*   SUBROUTINE PT$ERR(NUM)
*     CALL AELERR TO ISSUE ERROR MESSAGE. THIS ROUTINE IS PUT HERE
*  TO PROVIDE TRACE BACK.
*
*
            ENTRY  PT$ERR
PT$ERR      DATA   0
          SX6    X1           ADDRESS OF NUM
          SA6    ARG2
          SA1    A6           ARGUMENT LIST
+         RJ     =XAELERR     ISSUE MESSAGE
-         VFD    30/TRACE1.
          EQ     PLOT    RETURN
*
ARG2      DATA   0            ARGUMENT LIST - ADDRESS OF NUM
          VFD    60/ERRN
          VFD    60/0
ERRN      CON    1HF          ALL PLOT ERRORS ARE FATAL.
          SPACE  2
*    PT$CHEK - ISSUE CHECK MACRO.
          ENTRY  PT$CHEK
PT$CHEK   DATA   0
          SA1    PLOTFIT      FIT ADDRESS
          CHECK     X1        WAIT UNTIL ACTION ON FILE CEASES
          EQ     PT$CHEK
          SPACE  2
*   PT$OPEN - ISSUE OPENM (NOREWIND) MACRO
*
          ENTRY  PT$OPEN
PT$OPEN   DATA   0
          SA1    PLOTFIT      ADDRESS OF FIT
          OPENM  X1,OUTPUT,N           OPEN FILE FOR PROCESSING
          EQ     PT$OPEN
          SPACE  2
*PT
*     PT$WEOR - ISSUE WEOR MACRO
*
          ENTRY  PT$WEOR
PT$WEOR   DATA   0
          SA1    PLOTFIT      ADDRESS OF FIT
          WEOR   X1           WRITE END OF SECTION.
          EQ     PT$WEOR
          SPACE  2
*     PT$PUT (SIZ)  - ISSUE PUT MACRO
*         SIZ = NUMBER OF CHARACTERS IN RECORD.
          ENTRY  PT$PUT
PT$PUT    DATA   0
          SA1    X1           SIZ
          SA2    PLOTFIT      ADDRESS OF FIT
          PUT    X2,LOGL,X1
          EQ     PT$PUT
          SPACE  2
*     PT$CLOS - CLOSE PLOT FILE
*
          ENTRY  PT$CLOS
PT$CLOS   DATA   0
          SA1    PLOTFIT      ADDRESS OF FIT
          CLOSEM X1,N,FILE
          EQ     PT$CLOS
        SPACE    4
          ENTRY  CMM$ALF
                              THIS FUNCTION ALLOCATES SPACES FOR A FIXED
                              POSITION BLOCK, WITH A GIVEN SIZE-CODE,
                              WITHIN A GIVEN GROUP, AND RETURNS ITS
                              FIRST-WORD-ADDRESS.
                              CALLING SEQUENCE IS
                                <BLOCK-FWA> = CMM$ALF(<BLOCK-SIZE>,
                                                      <SIZE-CODE>,
                                                      <GROUP-ID>);
CMM$ALF   DATA   0
          SA2    X1           X2 = BLOCK-SIZE
          SA3    A1+1
          SA3    X3           X3 = SIZE-CODE
          LX3    6            SIZE-CODE IN BITS 11-6
          SA4    A1+2
          SA4    X4           X4 = GROUP-ID
          LX4    12           GROUP-ID IN BITS 28-12
          BX3    X3+X4        MERGE SIZE-CODE AND GROUP-ID IN X3
          RJ     =XCMM.ALF
          BX6    X1           CMM RETURNS BLOCK POINTER IN X1
          EQ     CMM$ALF
          SPACE  2,8
          ENTRY  CMM$FRF
                             THIS PROCEDURE FREES A FIXED-POSITION BLOCK
                              WHOSE FIRST-WORD-ADDRESS IS GIVEN
                              CALLING SEQUENCE IS
                                 CALL CMM$FRF(P<ARRAY>);
CMM$FRF   DATA   0
          SA1    X1
          SX1    X1           ISOLATE BUFFER ADDRESS
          RJ     =XCMM.FRF
          EQ     CMM$FRF
           SPACE   2,8
          ENTRY  PT$IOER
                              PROCESS CRM ERRORS FOR PLOT FILES.
                              THIS ROUTENE CALLS THE CRM ERROR PROCESSOR
                              FOR FORTRAN (IN FORSYS)
PT$IOER   DATA   0
          SA1    PT$IOER
          BX6    X1           MAKE IT APPEAR AS IF FTN ERROR PROCESSOR
          SA6    =XIOERR.     WAS CALLED FROM CRM DIRECTLY
          JP     =XIOERR.+1   THIS ROUTENE PROBABLY WILL NOT RETURN.
          SPACE  2,8
*      PT$MOVE (SOURCEC, DESTC, LENGTH)
*               CHARACTER MOVE SUBROUTINE
*         SOURCEC  - BEGINNING CHARACTER POSITION OF SOURCE
*                    (STARTING AT 0)
*         DESTC    - BEGINNING CHARACTER POSITION OF DESTINATION
*         LENGTH   - NUMBER OF CHARACTERS TO BE MOVED.
*
*   PARAMETERS ASSUMED -
*        SOURCEW - ADDRESS OF START OF SOURCE      = LOGL+1
*        DESTW   - ADDRESS OF START OF DESTINATION = LOGL+1
*
*    THIS SUBROUTINE LOADS ALL THE PARAMETERS INTO REGISTERS THEN
*    CALLS -MOVE.RM- TO DO THE DIRTY WORK.
          ENTRY  PT$MOVE
PT$MOVE   DATA   0
          SB1    1              REQUIRED BY MOVE.RM
*    FETCH FORMAL PARAMETERS
          SA2    A1+B1          DEST BYTE ADDRESS
          SA3    A2+B1          LENGTH
          SA1    X1             SOURCE BYTE
          SA2    X2             DEST BYTE
          SA3    X3             LENGTH
*     LOAD REGISTERS AS REQUIRED BY -MOVE.RM-
          SB3    X1             SOURCE BYTE
          SB5    X2             DEST BYTE
          SB4    X3             LENGTH
          SX5    LOGL+1       DESTINATION ADDRESS
          SX3    LOGL+1       SOURCE ADDRESS
          SB6    PT$MOVE        RETURN ADDREFSS
          EQ     =XMOVE$RM    GO MOVE CHARACTER
          SPACE  2
*   FORTRAN SUBROUTINE PLTFLG (N) - SET LOG-LOG FLAG TO N.
*      N=1 - LOG ON X AXIS ONLY
*       2 - LOG ON Y AXIS ONLY
*       3 - LOG ON BOTH AXES.
*
          ENTRY PLTFLG
PLTFLG    DATA   0
          SA1    X1                     GET PARAMETER
          BX6    X1
          SA6    XYLGFLG        STORE IN PLOT COMMON
          EQ     PLTFLG                 RETURN
            END
      SUBROUTINE PTDENCD (FORM, RECP, N, ARR)
      DIMENSION ARR(N)
*IF -DEF,AELIB5
      INTEGER FORM, RECP(40)
*ENDIF
*IF DEF,AELIB5
      INTEGER  FORM(*), RECP(40)
*ENDIF
C   SUBROUTINE PTDENCD
C      CALL ENCODE TO CONVERT DATA TO DISPLAY CODE
C
C   ENTRY
C      CALL PTDENCD (FORM, RECP, N, ARR)
C        WHERE
C          FORM = FORMAT
C          RECP = ARRAY IN WHICH CODED DATA IS TO BE STORED
C          N = NUMBER OF ELEMENTS IN ARRAY ARR
C          ARR = USER SUPPLIED ARRAY
C
C   EXIT
C     FORMAT IS ENCODED INTO LOGL
      IF (N .EQ. 0) GO TO 100
          ENCODE(136, FORM, RECP) ARR
        RETURN
100       ENCODE(136, FORM, RECP)
      END
*CWEOR
      PROC PT$MAIN ((MODEX), P1, P2, P3, P4, P5, P6, P7, P8, P9, P10);
   BEGIN
#    ENSURE FORTRAN COMPATABILITY#
      CONTROL FTNCALL;
      CONTROL TRACEBACK;
      ITEM MODEX I;
      ITEM P1 R, P2 R, P3 R, P4 R, P5 R, P6 R, P7 R, P8 R;
      ITEM P10 R, P9 R;
  #
    PLOT  IS A SUBROUTINE WHICH MAY BE CALLED WITH A VARIABLE NUMBER
       OF PARAMETERS, TO ALLOW PLOTTER OUTPUT FROM THE CDC 6600.
     PLOT MODES 10, 11 CODE ADDED DEC 1978.
       CLIPPING CODE WRITTEN BY J WENDORF, ADAPTED BY C TANNER.
        REVISED 80-10 FOR FTN5
        IF PLOT IS NOT DEFINED ON THE PROGRAM CARD, THEN NOTHING WILL
      EXIST FOR THE FILE PLOT ON THE FIRST CALL TO PLOT.  IN FTN5, WHEN
       PLOT IS SPECIFIED ON THE PROGRAM CARD, ONLY A FIT IS CREATED. NO
       BUFFER IS ALLOCATED.
        IF GETFIT CANNOT FIND THE FIT FOR PLOT, THEN REQUEST 35 WORDS
       FROM CMM  FOR THE PLOT FIT. IF NO BUFFER HAS BEEN ALLOCATED,
       REQUEST 2000 WORDS FROM CMM FOR THE PLOT BUFFER.
                                                                  #
      BASED ARRAY PDECODE ;        # USED IN CRACKING PARAMETERS. #
      BEGIN
         ITEM EXPON I (0,0,12) ;   # EXPONENT #
         ITEM PINT I (0,0,60) ;    # INTEGER VARIABLE #
         ITEM PREAL R (0,0,60) ;    # REAL VARIABLE#
      END
      BASED ARRAY XPTS ;   ITEM XPOINT R;    #  ARRAYS CONTAINING X-Y #
      BASED ARRAY YPTS ;   ITEM YPOINT R;    # PAIRS TO BE PLOTTED    #
      COMMON PT$COMM;    BEGIN          #COMMON BLOCK FOR PLOT DATA#
      BASED ARRAY PLTPRMS ;      # ARRAY CONTAINING PARAMETERS SAVED  #
        BEGIN                    # BETWEEN PLOT CALLS AT BEGINNING OF #
          ITEM SCALE R (0,0,60);       # PLOT BUFFER #
          ITEM XD R(2,0,60),    # ** PLOT MODE 1  PARMETERS**  #
               YD R(3,0,60),    # DRAWING AREA #
               X0 R(4,0,60),    # COORDS OF THIS FRAME #
               Y0 R(5,0,60),
               XL R(6,0,60),    #SIZE OF THIS FRAME #
               YL R(7,0,60),
               XMIN R(8,0,60),  #RANGE OF USER COORDINATES #
               YMIN R(9,0,60),
               XMAX R(10,0,60),
               YMAX R(11,0,60),
               TICX R(12,0,60), #TICK FLAGS #
               TICY R(13,0,60),
      # END OF PLOT MODE 1 PARAMETERS #
               STEPSSS   R(16,0,60),   #STEPS PER UNIT #
               FRAMECOUNT I(17,0,60),  #NO OF FRAMES DRAWN #
#       FOLLOWING FIELDS CONTAIN VALUES IN PLOT STEPS WITH RESPECT
        TO THE ORIGIN OF THE DRAWING AREA       #
               XKMIN R(18,0,60),
               YKMIN R(19,0,60),
               XKMAX R(20,0,60),    # BOUNDARY FOR CLIPPING #
               YKMAX  R(21,0,60),
               XLENGTH R(22,0,60),  # DRAWING AREA BOUNDARY #
               YLENGTH R(23,0,60),
               XPOS R(14,0,60),         #CURRENT PEN POSITION #
               YPOS R(15,0,60),
               X0P R(24,0,60),          #ORIGIN OF CURRENT FRAME#
               Y0P R(25,0,60);
          ITEM PLOTBUFF B(26,0,01);     #TRUE IF BUFFER FROM CMM#
        END
      BASED ARRAY PLOTFIT ;        # FIT FOR PLOT FILE #
        BEGIN
          ITEM PLOTLFN  U(00,00,42),   #LOGICAL FILE NAME#
               PLOTOC   U(17,01,02),    #OPEN/CLOSE FLAG#
               PLOTRT   U(11,32,04),    #RECORD TYPE#
               PLOTBT   U(11,36,03),    #BLOCK TYPE#
               PLOTBFS  U(17,42,18),    #CIRCULAR BUFFER SIZE#
               PLOTFWB  U(01,42,18);    #FWA CIRCULAR BUFFER)#
          ITEM PLOTWORD U(00,00,60),    #USED TO CLEAR FIT#
               PLOTEX   I(13,42,18),    #ERROR EXIT ADDRESS#
               PLOTLFNC C(00,00,07);    #PLOT LFN IN CHARS#
        END
      ARRAY LOGL [40] ;       # ARRAY FOR TEMP STORAGE FOR PLOT DATA. #
      BEGIN
          ITEM LOGLWORD (0,0,60);
          ITEM LITX (0,30,30);
          ITEM LOGXD (0,30,16),
               LOGYD (0,46,14),
               LOGXL (0,0,16),
               LOGYL (0,16,14);
          ITEM LOGMOD (0,0,6);
          ITEM LOGUPH (0,0,30);
          ITEM LOGTIME (0,6,12);
          ITEM LOGLWH (0,30,30);
          ITEM LOGPEN (0,6,6);
          ITEM LOGSYMB (0,12,6);
          ITEM LOGNCHR (0,18,12);
          ITEM LOG5MD (0,30,12);
      END
      ARRAY XYSIG [0] S(1);   #FLAGS FOR LOG LOG PLOTS#
        BEGIN
         ITEM  XYFLGWORD (0,0,60);
          ITEM XLOGFLG (0,59,1);    #ON IF X LOG PLOT#
          ITEM YLOGFLG (0,58,1);     #ON IF Y LOG PLOT#
        END
      ITEM SETSTEPS R;        # STEPS PER UNIT, SET BY PLOTE OR PLOTM#
        ITEM X1 R;      #X,Y CORDS OF START AND OF CURRENT LINE#
        ITEM Y1 R;
        ITEM X2 R;
        ITEM Y2 R;
      END
*CALL ERRORS
      COMMON AELERCM;
          BEGIN     # COMMON BLOCK FOR AELIB ERROR MESSAGE #
      ARRAY AELMSG [1:AELENGTH];   BEGIN
          ITEM AERROR C(0,0,7);
          ITEM AENDX   (0,48,12);
        END
      END
      ARRAY PLTDSP[0] S(2);
        BEGIN                 #ARRAY FOR DSP PARAMETERS#
          ITEM DSPCMP (0,0,60) = [0];        #COMPLETION BIT#
          ITEM DSPLFN (1,0,42) = [O"20141724000000"];
          ITEM DSPDC (1,48,12);    #DISPOSITION CODE#
          ITEM DSPMC (1,47,1) = [1];        #MACRO CALL BIT#
          ITEM DSPEOJ (1,44,1);    # EOJ BIT #
          ITEM DSPROT (1,45,2) = [0];    #ROUTING BITS - NOT USED YET#
      END
      ARRAY PPCALL [0];      #  ARRAY FOR CALL TO PP PROGRAM#
      BEGIN
         ITEM PPNAME C(0,0,3);
         ITEM PPRCL  (0,18,6) = [O"20"];
         ITEM PPRAM2 (0,24,18) = [0];
         ITEM PPRAM1 (0,42,18);
     END
*IF -DEF,NOS
      XREF ARRAY PT$TIME[0] S(2);
*ENDIF
*IF DEF,NOS
       ARRAY PT$TIME [0] S(2);
*ENDIF
        BEGIN                          #AND PLT CALL#
          ITEM TIME R(0,0,60);         #ESTIMATED PLOT TIME#
          ITEM PLTPARM U(1,0,60);      #PLT CALL WORD#
          ITEM PLTIME U(1,0,12);       #TIME LIMIT IN MIN*8#
          ITEM PLTFRAME U(1,12,12);    #FRAME COUNT#
          ITEM PLTFET U(1,24,24);      #FET ADDRESS#
          ITEM PLTERR U(1,48,11);      #PLT ERROR CODE#
          ITEM PLTCMP U(1,59,1);       #COMPLETION BIT#
        END
   #    MISCELLANOUS STORAGE CELLS #
       ARRAY WIDEDSPX [1];       # DSP PARAMETERS FOR WIDE PLOT#
          ITEM WIDEDSP (0,0,60) = [0,O"20141724000000112027"];
      ARRAY SCRDSPX [1];     # DSP PARAMETERS FOR EVICT PLOT FILE#
          ITEM SCRDSP (0,0,60) = [0,O"20141724000000012303"];
      ITEM CW R;        #LENGTH OF A CHARACTER - MODE 3#
      ITEM DIRCT I;     #DIRECTION INDEX (MODE 3)#
      ITEM DRWSYMB R;   #TIME TO DRAW A SYMBOL - MODE 2#
      ITEM I;           #GENERAL INDEX#
      ITEM IFINISH;     #END OF LOOP - MODE 2#
      ITEM ISTART;      #START OF LOOP - MODE 2#
      ITEM ISTEP;       #INCREMENT OF LOOP - MODE2#
      ITEM ITEMP1 I;    #GENERAL PURPOSE INTEGER#
      ITEM J;           #GENERAL INDEX#
      ITEM FLAG;        #USED IN CALL TO KLIP#
      ITEM K;           #GENERAL INDEX, #
      ITEM MODE;        #INTERNAL STORAGE FOR MODE#
      ITEM N;           #NUMBER OF POINTS ETC, MODE 2 + 3#
      ITEM NCH I;       #NUMBER OF CHARACTERS TRANSMITTED-MODE 3#
      ITEM NPAR I;      #NUMBER OF PARAMETERS IN PLOT CALL#
      ITEM NSKP I;      #NUMBER OF CHARACTERS SKIPPED - MODE 3#
      ITEM OUT B;       #TRUE IF LAST LINE ENDED INSIDE CLIPPING AREA#
                        #MODE 2#
      ITEM PENN;        #PEN INDICATOR - MODE 2#
      ITEM SW R;        #STRING LENGTH - MODE 3#
      ITEM TEMP1 R;     #GENERAL PURPOSE REAL#
      ITEM TMPA R;      #GP FIELD USED FOR TIME CALCULATION#
      ITEM TMPB R;
      ITEM TEMPBUFF B;  #HOLDS CMM BUFFER FLAG TEMPORARILY#
      ITEM XBOUND R;    #COORDS OF WHERE LINE CROSSES BOUNDARY#
      ITEM X1ORIG R;    #COORDS OF START OF LINE BEFORE CLIPPING#
      ITEM X2ORIG R;    #COORDS OF END OF LINE BEFORE CLIPPING#
      ITEM YBOUND R;    #MODE 2#
      ITEM Y1ORIG R;    #MODE 3#
      ITEM Y2ORIG R;    #USED IN MODE 2#
*CALL PLOTDEFS
      XREF BEGIN              # LIST OF EXTERNAL SUBROUTINES#
  #   SUBROUTINES IN COMPASS PART OF PLOT#
        FUNC CMM$ALF U;         #ALLOCATE A FIXED POSITION BLOCK#
        PROC CMM$FRF;           #FREE A FIXED POSITION BLOCK#
        PROC PT$CHEK;   #WAIT FOR CRM ACTIVITY TO CEASE#
        PROC PT$CLOS;   #CLOSE PLOT FILE#
         PROC PTDENCD;     #CALL ENCODE IN FTN LIBRARY#
        PROC PT$ERR;    #ISSUE ERROR MESSAGE AND QUIT#
        FUNC PT$FIND;   #LOCATE ADDRESS OF PLOT FIT#
        PROC PT$ISSU;   #CALL A PP PROGRAM#
        PROC PT$MOVE;   #MOVE CHARACTERS#
        PROC PT$OPEN;   #OPEN PLOT FILE#
        PROC PT$PUT;    #WRITE PLOT RECORD#
        PROC PT$WEOR;   #WRITE END OF SECTION(RECORD)#
#  CALLS TO OTHER ROUTINES#
        FUNC ALOG10 R;  #IN FORTRAN LIBRARY#
        PROC PT$IOERR;          #FTN PROCESSOR FOR CRM ERRORS#
        FUNC LEGVAR I;  #CHECK FOR LEGAL VARIABLE (ON FORTRAN LIB)#
        PROC PT$KLIP;   #PERFORMS CLIPPING FOR PLOT#
        PROC PT$TERM;   #TERMINATE PLOT FILE. PART OF PLOT BUT ON#
                        #FORTRAN LIBRARY#
        FUNC SQRT R;    #ON FORTRAN LIBRARY#
        END
#  PLOT ERROR MESSAGES#
      DEF BADMODE#3500#;        #MODE NOT 1,2,3,4,5,6 OR 7#
      DEF NOMODE1#3501#;        #NO MODE 1 BEFORE MODE 2,3,4 OR 5#
      DEF BADXAXIS#3502#;       #X AXIS NOT BETWEEN 0 AND 160 INCHES#
      DEF BADYAXIS#3503#;       #YAXIS NOT BETWEEN 0 AND 28.4 INCHES#
      DEF MAXEQMIN#3504#;       #X OR Y AXIS, MAX = MIN#
      DEF ZERON#3505#;          #ZERO NUMBER OF X,Y PAIRS#
      DEF BLANKMSG#3506#;       #BLANK MESSAGE #
      DEF ILLPARMS#3507#;       #ILLEGAL NUMBER OF PARAMETERS#
      DEF BADDISP#3508#;        #BAD DISPOSITION CODE#
      DEF EMPTYFIL#3509#;       #ATTEMPT TO RELEASE EMPTY FILE#
      DEF DSPERROR#3510#;       #ERROR IN DISPOSE CALL#
      DEF BADSCALE#3511#;       #BADLY SCALED PLOT#
      DEF ILLVARIABLE#3512#;    #ILLEGAL VARIABLE IN FORMAL PARAMETER#
      DEF MIXCALL#3513#;      #CAN ONLY CHANGE DEM. SYSTEMS ON MODE 1#
      DEF PLTCOMP#3514#;      #ERROR IN ATTEMPT TO SET PLOT TIME #
#
   DEFS TO MAKE CALLS TO SUBROUTINES NEATER#
      DEF CHEK#PT$CHEK#;
      DEF CLOS#PT$CLOS#;
      DEF  ENCD#PTDENCD#;
      DEF ERR#PT$ERR#;
      DEF FIND#PT$FIND#;
      DEF ISSU#PT$ISSU#;
      DEF KLIP#PT$KLIP#;
      DEF MOVE#PT$MOVE#;
      DEF OPEN#PT$OPEN#;
      DEF PUT#PT$PUT#;
      DEF TERMM#PT$TERM#;
      DEF WEOR#PT$WEOR#;
#
    DEFS TO MAKE CODE EASIER TO READ ( I HOPE)  #
      DEF XCALL# #;     #CALL TO EXTERNAL PROCEDURE#
      DEF ICALL# #;     #CALL TO INTERNAL PROCEDURE#
#
    DEFINE ORIGIN OF DRAWING AREA. ALL COORDINATES THAT ARE GIVEN IN
    INCHES OR MM, ARE ASSUMED TO BE RELATIVE TO THIS ORIGIN     #
      DEF  XORIGIN#400#;        #= 2.0 INCHES#
      DEF  YORIGIN#100#;        #= 0.5 INCHES#
#
  DEFINE MAXIMUM SIZE OF PLOTTING AREA#
      DEF  XDMAX#32600#;        #=163 IN. OR 4140.2 MM#
      DEF  YDNMAX#2135#;        #NARROW  = 10.675 IN. OR 271.145 MM#
      DEF  YDWMAX#5735#;        #WIDE    = 28.675 IN. OR 728.345 MM#
#
  DEFINE  SPACE PROVIDED ON RIGHT EDGE OF PLOT (FOR PLOT MODE 1) #
      DEF  XRBOUND#200#;        # = 1 INCH#
      CONTROL EJECT;
#    MISCELLANOUS SUBROUTINES       #
      #  LEGCHK (VARIABLE, NAME)   CHECK FOR LEGAL VARIABLE
          CALLS LEGVAR TO CHECK VARIABLE FOR LEGALITY. IF ILLEGAL,
          ISSUES ERROR MESSAGE-"NAME" IS ILLEGAL
          ENTRY -
            VARIABLE - FIELD TO BE CHECKED FOR LEGALITY
            NAME     - NAME OF FIELD
          EXIT -
            WILL NOT RETURN IF PARAMETER ILLEGAL
                                                                 #
      PROC LEGCHK ((AA),(NAME));
        BEGIN
          ITEM AA, NAME C(7);
          IF LEGVAR (AA) NQ 0 THEN
            BEGIN                  # ILLEGAL VARIABLE DETECTED #
              AERROR [3] = NAME;   # ISSUE ERROR MESSAGE #
              XCALL ERR (ILLVARIABLE);
            END
          RETURN;
        END
   #  RCONV (VARIABLE, NAME)       CONVERT VARIABLE TO REAL
          AFTER CALLING "LEGCHK" TO CHECK FOR LEGAL VARIABLE, THE
      EXPONENT OF "VARIABLE" IS CHECKED. IF THERE IS ONE, "VARIABLE" IS
      REAL AND NO CONVERSION IS MADE, OTHERWISE "VARIABLE" IS CONVERTED
      FROM INTEGER TO REAL.
          ENTRY -
            VARIABLE - FIELD CONTAINING VALUE TO BE CONVERTED
            NAME     - NAME OF FIELD (FOR LEGCHK)
          EXIT-
            RCONV -      REAL FORM OF VALUE.
          CALLS -
            LEGCHK
                                                                 #
      FUNC RCONV ((AA),(XX)) R;
      BEGIN
          ITEM AA, XX C(7);
          ICALL LEGCHK (AA, XX);
          P<PDECODE>=LOC(AA);
          IF EXPON[0] EQ 0 THEN
               RCONV = PINT[0];
          ELSE
               RCONV = PREAL[0];
          RETURN;
       END
#     ICONV (VARIABLE, NAME)       CONVERT VARIABLE TO INTEGER
          AFTER CALLING "LEGCHK" TO CHECK FOR LEGAL VARIABLE, THE
      EXPONENT OF "VARIABLE" IS CHECKED. IF THERE IS ONE, "VARIABLE" IS
      REAL AND IS CONVERTED TO INTEGER, OTHERWISE NO CONVERSION IS
      NECESSARY.
          ENTRY -
            VARIABLE - FIELD CONTAINING VALUE TO BE CONVERTED.
            NAME     -NAME OF FIELD (FOR LEGCHK)
          EXIT -
            ICONV    - INTEGER FORM OF VALUE
          CALLS -
            LEGCHK
                                                                 #
      FUNC ICONV ((AA), (XX)) I;
      BEGIN
          ITEM AA, XX C(7);
          ICALL LEGCHK (AA, XX);
          P<PDECODE>=LOC(AA);
          IF EXPON[0] EQ 0 THEN
               ICONV = PINT[0];
          ELSE
               ICONV = PREAL[0];
          RETURN;
       END
#
   ICALL DSPCALL(WORD)
         CALL DSP TO ROUTE A FILE
   ENTRY
     WORD IS THE 2 WORD PARAMETER LIST TO BE PASSED TO DSP. SEE
     SYSTEMS PROGRAMMMERS GUIDE FOR CONTENTS.
   EXIT
     NONE
   CALLS
     ISSU, CHEK
                        #
      PROC DSPCALL (PX);      #CALL DSP - PX CONTAINS 2 WORD PARAMETER#
      BEGIN                   #LIST TO BE PASSED TO DSP#
          ITEM PX;
          IF PLOTLFN[0] NQ "PLOT:::" THEN
               RETURN;        #ROUTE ONLY PLOT FILE#
          XCALL CHEK;   #WAIT UNTIL ACTION ON PLOT FILE CEASES#
          PPRAM1[0] = LOC(PX);
          PPNAME[0] = "DSP";     #SET UP CALL TO DSP#
          XCALL ISSU(PPCALL);   #CALL DSP TO ROUTE PLOT FILE#
          RETURN;
      END
#
    PLTCALL
        PROCEDURE TO CALL PLT TO SET PLOT TIME LIMIT.
    ENTRY
      TIME  - MUST ESTIMATED TIME TAKEN SINCE LAST PLTCALL.
      PLTFRAM - NUMBER OF FRAMES STARTED SINCE LAST PLTCALL.
    EXIT
      NONE
    CALLS
      ISSU, ERR
    METHOD
      ISSU IS USED TO CALL PLT. UPON COMPLETION, "TIME" AND "PLTFRAME"
      ARE SET TO ZERO IN PREPARATION FOR THE NEXT CALL. IF PLT
      REPORTS AN ERROR, THEN "ERR" IS CALLED TO TERMINATE EXECUTION.
                                        #
      PROC PLTCALL;           # CALL PLT.-PARAMETERS FOR PLT ARE IN #
      ITEM PLTEMP;
        BEGIN                 # PLTPARM.#
          PLTIME [0] = TIME [0]/7.5+.6;      #TIME IN MIN*8#
          PLTFET[0] = LOC(PLOTFIT);
          PPNAME[0] = "PLT";
          PPRAM1[0] = LOC(PT$TIME) + 1;      #ADDRESS OF PLT PARAMETERS#
*IF -DEF,NOS
          XCALL ISSU(PPCALL);   #PLT WILL PUT PLOT TIME ONTO FILE#
*ENDIF
#  CHECK PLT ERROR CODE FIELD.
     IF = 32B - DO NOT RESET PLOT TIME LIMIT FIELD.
     IF = 0  - NO ERRORS FOUND IN EXECUTION.
     OTHERWISE ISSUE ERROR MESSAGE.
  NOTE PLT WILL PUT AN ERROR MESSAGE INTO THE DAYFILE.  #
      IF PLTERR[0] EQ 0 THEN
           BEGIN
             TIME[0] = 0;
             PLTFRAME [0] = 0;
           END
      ELSE
      IF PLTERR[0] NQ O"37" THEN
          XCALL ERR(PLTCOMP);           #IF PLT COMPLAINS#
      PLTEMP = PLTFRAME[0];
      PLTPARM[0] = 0;         #CLEAR PLT PARAMETER WORD#
      PLTFRAME[0] = PLTEMP;
       END
#
     XBLANK(SIZ)
                COUNT NUMBER OF NON BLANK CHARACTERS
     ENTRY
       SIZ - LENGTH OF CHARACTER IN WORDS
        CHARACTER STRING MUST BE IN LOGL[1] +
     EXIT
       TRAILING BLANKS OF CHARACTER STRING ARE REMOVED.
       NCH = NUMBER OF CHARACTERS REMAINING IN STRING
     CALLS
       NONE
     METHOD
       THE CHARACTER STRING IS EXAMINED STARTING FROM THE END UNTIL
       A NON BLANK CHARACTER IS FOUND. ALL CHARACTERS AFTER THIS
       CHARACTER ARE SET TO BINARY ZERO, AND
        NCH = (LENGTH OF STRING IN CHARS) - (NUMBER OF BLANKS FOUND)
                                #
      PROC XBLANK (SIZ) ;        #COUNT NUMBER OF NON BLANK CHARACTERS#
      BEGIN             #IN ARRAY LOGL STARTING AT CELL NOP + SIZ#
      ITEM SIZ;         # USES I, J, AND ITEMP1#
      J=SIZ;          #INITIALIZE#
      NCH = SIZ*10;
XBK1:                                   #SKIP OVER BLANK WORDS#
      LOGLWORD[J+1]=0;      #FOR 6RM IN CASE THIS IS THE LAST CALL#
      IF LOGLWORD[J] NQ O"55555555555555555555" THEN
          GOTO XBK2;          #FOUND WORD WITH NON BLANK CHARACTERS#
      J=J-1;
      NCH = NCH - 10;
      IF J EQ 0 THEN
          RETURN;             #IF NO CHARACTERS IN MESSAGE#
      GOTO XBK1;
XBK2:
      NCH = NCH - 1;    #FIND FIRST NON-BLANK CHARACTER IN WORD#
      FOR I = 9 STEP -1 UNTIL 0 DO BEGIN
          IF C<I>LOGLWORD[J] NQ O"55" THEN BEGIN
              NCH = NCH + 1;    #FOUND IT - RETURN#
               RETURN;
               END
          C<I>LOGLWORD[J]=0;       #CLEAR BLANK#
          NCH = NCH - 1;
          END
      RETURN;
      END
#
      ROUNDX (A)
        CONVERT A REAL NUMBER TO INTEGER WITH ROUNDING.
       ENTRY
          A - NUMBER TO BE ROUNDED.
       EXIT
          FUNCTION RETURN.
          A IS IN INTEGER FORM AND ROUNDED UP TO NEXT WHOLE NUMBER.
      CALLS
          NONE
       METHOD
          IF "A" IS POSITIVE, 0.5 IS ADDED TO IT AND THE RESULT IS
        CONVERTED TO INTEGER, OTHERWISE 0.5 IS SUBTRACTED FROM "A"
        AND THE RESULT CONVERTED TO INTEGER.
                                                        #
       FUNC ROUNDX ((A)) I;
        BEGIN
          ITEM A R;
          IF A LS 0 THEN
            ROUNDX = A - 0.5;
           ELSE
            ROUNDX = A + 0.5;
        END
      CONTROL EJECT;
   #
      PLOT INITIALIZATION ...
          1. CONVERT MODE TO INTEGER
          2. FIND PLOT FIT
          3. FIND NUMBER OF FORMAL PARAMETERS IN CALL TO PLOT
          4. IF FILE NEVER OPENED -
              RESERVE FIRST 30 WORDS OF BUFFER FOR PLOT SCRATCH STORAGE
               SET RECORD TYPE = U, BLOCK TYPE = C
               OPEN FILE
          5. SET PLOT PARAMETER ARRAY (STORED AT TOP END OF BUFFER)
          6. GO TO APPROPRIATE SECTION.      #
      P<PLOTFIT> = PT$FIND;   #GET ADDRESS OF FIT FOR PLOT FILE#
#
      IF NO BUFFER HAS BEEN ASSIGNED, REQUEST A BLOCK OF 2000 WORDS
AND SET THE FIT UP ACCORDINGLY.#
      IF PLOTFWB EQ 0 THEN      #NO BUFFER#
         BEGIN
          PLOTFWB = CMM$ALF(2000,0,0);  #GET SPACE FOR BUFFER#
          PLOTBFS  = 2000;
          PLOTEX = LOC(PT$IOERR);
          TEMPBUFF = TRUE;
        END ELSE
          TEMPBUFF = FALSE;
*IF -DEF,NOS
       #  CHECK FOR MORE THAN 5 MINUTES PLOTTING TIME SINCE PLOT
          TIME LIMIT WAS LAST PUT ONTO FILE#
      IF TIME[0] GR 300 AND PLOTOC[0] EQ 1 THEN
        BEGIN
          CHEK;         #WAIT FOR ACTIVITY TO STOP#
          PLTCALL;            #CALL PLT TO SET PLOT TIME LIMIT#
        END
*ENDIF
      MODE = ICONV(MODEX, "MODE");
#
    COUNT NUMBER OF PARAMETERS IN CALX TO PLOT#
      NPAR = 0;
      IF LOC(P1) EQ 0 THEN
          GOTO PTM1;               # TO PLOT #
      NPAR = NPAR+1;
      IF LOC(P2) EQ 0 THEN
          GOTO PTM1;
      NPAR = NPAR+1;
      IF LOC(P3) EQ 0 THEN
          GOTO PTM1;
      NPAR = NPAR+1;
      IF LOC(P4) EQ 0 THEN
          GOTO PTM1;
      NPAR = NPAR+1;
      IF LOC(P5) EQ 0 THEN
          GOTO PTM1;
      NPAR = NPAR+1;
      IF LOC(P6) EQ 0 THEN
          GOTO PTM1;
      NPAR = NPAR+1;
      IF LOC(P7) EQ 0 THEN
          GOTO PTM1;
      NPAR = NPAR+1;
      IF LOC(P8) EQ 0 THEN
          GOTO PTM1;
      NPAR = NPAR+1;               # NPAR = NUMBER OF PARAMETERS #
      IF LOC(P9) EQ 0 THEN
          GOTO PTM1;
      NPAR=NPAR+1;
      IF LOC(P10) EQ 0 THEN
          GOTO PTM1;
      NPAR=NPAR+1;
#
    SET UP FIT AND OPEN PLOT FILE#
PTM1:
      IF PLOTOC[0] EQ 0 THEN BEGIN      #FILE NEVER OPENED#
            P<PLTPRMS> = PLOTFWB[0];
          PLOTFWB[0] = PLOTFWB[0] + 30;    #FIRST 30 WORDS OF BUFFER#
          PLOTBFS[0] = PLOTBFS[0] - 30;    #ARE USED FOR PLOT CONSTANTS#
          GOTO PTM2;
          END
      P<PLTPRMS> = PLOTFWB[0] - 30;
      IF PLOTOC[0] EQ 2 THEN BEGIN         # PLOT FILE CLOSED #
PTM2:   PLOTRT[0] = 7;           # RT=U #
        PLOTBT[0] = 2;           # BT=C #
          FOR I = 0 STEP 1 UNTIL 25 DO
            SCALE[I]=0;
         XCALL OPEN;            #OPEN PLOT FILE#
           PLTPARM[0] = 0;    #CLEAR PLT PARAMETER WORD#
         PLTFRAME[0] = 0;     #INITIALIZE PLOT TIME VARIABLES#
         TIME[0] = TITLES;
      END
      PLOTBUFF = TEMPBUFF;
          SWITCH PLTMOD , PMOD1, PMOD2, PMOD3, PMOD4, PMOD5, PMOD6,
           PMOD7, PTERR, PTERR, PMOD10, PMOD11, PTERR, PMOD13;
      IF MODE EQ 1 OR MODE EQ 10 THEN
          GOTO PTM3;          #AVOID CERTAIN CHECKS IF MODE 10#
      IF MODE NQ 6 AND XD EQ 0 THEN
          XCALL ERR(NOMODE1);
   #  CHECK FOR METRIC CALL IN ENGLISH FRAME OR VICA VERSA#
      IF STEPSSS[0] NQ 0 AND STEPSSS[0] NQ SETSTEPS THEN
          XCALL ERR(MIXCALL);
      IF MODE LS 1 OR MODE GR 13 THEN
          GOTO PTERR;
PTM3:
      GOTO PLTMOD[MODE];      #EXECUTE APPROPRIATE SECTION#
PTERR:
      ERR (BADMODE);       # BAD MODE PARAMETER #
      CONTROL EJECT;
  #                     PLOT MODE 1 SUBROUTINES
      MODE10     PRODUCE PLOT MODE 10 RECORD
         THIS ROUTINE PRODUCES A RECORD OF THE FORMAT
               WORD1 - 6/10,12/TIME LIMIT,12/NO OF FRAMES,30/XD,YD
               WORD2 - 0
               WORD3 - 0
       IF THIS IS NOT THE FIRST CALL TO THIS ROUTINE, THEN WEOR IS
     CALLED TO TERMINATE THE PREVIOUS FRAME, AND PLT IS CALLED TO UPDATE
     THE TIME LIMIT. THEN THE RECORD IS SET UP AND WRITTEN TO THE PLOT
     FILE
      NOTE - THE FIELD -TIME LIMIT- CONTAINS THE TIME IN MIN*8 TO DRAW
      THIS PLOT FILE. THIS IS SET BY THE PP PROGRAM PLT WHICH ALSO SETS
      THE FIELD -NO OF FRAMES-. THESE FIELDS ARE PRESENT ONLY ON THE
      FIRST FRAME OF THE PLOT FILE. THE PP PROGRAM PLT RESIDES ON
      AECLSYSTEMPL
          ENTRY -
            XD, YD  IN PLTPRMS
          EXIT -
            XLENGTH, YLENGTH     - DRAWING AREA OUTER BOUNDARY
            XKMAX, YKMAX         - CLIPPING AREA OUTER BOUNDARY
            XKMIN, YKMIN         - CLIPPING AREA INNER BOUNDARY
          CALLS -
            ERR, DSPCALL, PUT, PLTCALL, WEOR
        FIELDS USED -
            TMPA - LENGTH OF X AXIS IN PLOT STEPS.
            TMPB - LENGTH OF Y AXIS IN PLOT STEPS.
                                                            #
  PROC MODE10;
  BEGIN
     # IF THIS IS NOT THE FIRST CALL, CLEAN UP THE LAST FRAME. #
      IF FRAMECOUNT NQ 0 THEN
        BEGIN
          XCALL WEOR;              #WRITE EOR AFTER LAST FRAME #
          TMPA = XLENGTH[0] - XPOS[0];  # CALCULATE TIME TO MOVE PEN#
          TMPB = YLENGTH[0] - XPOS[0];  # TO NEW FRAME #
          IF TMPA GR TMPB THEN
              TIME[0] = TIME[0] + TMPA*SPEED + NEWFRAME;
            ELSE
              TIME[0] = TIME[0] + TMPB*SPEED + NEWFRAME;
          PLTFRAME[0] = PLTFRAME[0] + 1;     #CALL PLT TO SET TIME #
          PLTCALL;                           #FOR PREVIOUS FRAME   #
        END
  #  THIS IS A NEW FRAME #
      FRAMECOUNT = FRAMECOUNT + 1;
  #  CALCULATE DRAWING AREA BOUNDARIES   #
      STEPSSS[0] = SETSTEPS;       #SET PLOT STEPS PER UNIT#
      TMPA = XD[0] * SETSTEPS;
      TMPB = YD[0] * SETSTEPS;
      XLENGTH = TMPA - XORIGIN;
      YLENGTH = TMPB - YORIGIN;
      XKMIN[0] = -XORIGIN-200;          #CLIPPING BOUNDARY IS 1 INCH#
      YKMIN[0] = -YORIGIN - 200;        #OUTSIDE DRAWING AREA BOUNDARY#
      XKMAX = XLENGTH + 200;
      YKMAX = YLENGTH + 200;
  # CHECK LIMITS ON XD AND YD  #
      IF TMPA LS 1 OR TMPA GR XDMAX THEN     #FOR CURRENT LIMITS#
         XCALL ERR(BADXAXIS);
      IF TMPB LS 1 OR TMPB GR YDWMAX THEN      #SEE START OF PROGRAM#
         XCALL ERR(BADYAXIS);
  # IF WIDE PLOT, CALL DSP TO SET WIDE PLOT BIT.#
      IF TMPB GR YDNMAX THEN
        BEGIN
          WIDEDSP[0] = 0;          #CLEAR COMPLETION BIT #
          ICALL DSPCALL(WIDEDSPX);
        END
  # SET MODE 10 RECORD #
      LOGLWORD[0] = 0;
      LOGLWORD[1] = 0;
      LOGLWORD[2] = 0;
      LOGXD[0] = ROUNDX(TMPA) - O"60000";      #STORE XD AND YD #
      LOGYD[0] = ROUNDX(TMPB);
      LOGMOD[0] = 10;                        #SET MODE #
#    INITIALIZE PEN POSITION. IF FIRST FRAME, PUT TIME USED SO FAR INTO
    TIME LIMIT FIELD TO AVOID ZERO PRIORITY PLOT FILE #
      XPOS[0] = 0;
      YPOS[0] = 0;
      IF FRAMECOUNT EQ 1 THEN
        BEGIN
          LOGTIME[0] = TIME[0]/7.5 + .6;
          LOGNCHR[0] = 1;
          TIME[0] = 0;
        END
   # WRITE RECORD, THEN WE ARE FINISHED #
      XCALL PUT(30);
      RETURN;
   END
      CONTROL EJECT;
    #
      MODE11     PRODUCE PLOT MODE 11 RECORD
          THIS ROUTINE PRODUCES A RECORD OF THE FORM -
               WORD1 - 6/11,24/0,30/X0,Y0
               WORD2 - 30/XL,YL,30/ITX
               WORD3 - 30/ITY,30/DTX
               WORD4 - 30/DTY
          WHERE -
            X0,Y0 - COORDS OF LOWER LEFT HAND CORNER OF FRAME.
            XL,YL - LENGTH OF FRAME.
            ITX,ITY - DISTANCE BETWEEN TICKS
            DTX,DTY - DISTANCE BETWEEN START OF AXIS AND FIRST TICK.
       NO RECORD IS PRODUCED IF TICX = TICY = -1 (NO AXIS TO BE DRAWN)
          ENTRY -
            X0, Y0, XL, YL, XMIN, XMAX, YMIN, YMAX, TICX, TICY
            IN PLTPRMS.
          EXIT -
            SCALE       - SCALING FACTOR FOR POINTS IN USER UNITS
            X0, Y0      - ORIGIN OF THIS FRAME IN PLOT STEPS RELATIVE
                          TO ORIGIN OF DRAWING AREA.
          CALLS -
            ERR, PUT
                                                            #
   PROC MODE11;
   BEGIN
      ARRAY LENGTHD  P(2);
        ITEM XLP R(0,0,60),
             YLP R(1,0,60);
  #  TRANSFORM X0, Y0,  XL, YL INTO PLOTTING UNITS.#
      X0P = X0*SETSTEPS - XORIGIN;
      Y0P = Y0*SETSTEPS - YORIGIN;
      XLP[0] = XL * SETSTEPS;
      YLP[0] = YL * SETSTEPS;
   #  CHECK FOR X0, Y0 WITHIN DRAWING AREA#
      IF X0P LS -XORIGIN OR X0P GR XLENGTH THEN
          XCALL ERR(BADXAXIS);                  #-1.5< X0 < XD-1.5 #
      IF Y0P LS -YORIGIN OR Y0P GR YLENGTH THEN
          XCALL ERR(BADYAXIS);                 #-0,5 < Y0 < YD-0.5 #
   #  CHECK FOR THIS FRAME WITHIN DRAWING AREA#
      TMPA = X0P + XLP[0];
      IF TMPA GR XLENGTH THEN
          XCALL ERR(BADXAXIS);
      TMPB = Y0P + YLP[0];
      IF TMPB GR YLENGTH THEN
          XCALL ERR(BADYAXIS);
#   CHECK FOR NEGATIVE OR ZERO XL AND YL#
      IF XLP[0] LQ 0 THEN
          XCALL ERR(BADXAXIS);
      IF YLP[0] LQ 0 THEN
          XCALL ERR(BADYAXIS);
  # LOOP - FIRST TIME THRU - X PARAMETERS
         - SECOND TIME THRU - Y PARAMETERS   #
      FOR I=0 STEP 1 UNTIL 1 DO
        BEGIN
  # CHECK FOR MAX = MIN                      #
      IF XMAX[I] EQ XMIN[I] THEN
          XCALL ERR(MAXEQMIN);
  # CALCULATE SCALE = XL /(XMAX-XMIN)#
      SCALE[I] = XLP[I] / (XMAX[I]-XMIN[I]);
#   CALCULATE ITX AND DTX.#
  # IF TICK = 0, ITX = DTX 0 #
      IF TICX[I] EQ 0 THEN
        BEGIN
          LOGLWORD[I+1] = 0;
          LOGLWORD[I+3] = 0;
        END ELSE
  # TICK = -1,  ITX = DTX = -01    #
          IF TICX[I] LS 0 THEN
            BEGIN
              LOGLWORD[I+1] = O"7777777777";
              LOGLWORD[I+3] = O"7777777777";
            END ELSE BEGIN
  # TICK = VE     ITX = (XL / (XMAX-XMIN) * TICK       #
              TEMP1 = ABS(SCALE[I]*100*TICX[I]+.5);
              IF TEMP1 GR 4194304.0 THEN     #ERROR IF ITX GR 2**21 #
                LITX[I+1] = 4194304;
              ELSE
                LITX[I+1] = TEMP1;
#   CALCULATE A = (XMIN +- TICK) / TICK.
    IF A IS AN INTEGER THEN  DTX = ITX.         #
              IF XMIN[I] GR XMAX[I] THEN
                  TEMP1 = (XMIN[I]-TICX[I])/TICX[I];
                ELSE
                  TEMP1 = (XMIN[I]+TICX[I])/TICX[I];
              ITEMP1 = TEMP1;
              IF TEMP1 EQ ITEMP1 THEN
                  LOGLWORD[I+3] = LOGLWORD[I+1];
                ELSE BEGIN
  # OTHERWISE DTX = (INT(A)*TICK-XMIN)* XL/(MAX-MIN)#
                  IF TEMP1 LS 0 THEN
                     ITEMP1 = ITEMP1-1;
                  IF XMIN[I] GR XMAX[I] THEN
                     ITEMP1 = ITEMP1+1;
                  TEMP1 = ABS((ITEMP1*TICX[I]-XMIN[I]) * SCALE[I])*100
                    + .5;
                  IF TEMP1 LS 0 OR TEMP1 GR 4194304.0 THEN
                      XCALL ERR(BADSCALE);      #CHECK FOR BAD DTX #
                  LITX[I+3]=TEMP1;
                END
            END
  # CALCULATE TIME TO DRAW THIS AXIS  #
          IF TICX[I] GQ 0 THEN
            BEGIN
              TIME[0] = TIME[0] + 2*XLP[I]*SPEED;    #DRAW AXIS#
              IF TICX[I] GR 0 THEN
                BEGIN
                  ITEMP1 = ABS(XMAX[I] - XMIN[I]) / TICX[I];
                  TIME[0] = TIME[0] + ITEMP1*200*SPEED;
                END
            END
         END
  # SET UP PLOT MODE 11 RECORD AND WRITE IT #
      IF TICX GQ 0 OR TICY GQ 0 THEN
        BEGIN
          LOGLWORD [0] = 0;
          LOGMOD [0] = 11;                   # MODE#
          LOGXD [0] = ROUNDX(X0P) - O"60000";     # X0,Y0#
          LOGYD [0] = ROUNDX(Y0P);
          LOGXL [1] = ROUNDX(XLP[0]) - O"60000";   #XL, YL#
          LOGYL [1] = ROUNDX(YLP[0]);
  #   ITX IS ALREADY IN THE CORRECT SPOT #
          LOGUPH[2] = LOGLWH[2];             #ITY#
          LOGLWH[2] = LOGLWH[3];             #DTX#
          LOGUPH[3] = LOGLWH[4];             #DTY#
          XCALL PUT(35);
        END
  # MOVE PEN TO START OF FRAME #
      TMPA = ABS(Y0P - XPOS);
      TMPB = ABS(Y0P - YPOS);
      IF TMPA GR TMPB THEN
          TIME[0] = TIME[0] + TMPA*SPEED;
        ELSE
          TIME[0] = TIME[0] + TMPB*SPEED;
      XPOS = X0P;
      YPOS = Y0P;
  # FINISHED  #
      RETURN;
   END
      CONTROL EJECT;
   # PLOT MODE 1 - THIS ROUTINE SETS UP A NEW FRAME AND DRAWS A SET
          OF AXIS
        CALL PLOT (1,XL,YL,XMIN,XMAX,YMIN,YMAX,TICX,TICY)
      THIS CALL IS DECOMPOSED INTO TWO CALLS -
    CALL PLOT (10, XD, YD)
    CALL PLOT (11, X0, Y0, XL, YL, XMIN, XMAX, YMIN, YMAX, TICX, TICY)
          WHERE
            XD= XL + 2.5
            YD = 10.4 OR 28.5 (DEPENDING ON XL)
            X0, Y0  = ORIGIN OF DRAWING AREA. CURRENTLY -
                        X0 = 1.5 INCHES
                        Y0 = 0.5 INCHES
                                        #
PMOD1:
#  CHECK NUMBER OF PARAMETERS   #
      IF NPAR NQ 8 THEN
          XCALL ERR(ILLPARMS);
#  MOVE PARAMETERS INTO STORAGE FIELDS #
      XL[0] = RCONV(P1,"XLENGTH");
      YL[0] = RCONV(P2,"YLENGTH");
      ICALL LEGCHK (P3,"XMIN");
      ICALL LEGCHK (P4,"XMAX");
      XMIN[0] = P3;
      XMAX[0] = P4;
      ICALL LEGCHK (P5,"YMIN");
      ICALL LEGCHK (P6,"YMAX");
      YMIN[0] = P5;
      YMAX[0] = P6;
      TICX[0] = RCONV(P7, "TICK X");
      TICY[0] = RCONV(P8, "TICK Y");
#  PRODUCE PLOT MODE 10 RECORD #
      XD[0] = XL[0] + ((XORIGIN + XRBOUND)/SETSTEPS);
      IF YL[0] GR (YDNMAX - YORIGIN)/SETSTEPS THEN
          YD[0] = YDWMAX /SETSTEPS;
        ELSE
          YD[0] = YDNMAX /SETSTEPS;
      ICALL MODE10;
#  PRODUCE PLOT MODE 11 RECORD #
      X0[0] = XORIGIN/SETSTEPS;
      Y0[0] = YORIGIN/SETSTEPS;
      ICALL MODE11;
#  DONE#
      RETURN;
       CONTROL EJECT;
#  SUBROUTINES USED BY PLOT MODE 2
     STOREPOINT (X, Y)       STORE POINT IN PLOT MODE 2 RECORD.
        THIS SUBROUTINE STORES THE POINT IN THE NEXT FIELD IN THE
      PLOT MODE 2 RECORD. WHEN THE BUFFER FOR THE RECORD IS FULL
      (40 WORDS) IT IS FLUSHED.
      ENTRY -
        X, Y  - COORDINATES OF POINT TO BE STORED.
      EXIT -
        NONE
      CALLS -
        PUT
      FIELDS USED -
        J  - INDEX INTO ARRAY -LOGLWORD-
        K  - UPPER/LOWER PART OF WORD SIGNAL
                (BOTH J + K ARE INITIALIZED IN PLOT MODE 2)
                                #
      PROC STOREPOINT ((X), (Y));
      BEGIN
          ITEM X R, Y R;
        IF J LS 0 THEN
          BEGIN               #FIRST TIME THROUGH#
            J = 0;            #INITIALIZE BUFFER COUNTER#
            K=1;              #FIRST PAIR IN LOWER HALF OF WORD#
          END
      IF K EQ 0 THEN    #COORDS GO IN UPPER HALF OF WORD#
        BEGIN
          LOGXL[J] = ROUNDX(X) - O"60000";
          LOGYL[J] = ROUNDX(Y);
          K = 1;
        END ELSE BEGIN          #COORDS GO IN XOWER HALF OF WORD#
          LOGXD[J] = ROUNDX(X) - O"60000";
          LOGYD[J] = ROUNDX(Y);
          J = J + 1;
          K = 0;
          IF J EQ 40 THEN       #BUFFER FULL, OUTPUT IT#
            BEGIN
              XCALL PUT(400);
              J = 0;
            END
        END
      #   CALCULATE TIME TO DRAW THIS LINE#
      TMPA = ABS(X - XPOS);
      TMPB = ABS(Y - YPOS);
      IF TMPA GR TMPB THEN
          TIME[0] = TIME[0] + TMPA*SPEED + DRWSYMB;
        ELSE
          TIME[0] = TIME[0] + TMPB*SPEED + DRWSYMB;
      XPOS = X;
      YPOS = Y;
      RETURN;
      END
#
       XCONVERT (X)     - CONVERTS X FROM USER UNITS TO PLOT STEPS.
        THIS SUBROUTINE CONVERTS AN X VALUE FROM THE USER UNITS TO
      PLOT STEPS (1 STEP = .005 INCHES). THE FOLLOWING FORMULA ARE USED-
           XP = (XL/(XMAX-XMIN)*(X-XMIN) + X0
           XR = (XP*STEPS - 150)
        WHERE
          XL, XMAX, XMIN, X0  ARE AS DEFINED IN PLOT MODE 10 OR 11
          STEPS = NUMBER OF PLOT STEPS PER UNIT(INCHES OR MILLIMETRES).
      ENTRY
        X
      EXIT
        XR - AS DEFINED ABOVE
      CALLS -
        ALOG10  (IF LOG FLAG SET)
                                #
      FUNC XCONVERT ((X)) R;
      BEGIN
      ITEM X R, XR R;
        ICALL LEGCHK(X, "X");
        IF XLOGFLG[0] EQ 1 THEN
            XR = ALOG10(X);     #IF XLOG PLOT#
          ELSE
            XR = X;             #NORMAL PLOT#
        XCONVERT = (SCALE[0] * (XR - XMIN)) + X0P;
        RETURN;
      END
#
       YCONVERT (Y)     - CONVERTS Y FROM USER UNITS TO PLOT STEPS.
        THIS SUBROUTINE CONVERTS AN Y VALUE FROM THE USER UNITS TO
      PLOT STEPS (1 STEP = .005 INCHES). THE FOLLOWING FORMULA ARE USED-
           YP = (YL/(YMAY-YMIN)*(Y-YMIN) + Y0
           YR = (YP*STEPS - 50)
        WHERE
          YL, YMAY, YMIN, Y0  ARE AS DEFINED IN PLOT MODE 10 OR 11
          STEPS = NUMBER OF PLOT STEPS PER UNIT(INCHES OR MILLIMETRES).
      ENTRY
        Y
      EXIT
        YR - AS DEFINED ABOVE
      CALLS -
        ALOG10  (IF LOG FLAG SET)
                                #
      FUNC YCONVERT ((Y)) R;
      BEGIN
      ITEM Y R, YR R;
        ICALL LEGCHK(Y, "Y");
        IF YLOGFLG[0] EQ 1 THEN
            YR = ALOG10(Y);     #IF YLOG PLOT#
          ELSE
            YR = Y;             #NORMAL PLOT#
        YCONVERT = (SCALE[1] * (YR - YMIN)) + Y0P;
        RETURN;
      END
          CONTROL EJECT;
   #   PLOT-2 -
          THIS ROUTINE PLOTS A SET OF POINTS
          CALL PLOT(2,PEN,SYMB,X,Y,N)
               IF N LS 0 , PLOT ARRAYS IN REVERSE
               IF N EQ 0, ERROR MESSAGE AND ABORT
        DATA WRITTEN TO PLOT FILE -
                WORD1 - 6/02,6/PEN,6/SYMB,12/0,30/X(1),Y(1)
                WORD2 - 30/X(2),Y(2),30/X(3),Y(3)
                - - - - - - - - - - - - - - - - -
                WORDM - 30/X(N),Y(N),6/40B,24/0
                                                #
PMOD2:
      IF NPAR NQ 5 THEN
          XCALL ERR(ILLPARMS);
#
    PUT PARAMETERS INTO PLOT RECORD#
      LOGMOD[0] = 2;           # MODE #
      PENN = ICONV(P1, "PEN");
      LOGPEN[0] = PENN;
      LOGSYMB[0] = ICONV(P2, "SYMBOL");
      IF LOGSYMB[0] LS 0 OR LOGSYMB[0] GR 24 THEN
          LOGSYMB[0] = 0;     # LIMITS ON SYMBOL #
      N = ICONV(P5, "N");
      IF N EQ 0 THEN
          XCALL ERR(ZERON);
#
    INITIALZE TIME CALCULATION FOR THIS LINE#
      IF LOGSYMB[0] NQ 0 THEN      #SET TIME TO DRAW A SYMBOL #
        BEGIN
          IF B<5,1>LOGSYMB[0] EQ 1 THEN
               DRWSYMB = DRAWSYMBOL;    #SYMB ODD - SMALL SYMBOL#
          ELSE
               DRWSYMB = 3 * DRAWSYMBOL;  #SYMB EVEN - LARGE SYMBOL#
        END ELSE
          DRWSYMB = 0;        #NO SYMBOLS#
      IF PENN NQ 0 THEN         #LINE BEING DRAWN#
          TIME[0] = TIME[0] + UPDOWN;
#
    SET BOUNDARYS OF DO LOOP FOR SCANNING THROUGH X, Y PAIRS#
      IF N LS 0 THEN BEGIN
          N = -1 * N;
          ISTART = N - 1;       #N LS 0, PLOT POINTS IN REVERSE#
          ISTEP = -1;         # SET PARAMETERS FOR DO LOOP #
          IFINISH = 0;
      END ELSE BEGIN
          ISTART = 0;
          ISTEP = 1;
          IFINISH = N-1;
      END
      P<XPTS> = LOC(P3);      #SET COORDINATE ARRAYS#
      P<YPTS> = LOC(P4);
      J=-1;         #BUFFER COUNTER#
#
  IF NO LINES ARE TO BE DRAWN BETWEEN POINTS, TRANSFORM THE POINTS
  AND CLIP THEM, ONLY STORING POINTS WHICH LIE INSIDE THE CLIPPING
  REGION.       #
       IF PENN EQ 0 THEN
         BEGIN
           I = ISTART;
LOOP1:
               X1 = XCONVERT(XPOINT[I]);
               Y1 = YCONVERT(YPOINT[I]);
               IF (X1 GQ XKMIN AND X1 LQ XKMAX) AND
                 (Y1 GQ YKMIN AND Y1 LQ YKMAX) THEN
                 BEGIN
                   ICALL STOREPOINT(X1, Y1);
                   TIME[0] = TIME[0] + UPDOWN + UPDOWN;
                 END
            IF I NQ IFINISH THEN
              BEGIN
                I = I + ISTEP;
                GOTO LOOP1;
              END
          IF J LS 0 THEN
               GOTO PMOD2RETURN;                #NO POINTS DRAWN#
         END  ELSE BEGIN
#
     GET FIRST POINT#
     I = ISTART;
      X1 = XCONVERT(XPOINT[ISTART]);
      Y1 = YCONVERT(YPOINT[ISTART]);
#  HANDLE SPECIAL CASE OF ONLY ONE POINT BEING DRAWN#
      IF N EQ 1 THEN
        BEGIN
          IF (X1 GQ XKMIN AND X1 LQ XKMAX) AND
            (Y1 GQ YKMIN AND Y1 LQ YKMAX) THEN
            BEGIN
              ICALL STOREPOINT(X1,Y1);
              GOTO PMOD2FINISH;
            END ELSE
              GOTO PMOD2RETURN;
        END
#
   IF LINES ARE TO BE DRAWN BETWEEN POINTS, TRANSFORM THE POINTS AND
   CLIP THE LINES. RATHER THAN ACTUALLY CLIPPING LINES, PRODUCING
   MULTIPLE SEGMENTS FROM THE GIVEN SEGMENT, CLIPPED PORTIONS ARE MADE
   TO RUN ALONG THE CLIPPING REGION BOUNDARY.
   REPEAT THE FOLLOWING FOR EACH LINE SEGMENT -
   TRANSFORM THE SECOND POINT AND CLIP THE LINE SEGMENT.    #
      OUT = FALSE;
    I = ISTART+ISTEP;
LOOP2:
      X2ORIG = XCONVERT(XPOINT[I]);
      X2=X2ORIG;
      Y2ORIG = YCONVERT(YPOINT[I]);
      Y2=Y2ORIG;
      XCALL KLIP(FLAG);
#
   IF THE SEGMENT IS NOT ENTIRELY OUTSIDE THE CLIPPING REGION, THEN
   SOME PORTION OF IT LIES INSIDE, AND DATA POINTS DESCRIBING THIS
   INSIDE PORTION MUST BE SAVED.        #
      IF FLAG EQ 4 THEN
          GOTO GETNEXTPOINT;
#
   IF COMING BACK INTO THE CLIPPING REGION FROM OUTSIDE, THE POINTS
   WHICH DESCRIBE THE SEGMENTS LYING OUTSIDE THE BOUNDARY OF THE REGION
   MUST BE STORED. OTHERWISE ONLY THE FIRST (CLIPPED) POINT OF THE
   PRESENT SEGMENT NEED BE STORED       #
      IF OUT THEN
        BEGIN
          ICALL STOREPOINT(XBOUND,YBOUND);
          IF X1 NQ XBOUND AND Y1 NQ YBOUND THEN
            BEGIN
              IF XBOUND NQ XKMIN AND XBOUND NQ XKMAX THEN
                BEGIN
                  XBOUND = XKMIN;
                  IF X1 NQ XKMIN THEN
                    BEGIN
                      XBOUND = XKMAX;
                      IF X1 NQ XKMAX THEN
                         BEGIN
                          ICALL STOREPOINT(XBOUND,YBOUND);
                          YBOUND = YKMAX - YBOUND + YKMIN;
                        END
                    END
                END ELSE BEGIN
                  YBOUND = YKMIN;
                  IF Y1 NQ YKMIN THEN
                    BEGIN
                      YBOUND = YKMAX;
                      IF Y1 NQ YKMAX THEN
                        BEGIN
                          ICALL STOREPOINT(XBOUND,YBOUND);
                          XBOUND = XKMAX - XBOUND + XKMIN;
                        END
                    END
                END
              ICALL STOREPOINT(XBOUND,YBOUND);
            END
        END
      ICALL STOREPOINT(X1,Y1);
#
   IF THE SECOND POINT LIES OUTSIDE THE CLIPPING REGION, SAVE THE
   POINT AT WHICH THE LINE SEGMENT INTERSECTS THE BOUNDARY AND
   INDICATE THAT THE DATA POINTS HACE MOVED OUTSIDE THE CLIPPING
   REGION       #
      OUT = FALSE;
      IF FLAG GQ 2 THEN
        BEGIN
          XBOUND = X2;
          YBOUND = Y2;
          OUT = TRUE;
        END
#
   SET THE SECOND (UNCLIPPED) POINT AS THE FIRST POINT OF THE NEXT
   LINE SEGMENT. RETREIVE THE SECOND POINT OF THE NEXT SEGMENT.#
GETNEXTPOINT:
      X1 = X2ORIG;
      Y1 = Y2ORIG;
     IF I NQ IFINISH THEN
       BEGIN
         I = I + ISTEP;
         GOTO LOOP2;
       END
#  IF NO MORE POINTS, SAVE THE LAST POINT AND RETURN.#
      IF FLAG NQ 4 THEN
          IF OUT THEN
              ICALL STOREPOINT(XBOUND, YBOUND);
            ELSE
              ICALL STOREPOINT(X1, Y1);
      END
#
  FLUSH THE PLOT RECORD AREA#
PMOD2FINISH:
      NCH = (J+1)*10;   #NO OF CHARACTERS IN BUFFER#
      IF K EQ 0 THEN
        BEGIN                   #SET TERMINATION CODE#
          LOGLWORD[J] = O"40000000000000000000";
          NCH = NCH - 5;
        END ELSE
          LOGLWH[J] = O"4000000000";
      LOGLWORD[J+1] = 0;        #FOR CRM IN CASE THIS IS THE LAST CALL#
      XCALL PUT(NCH);           #FLUSH RECORD AREA#
PMOD2RETURN:
      XYFLGWORD[0] = 0;         #CLEAR LOG LOG FLAG#
      RETURN;
      CONTROL EJECT;
   #
       PLOT 3 -
          THIS ROUTINE PLOTS A TITLE
          CALL PLOT (3,FORM,SIZE,DIR,X,Y,ARR,N)
               IF FORMAT IS PURE HOLLERITH, LAST TWO CHARACTERS MAY
                BE OMITTED
               ERROR MESSAGE IF N LESS 0
        DATA WRITTEN TO PLOT FILE -
           WORD1 - 6/03B,6/SIZE,6/DIR,12/NCHR,30/X,Y
           WORD2 - WORDN = MESSAGE TO BE PLOTTED (NCHR CHARACTERS LONG)
                                                        #
PMOD3:
#
      SET UP X1, Y1  COORDS OF START OF STRING VECTOR#
      X1 = XCONVERT(P4);
      Y1 = YCONVERT(P5);
PMOD3A:
#
   CHECK FOR LEGAL NUMBER OF PARAMETERS IN PLOT CALL#
      IF NPAR NQ 5 AND NPAR NQ 7 THEN
          PT$ERR(ILLPARMS);
#
     PLOT MODE 13 JUMPS HERE TO FINISH PROCESSING#
#
     PUT PARAMETERS INTO PLOT RECORD#
       LOGLWORD[0] = 0;         #CLEAR FIRST WORD OF RECORD AREA#
      LOGMOD[0] = 3;               # MODE #
      LOGPEN[0] = ICONV(P2, "SIZE");
      IF LOGPEN[0] GR 10 OR LOGPEN[0] LQ 0 THEN
          LOGPEN[0] = 3;           # SET DEFAULT SIZE #
      DIRCT = ICONV(P3, "DIRECTION");
      LOGSYMB[0] = DIRCT;
      IF NPAR EQ 5 THEN
          N = 0;                   # SET N - NUMBER OF ENTRIES IN ARRAY#
      ELSE
          N = ICONV(P7, "N");
      IF N LS 0 THEN
        BEGIN
          AERROR[3] = "N";
          XCALL ERR(ILLVARIABLE);
        END
      XCALL ENCD(P1, LOGL[1], N, P6);   #CALL ENCODE TO CODE DATA#
      ICALL XBLANK(14);         #COUNT NUMBER OF NON-BLANK CHARS
                                IN MESSAGE#
      IF NCH EQ 0 THEN          #NO OUTPUT IF#
          RETURN;               #NO MESSAGE TO BE PLOTTED#
      LOGNCHR[0] = NCH;
#
    CALCULATE CHARACTER SIZE.  IF CHARACTERS ARE ON A DIAGONAL, THEN
    SIZE IS REGULAR SIZE * SQRT (2)     #
      IF ABS(XDIR[DIRCT]) EQ ABS(YDIR[DIRCT]) THEN
          CW = LOGPEN[0] * 1.414*16;
        ELSE
          CW = LOGPEN[0] * 16;
      SW = NCH * CW;            #LENGTH OF CHARACTER STRING#
#
    DETERMINE THE BASE VECTOR LYING ALONG THE BOTTOM OF THE CHARACTER
    STRING AND CLIP IT. #
      X1ORIG = X1;
      Y1ORIG = Y1;
      X2 = X1 + SW*XDIR[DIRCT];
      Y2 = Y1 + SW*YDIR[DIRCT];
      XCALL KLIP(FLAG);
#
   IF THE BASE VECTOR LIES COMPLETELY OUTSIDE THE CLIPPING REGION,
   IGNORE THIS CALL.    #
      IF FLAG EQ 4 THEN
        RETURN;
#
     IF THE FIRST CHARACTER IS LOCATED WITHIN THE CLIPPING REGION, DO
    NOT SKIP OVER ANY CHARACTERS, SAVE THEM ALL IN THE TEXT STREAM.
    NOTE THAT ANY CHARACTERS AT THE END OF THE STRING WHICH HAPPEN TO
    LIE OUTSIDE THE CLIPPING REGION WILL BE CLIPPED WHEN THE DRAWING
    IS PLOTTED, AND HENCE WILL BE CLIPPED AT THAT TIME. #
#
    DETERMINE THE NUMBER OF CHARACTERS TO SKIP OVER IN ORDER TO REACH
   THE FIRST CHARACTER WHICH IS LOCATED WITHIN THE CLIPPING REGION.
   STORE THIS AND ALL REMAINING CHARACTERS IN THE TEXT STRING #
      IF FLAG EQ 1 OR FLAG EQ 3 THEN
        BEGIN
          TMPA = X1-X1ORIG;
          TMPB = Y1-Y1ORIG;
          SW = SQRT(TMPA*TMPA+TMPB*TMPB);
          NSKP = SW/CW +1;
          SW = NSKP * CW;
          X1 = X1ORIG + SW*XDIR[DIRCT];
          Y1 = Y1ORIG + SW*YDIR[DIRCT];
          IF (X1 LS XKMIN OR X1 GR XKMAX) OR
            (Y1 LS YKMIN OR Y1 GR YKMAX) THEN
              RETURN;
#
SKIP OVER THE REQUIRED NUMBER OF CHARACTERS IN THE MODE 3 RECORD.#
          NCH = NCH - NSKP;
          XCALL MOVE(NSKP,0,NCH);
        END
#
    STORE NUMBER OF CHARACTERS LEFT IN MODE 3 CALL AND XY POSITION#
      LOGNCHR[0] = NCH;
      LOGXD[0] = X1 - O"60000";
      LOGYD[0] = Y1;
      XYFLGWORD[0] = 0;         #CLEAR LOGLOG FLAG#
      XCALL PUT(NCH+10);
   #
     CALCULATE TIME TO MOVE PEN TO START OF STRING VECTOR#
      TMPA = ABS(X1 - XPOS);
      TMPB = ABS(Y1 - YPOS);
      IF TMPA GR TMPB THEN
          TIME[0] = TIME[0] + SPEED*TMPA;
        ELSE
           TIME[0] = TIME[0] + SPEED*TMPB;
#
    CALCULATE TIME TO DRAW SYMBOLS#
      TIME[0] = TIME[0] + UPDOWN+UPDOWN +
                NCH*(DRAWCHAR1 + CW*DRAWCHAR2);
      XPOS = X2;
      YPOS = Y2;
      RETURN;
      CONTROL EJECT;
   #
      PLOT 4 -
          THIS ROUTINE RETURNS VARIABLES SUPPLIED BY THE LAST MODE 1
          CALL OF PLOT #
PMOD4:
      IF NPAR NQ 8 THEN
          XCALL ERR(ILLPARMS);
      P1 = XL;
      P2 = YL;
      P3 = XMIN;
      P4 = XMAX;
      P5 = YMIN;
      P6 = YMAX;
      P7 = TICX;
      P8 = TICY;
      RETURN;
      CONTROL EJECT;
   #
      PLOT 5 -
        THIS ROUTINE SENDS A MESSAGE TO THE 3300 CONSOLE
        CALL PLOT (5,FORM,ARR,N)
            IF FORMAT IS PURE HOLLERITH, LAST TWO PARAMETERS MAY BE
               OMITTED
        WORDS WRITTEN TO PLOT FILE -
           WORD1 - 30/0,12/5,18/NCHR
           WORD2 - WORDN = MESSAGE TO BE PLOTTED (NCHR CHARACTERS LONG)
                                                #
PMOD5:
      IF NPAR NQ 1 AND NPAR NQ 3 THEN
          XCALL ERR(ILLPARMS);
      IF NPAR EQ 1 THEN
          N=0;           # SET N - NUMBER OF WORDS IN DATA ARRAY#
      ELSE
          N = ICONV(P3, "N");
      IF N LS 0 THEN
        BEGIN
          AERROR[3] = "N";
          XCALL ERR(ILLVARIABLE);
        END
      XCALL ENCD(P1, LOGL[1], N, P2);      #CALL ENCODE#
      ICALL XBLANK(4);          #NUMBER OF NON BLANK CHARS#
      IF NCH EQ 0 THEN          #IF NO CHARACTERS IN MESSAGE#
          XCALL ERR(BLANKMSG);
      LOGLWORD[0]=NCH;
      LOG5MD[0] = 5;            #MODE#
      LOGUPH[0] = 0;            #3300 IGNORES THIS PART#
      XCALL PUT(NCH+10);                #WRITE MESSAGE#
      RETURN;
      CONTROL EJECT;
   #
     PLOT 6 -
        THIS ROUTINE ISSUES SPECIAL PLOTTING INSTRUCTIONS
            CALL PLOT (6,I,ITIME,NOW)
                I=1 - SPECIAL INSTRUCTIONS GIVEN
                  6 - WIDE PLOTTER
                  7 - PLOT TIME LIMIT GIVEN
                ITIME - PLOT TIME LIMIT
                NOW  " 0  PLOT RELEASED IMMEDIATELY.
      NOVEMBER 1975 - TIME LIMIT SPECIFICATION IS IGNORED.
          PLOT TIME CALCULATED INTERNALLY.
        SEE SCOPE REFERENCE MANUAL FOR FORMAT OF DISPOSE PARAMETERS #
PMOD6:
      IF NPAR LS 1 OR NPAR GR 3 THEN
          XCALL ERR(ILLPARMS);
      DSPCMP[0] = 0;          # RESET COMPLETION BIT#
      I = ICONV(P1, "P6CODE");
      IF I EQ 1 THEN
          DSPDC[0] = "PX";      #SPECIAL DISPOSE#
        ELSE
          IF I EQ 6 THEN
              DSPDC[0] = "PW";  #WIDE PLOTTER#
            ELSE
              DSPDC[0] = "PL";  #DEFAULT DC#
      IF NPAR LQ 2 OR ICONV(P3, "NOW") LQ 0 THEN
          DSPEOJ[0] = 1;      # SET EOJ BIT #
      ELSE BEGIN              # RELEASE FILE NOW #
          IF SCALE[0] EQ 0 THEN
              XCALL ERR(EMPTYFIL);      #NO MODE 1 CALL#
          DSPEOJ[0] = 0;
          XCALL CLOS;           #FOR THIS FRAME#
          PLTCALL;            #FOR THIS FRAME#
      END
      DSPCALL(PLTDSP);        # CALL DSP TO ROUTE FILE #
      RETURN;
      CONTROL EJECT;
   #
      PLOT 7 -
          CLOSE PLOT FILE
               CALL PLOT (7,I)
                    IF I = 0 - CLOSE NOREWIND
                    IF I " 0 - CLOSE THEN EVICT.  #
PMOD7:
      IF NPAR NQ 0 AND NPAR NQ 1 THEN
          XCALL ERR(ILLPARMS);
      IF NPAR EQ 0 OR ICONV(P1, "P7PARM") EQ 0 THEN
         BEGIN
*IF -DEF,NOS
          XCALL TERMM(PLOTFIT);         #NORMAL CLOSE#
*ENDIF
*IF DEF,NOS
           XCALL CLOS;     #NORMAL CLOSE#
*ENDIF
           PLTPARM[0] = 0;    #CLEAR PLT PARAMETER WORD#
           PLTFRAME[0] = 0;
         END
      ELSE BEGIN
          XCALL CLOS;           #CLOSE AND EVICT#
          SCRDSP[0] = 0;     #CLEAR COMPLETEION BIT#
          DSPCALL(SCRDSPX);        # CALL DSP TO EVICT FILE #
 END
       IF PLOTBUFF THEN         #IF BUFFER FROM CMM, RETURN IT#
        BEGIN
          XCALL CMM$FRF (PLOTFWB - 30);
          PLOTFWB = 0;
        END
 RETURN;
      CONTROL EJECT;
  #
      PLOT 10 - DEFINE A DRAWING AREA
         XCALL PLOT (10,XD,YD)
           WHERE
             XD,YD  = DIMENSIONS OF DRAWING AREA IN INCHES (MM).
         NOTE: MOST OF THE WORK FOR THIS CALL IS DONE BY "MODE10" WHICH
           IS LOCATED BEFORE PLOT MODE 1.
                                                            #
PMOD10:
   #  CHECK NUMBER OF PARAMETERS  #
      IF NPAR NQ 2 THEN
          XCALL ERR(ILLPARMS);
   #  CHECK XD, YD AND MOVE THEM INTO STORAGE BLOCK #
      XD[0] = RCONV(P1, "XD");
      YD[0] = RCONV(P2, "YD");
#  INITIALIZE OTHER PARAMETERS IN BLOCK IN CASE OF NO PLOT MODE 11 CALL.
#
      X0[0] = 0;
      Y0[0] = 0;
      XL[0] = XD;
      YL[0] = YD;
      XMIN[0] = 0;
      YMIN[0] = 0;
      XMAX[0] = XD;
      YMAX[0] = YD;
      TICX[0] = -1;
      TICY[0] = -1;
      SCALE[0] = SETSTEPS;
      SCALE[1] = SETSTEPS;
      X0P = -XORIGIN;
      Y0P = -YORIGIN;
  # PRODUCE MODE 10 RECORD #
      ICALL MODE10;
      RETURN;
      CONTROL EJECT;
  #
      PLOT 11 - ESTABLISH FRAME WITHIN DRAWING AREA AND DRAW AXES
          CALL PLOT (11,X0,Y0,XL,YL,XMIN,XMAX,YMIN,YMAX,TICX,TICY)
            WHERE -
               X0,Y0 = COORDINATES OF THIS FRAME.
               XL,YL = SIZE OF THIS FRAME
               XMIN,XMAX = RANGE OF X VALUES
               YMIN,YMAX = RANGE OF Y VALUES
               TICX,TICY = -1 - NO AXIS DRAWN
                           0 - FRAME DRAWN BUT NO TICKS.
                           >0 -TICKS DRAWN AT X = N*TICK (N= 0,1,2,-..)
       NOTE - MOST OF THE WORK FOR THIS SECTION IS PERFORMED BY THE
         SUBROUTINE "MODE11" WHICH IS LOCATED BEFORE PLOT MODE 1.
                                                                 #
PMOD11:
  # CHECK NO OF PARAMETERS #
      IF NPAR NQ 10 THEN
          XCALL ERR(ILLPARMS);
  # LOAD ALL PARAMETERS INTO STORAGE BLOCK #
      ICALL LEGCHK (P1, "X0");
      ICALL LEGCHK(P2,"Y0");
      X0[0] = P1;
      Y0[0] = P2;
      XL[0] = RCONV(P3,"XL");
      YL[0] = RCONV(P4,"YL");
      ICALL LEGCHK(P5,"XMIN");
      ICALL LEGCHK(P6,"XMAX");
      XMIN[0]=P5;
      XMAX[0]=P6;
      ICALL LEGCHK(P7,"YMIN");
      ICALL LEGCHK(P8,"YMAX");
      YMIN[0]=P7;
      YMAX[0]=P8;
      TICX[0]=RCONV(P9,"TICK X");
      TICY[0]=RCONV(P10,"TICK Y");
  # PRODUCE PLOT MODE 11 RECORD   #
      ICALL MODE11;
  # FINISHED  #
      RETURN;
      CONTROL EJECT;
#
       PLOT 13 -
          THIS ROUTINE PLOTS A TITLE.
          CALL PLOT(13,FORM,SIZE,DIR,X,Y,ARR,N)
        THIS ROUTINE IS SIMILAR TO PLOT 3 EXCEPT X AND Y ARE
     SPECIFIED IN INCHES
                                        #
PMOD13:
       IF NPAR NQ 5 AND NPAR NQ 7 THEN
#
    SET COORDS OF START OF STRING VECTOR
        X1 = X + X0
        Y1 = Y + Y0             #
      ICALL LEGCHK(P4,"X");
      ICALL LEGCHK(P5,"Y");
      X1 = P4*SETSTEPS + X0P;
      Y1 = P5*SETSTEPS + Y0P;
      GOTO PMOD3A;           #JOIN PLOT 3 PROCESSING#
      END
      TERM
       PROC PT$KLIP (FLAG);
      BEGIN
#
     KLIP WILL CLIP A GIVEN LINE SEGMENT TO THE GIVEN RECTANGULAR
  CLIPPING REGION IN TWO SPACE.
  ARGUEMENT LIST -
        PART OF COMMON BLOCK PT$COMM
          X1, Y1        XY COORDINATES OF FIRST POINT OF LINE SEGMENT.
          X2, Y2        XY COORDINATES OF SECOND POINT OF LINE SEGMENT.
          XKMIN, YKMIN, XKMAX, YKMAX    LIMITS ON CLIPPING REGION.
       FORMAL PARAMETER
          FLAG          INDICATES RESULT OF THE CLIPPING OPERATION.
             0 - SEGMENT LIES COMPLETELY INSIDE CLIPPING REGION.
             1 - FIRST POINT OF SEGMENT LIES OUTSIDE BUT SECOND IS
                 INSIDE.
             2 - SECOND POINT OF SEGMENT LIES OUTSIDE BUT FIRST IS
                 INSIDE.
             3 - BOTH END POINTS OF SEGMENT LIE OUTSIDE CLIPPING
                 REGION, BUT MIDDLE PORTION OF SEGMENT LIES INSIDE.
             4 - ENTIRE SEGMENT LIES OUTSIDE CLIPPING REGION.
    X1, Y1, X2, Y2 IN THE COMMON BLOCK /PT$COMM/ RETURN THE CLIPPED END
  POINTS OF THE SEGMENT. HOWEVER IF THE ENTIRE SEGMENT LIES OUTSIDE
  THE CLIPPING REGION, X1, Y1, X2, Y2 WILL BE UNDEFINED UPON RETURN.
 ALGORITHM USED -
    THE SCAN ALGORITHM AS DESCRIBED IN "TWO SIMPLE WINDOWING
  ALGORITHMS" BY JOHN F. JARVIS, SOFTWARE - PRACTICE AND EXPERIENCE,
  VOL. 5, PP. 115-122 (1975), IS USED IN KLIP.
  WRITTEN BY JAMES W. WENDORF, OCTOBER, 1978.
  ADAPTED BY C. J. TANNER, DECEMBER 1978.
                                        #
#   FORMAL PARAMETERS#
      ITEM FLAG I;
#     COMMON BLOCK#
      COMMON PT$COMM;           #COMMON BLOCK FOR PLOT DATA#
        BEGIN
          BASED ARRAY PLTPRMS;          #ARRAY CONTAINING PARAMETERS#
            BEGIN               #SAVED BETWEEN PLOT CALLS AT#
              ITEM SCALE R(0,0,60);     #BEGINNING OF PLOT#
                                        #BUFFER#
          ITEM XD R(2,0,60),    # ** PLOT MODE 1  PARMETERS**  #
               YD R(3,0,60),    # DRAWING AREA #
               X0 R(4,0,60),    # COORDS OF THIS FRAME #
               Y0 R(5,0,60),
               XL R(6,0,60),    #SIZE OF THIS FRAME #
               YL R(7,0,60),
               XMIN R(8,0,60),  #RANGE OF USER COORDINATES #
               YMIN R(9,0,60),
               XMAX R(10,0,60),
               YMAX R(11,0,60),
               TICX R(12,0,60), #TICK FLAGS #
               TICY R(13,0,60),
      # END OF PLOT MODE 1 PARAMETERS #
               XPOS R(14,0,60), #CURRENT PEN POSITION #
               YPOS R(15,0,60),
               STEPSSS   R(16,0,60),   #STEPS PER UNIT #
               FRAMECOUNT I(17,0,60),  #NO OF FRAMES DRAWN #
               XKMIN R(18,0,60),
               YKMIN R(19,0,60),
               XKMAX R(20,0,60),    # BOUNDARY FOR CLIPPING #
               YKMAX  R(21,0,60),
               XLENGTH R(22,0,60),  # BOUNDARY IN PLOT STEPS #
               YLENGTH R(23,0,60),
               X0P R(24,0,60),          #X0, Y0 IN PLOT STEPS#
               Y0P R(25,0,60);
          ITEM PLOTBLOCK B(26,0,60);
            END
          ITEM FITADDR I;
          ARRAY LOGL [40];      ITEM LOGLWORD (0,0,60);
          ITEM XYSIG;           #FLAGS FOR LOG LOG PLOTS#
          ITEM SETSTEPS R;      #STEPS PER UNIT, MODE 1 ONLY#
          ARRAY P1 P(2);        #X COORDINATES#
             ITEM X1 R(0,0,60),
                  Y1 R(1,0,60);
          ARRAY P2 P(2);        #Y COORDINATES#
             ITEM X2 R(0,0,60),
                  Y2 R(1,0,60);
       END
#  MISC. FIELDS#
      ITEM A R;         #GENERAL PURPOSE REAL#
      ITEM B R;
      ITEM I I;         #LOOP INDEX#
      ITEM IFLAG I;     #HOLDS VALUE OF OUTPUT FLAG#
      ITEM J I;         #USED TO REFERENCE OTHER POINT FROM I#
                        #WHEN I REFERS TO X, J REFERS TO Y  #
      ITEM W R;
#
   INITIALIZE THE RETURN FLAG VALUE AND COMPUTE THE PARAMETERS
   DEFINING THE LINE PASSING THROUGH THE GIVEN POINTS A*X+B*Y=W. #
       IFLAG = 0;
       A = Y1[0] - Y2[0];
       B = X2[0] - X1[0];
       W = Y1[0]*X2[0] - X1[0]*Y2[0];
   #
     FIRST CLIP AGAINST MIN AND MAX X LIMITS AND THEN AGAINST MIN
  AND MAX Y LIMITS OF CLIPPING REGION  #
       FOR I = 0 STEP 1 UNTIL 1 DO
         BEGIN
           J = 1-I;     #J = 1 WHEN I = 0, ETC#
#  CLIP AGAINST MINIMUM LIMIT#
           IF X1[I] LS XKMIN[I] THEN
             BEGIN
               IF X2[I] LS XKMIN[I] THEN
                   GOTO ALLOUT;
#    THE FIRST POINT LIES OUTSIDE#
               X1[I] = XKMIN[I];
               X1[J] = (W - XKMIN[I]*A) / B;
               IFLAG = IFLAG LOR 1;
             END ELSE BEGIN
# THE SECOND POINT LIES OUTSIDE#
               IF X2[I] LS XKMIN[I] THEN
                 BEGIN
                   X2[I] = XKMIN[I];
                   X2[J] = (W - XKMIN[I]*A) / B;
                   IFLAG = IFLAG LOR 2;
                 END
            END
#  CLIP AGAINST MAXIMUM LIMIT#
           IF X1[I] GR XKMAX[I] THEN
             BEGIN
               IF X2[I] GR XKMAX[I] THEN
                   GOTO ALLOUT;
#  THE FIRST POINT LIES OUTSIDE#
               X1[I] = XKMAX[I];
               X1[J] = (W - XKMAX[I]*A) / B;
               IFLAG = IFLAG LOR 1;
             END ELSE BEGIN
#  THE SECOND POINT LIES OUTSIDE#
               IF X2[I] GR XKMAX[I] THEN
                 BEGIN
                   X2[I] = XKMAX[I];
                   X2[J] = (W - XKMAX[I]*A) / B;
                   IFLAG = IFLAG LOR 2;
                 END
             END
#  PREPARE TO CLIP AGAINST OTHER MIN AND MAX LIMITS#
           A==B;
         END
       FLAG = IFLAG;
       RETURN;
#  IF THE ENTIRE SEGMENT LIES OUTSIDE THE CLIPPING REGION, RETURN
   FLAG VALUE OF 4#
ALLOUT:
       FLAG = 4;
       RETURN;
     END
     TERM
*CWEOR
