*DECK PTPUN
          IDENT    PTPUN
          B7=1
          COMMENT   PUNCH 6 OR 8 CHANNEL PAPER TAPE
          ENTRY    PTPUN
*
*
*         PUNCH 6 OR 8 CHANNEL TAPE FROM A FORTRAN PROGRAM
*
*         CALL PTPUN(IUN,IDATA,NWD,MODE,FORMAT,CONVA)
*             WHERE - IUN = FILE NAME OR NUMBER
*                     IDATA = FWA OF USERS ARRAY
*                     NWD = NUMBER OF WORDS TO BE WRITTEN
*                     MODE = PS = PUNCH 6 CHANNEL TAPE
*                            PT = PUNCH 8 CHANNEL TAPE
*                     FORMAT = FWA OF FORMAT TO BE USED
*                     CONVA = FWA OF CONVERSION ARRAY
*
*
*
*         FORTRAN EXTENDED ENTRY
*
AZERO     DATA     0
TRACE.    VFD      42/0LPTPUN,18/PTPUN
PTPUN     DATA     0
          SX6      A0
          SA6      AZERO          SAVE A0
          SA2      A1+1
          SX6      X2
          SA6      FWA            FWA OF USERS ARRAY
          ZR       X6,ENDIT
          SA2      A1+2
          SA3      X2
          SX7      X3
          SA7      NWDS           NUMBER OF WORDS TO BE TRANSFERRED
          ZR       X7,ENDIT
          SA2      A1+3
          SA3      X2
          SX6      X3
          SA6      MODE           PUNCHING MODE TO BE USED
          ZR       X6,ENDIT
          MX6      0
          SA6      BFADD
          SA6      CONVA
          SA2      A1+4
          SX6      X2
          SA6      BFADD          FWA OF USERS FORMAT
          ZR       X6,BINWR
          SA2      A1+5
          SX6      X2
          SA6      CONVA          FWA OF CONVERSION ARRAY
          ZR       X6,ENDIT
BINWR     RJ       MAIN
          SA1      AZERO
          SA0      X1             RESTORE A0
          EQ       PTPUN
*
ENDIT     SX1      PEMSG          PARAMETER ERROR
          EQ       ERREX
          EJECT
*
*
*         THE ROUTINE MAIN PACKS DATA AND SENDS IT TO THE PUNCH FILE
*
MAIN      DATA     0
          RJ       SETBWS
          RJ       INITTP
STARTD    SA1      BFADD
          ZR       X1,BINARY      SKIP IF BINARY FORMAT
NPOF      RJ       GNFP           GET NEXT FORMAT PARAMETER
          SA1      FPTYPE
          SB6      B0
LOOPB     SA2      B6+LETLIST
          BX3      X1-X2
          ZR       X3,CFF
          SB6      B6+B7
          EQ       LOOPB
CFF       SA1      FW
          SB1      X1             B1 = FIELD WIDTH
          JP       B6+LETSW
*
*         DECODE A AND L FORMATS
*
FORMAL    MX0      6
          LX0      6
ANW       SB2      B0
          SA1      NWT
          SB5      X1
          SA1      FWA
          SA1      X1+B5
ALOOP     LX1      6
          BX2      X1*X0
          RJ       PACK
          SB2      B2+B7
          LT       B2,B1,ALOOP
          RJ       CKIT
          EQ       ANW
*
*         DECODE I FORMATS
*
FORMI     MX0      48
          LX0      48
INW       SB2      B1
          SA1      NWT
          SB5      X1
          SA1      FWA
          SA1      X1+B5
          PL       X1,INSET
          BX1      -X1
          SX2      MINUS
          SB2      B2-B7
          EQ       B2,B0,INR
          RJ       PACK
          EQ       INSET
INR       SX2      ASTRX
          RJ       PACK
INWE      RJ       CKIT
          EQ       INW
INSET     BX1      X1*X0
INWA      SB3      0
          SA2      B2+FWTA
INWB      IX1      X1-X2
          NG       X1,INWC
          SB3      B3+B7
          EQ       INWB
INWC      IX1      X1+X2
          SX2      B3
          SB4      10
          LT       B3,B4,INWD
          SX2      AM33B
INWD      SX3      ZERO
          IX2      X2+X3
          RJ       PACK
          SB2      B2-B7
          EQ       B2,B0,INWE
          EQ       INWA
*
*         DECODE O FORMATS
*
FORMO     MX0      3
          LX0      3
ONW       SB2      B0
          SA1      NWT
          SB5      X1
          SA1      FWA
          SA1      X1+B5
          SB3      20
          SB4      B1
OLOOP     SB4      B4+B7
          LT       B3,B4,KOKO
          LX1      3
          EQ       OLOOP
KOKO      LX1      3
          BX2      X1*X0
          SX3      ZERO
          IX2      X2+X3          MAKE IT A DISPLAY CODE NUMBER
          RJ       PACK
          SB2      B2+B7
          LT       B2,B1,KOKO
          RJ       CKIT
          EQ       ONW
*
*         DECODE R FORMATS
*
FORMR     MX0      6
          LX0      6
RNW       SB2      B0
          SA1      NWT
          SB5      X1
          SA1      FWA
          SA1      X1+B5
          SB3      10
          SB4      B1
RLOOP     SB4      B4+B7
          LT       B3,B4,OKOK
          LX1      6
          EQ       RLOOP
OKOK      LX1      6
          BX2      X1*X0
          RJ       PACK
          SB2      B2+B7
          LT       B2,B1,OKOK
          RJ       CKIT
          EQ       RNW
*
*         DECODE X FORMATS
*
FORMX     SA1      NIS
          SB1      X1
          SB2      B0
XNW       SX2      SPACE
          RJ       PACK
          SB2      B2+B7
          LT       B2,B1,XNW
          EQ       NPOF
*
*         DECODE BINARY DATA
*
BINARY    SA1      FWA
          SA1      X1
          SB2      B0             BYTE/CHARACTER INDEX
          SA2      PCC
          SB1      X2
          SB3      10
          EQ       B1,B3,SIXBB    SIX BIT MODE
          MX0      12             NO
          LX0      12             FORM MASK FOR 8 BIT BINARY
          EQ       BININB
SIXBB     MX0      6
          LX0      6              FORM MASK FOR 6 BIT BINARY
          EQ       BININB
BININ     SA1      A1+1
BININB    LX1      6
          SB3      10
          EQ       B1,B3,GOPACK
          LX1      6
GOPACK    BX2      X1*X0          MASK OFF CHARACTER
          RJ       PACK
          RJ       CKIT
          SB2      B2+B7
          NE       B2,B1,BININB
          SB2      B0
          EQ       BININ
*
CKIT      DATA     0
          SA3      NWT
          SX4      B7
          IX6      X3+X4          INCREMENT NWT
          SA6      NWT
          SA5      NWDS
          IX5      X5-X6
          ZR       X5,THRU        HAS EVERYTHING BEEN TRANSFERRED
          SA3      NIS            NO
          IX6      X3-X4          DECREMENT NIS
          SA6      NIS
          ZR       X6,NPOF        IS THIS FORMAT PARAMETER ALL USED
          EQ       CKIT           NO
*
PACK      DATA     0
          SA3      PC
          NZ       X3,GOON        IS CURRENT BUFFER WORD EMPTY
          SA3      PCC            YES
          BX6      X3
          SA6      PC
GOON      SA4      BUFFP
          SB6      X4
          SA4      B6+BUFF
          LX4      6
          SA5      PCC
          SB5      X5
          SB4      10
          EQ       B4,B5,ONESH    8 CHANNEL MODE
          LX4      6              YES
ONESH     SA5      CONVA          NO
          SB4      X5
          EQ       B4,B0,NOCON    HAS A CONVERSION ARRAY BEEN GIVEN
          ZR       X2,NOCON       YES, IS THE CHARACTER THERE
          SX2      X2-1
          SA2      X2+B4          YES, GET CONVERTED CHARACTER
NOCON     BX6      X4+X2          MERGE IN NEW CHARACTER
          SA6      B6+BUFF
          SX5      B7
          IX6      X3-X5          DECREMENT PC
          SA6      PC
          ZR       X6,EMPTY
          EQ       PACK
EMPTY     SB6      B6+B7
          SB5      10
          SX6      B6
          SA6      BUFFP          INCREMENT BUFFER POINTER
          EQ       B6,B5,PBFULL   IS THE BUFFER FULL
          EQ       PACK           NO
PBFULL    RJ       FILBUF         YES, PUT DATA INTO PUNCH BUFFER
          SX6      B0
          SA6      BUFFP          CLEAR BUFFER POINTER
          EQ       PACK
*
THRU      SA1      BUFFP
          SA2      PC
          IX3      X1+X2
          ZR       X3,FINIS       ANY LEFT IN BUFFER
          ZR       X2,FNOW        YES
          SA3      X1+BUFF
          SB6      X2
          SA4      PCC
          SB5      X4
          SB4      10
THRUL     LX3      6              LEFT JUSTIFY LAST BUFFER WORD
          EQ       B4,B5,NSS
          LX3      6
NSS       SB6      B6-B7
          NE       B6,B0,THRUL
          BX6      X3
          SA6      A3
FNOW      RJ       FILBUF
FINIS     EQ       MAIN
*
ERREX     MESSAGE   X1,,RCL   ISSUE DIAGNOSTIC MESSAGE
          ABORT                   DROP JOB
          EJECT
*
*
*         THE ROUTINE SETBWS SETS ALL INITIAL VALUES FOR EACH CALL
*
SETBWS    DATA     0
          SB7      1
          MX6      0
          SA6      BUFFP          CLEAR BUFFER POINTER
          SB6      9
LOOP      SA6      B6+BUFF        CLEAR BUFFER
          SB6      B6-B7
          GE       B6,B0,LOOP
          SA6      NWT            CLEAR NUMBER OF WORDS TRANSFERRED
          SA6      WDPOS          CLEAR FORMAT WORD POSITION
          SX6      ELEVEN
          SA6      CHPOS          CHARACTER POSITION = 11
          MX0      6
          LX0      6
          SB2      B0
          SB3      X6
          SB4      10
          SB5      B0
          MX6      0
L         SA2      BFADD
          ZR       X2,SETBWS      EXIT IF NO FORMAT SPECIFIED
          SA3      B5+X2
LL        LX3      6
          SB3      B3-B7
          NE       B3,B0,LLL
          SB3      11
          SB5      B5+B7
          EQ       L
LLL       BX4      X3*X0
          SX5      OPENB
          BX5      X4-X5
          ZR       X5,START
          SX5      SPACE
          BX5      X4-X5
          ZR       X5,LL          IGNORE SPACES
NONO      SX1      FEMSG
          EQ       ERREX
START     LX3      6              OPENING BRACKET FOUND
          SB3      B3-B7
          NE       B3,B0,STL
          SB3      11
          SB5      B5+B7
          SA3      B5+X2
          EQ       START
STL       BX4      X3*X0
          SX5      SPACE
          BX5      X4-X5
          ZR       X5,START       IGNORE SPACES
          SX5      OPENB
          BX5      X4-X5
          ZR       X5,NONO        NO STACKING ALLOWED
          SX5      CLOSB
          BX5      X4-X5
          ZR       X5,EOFT
          LX6      6
          BX6      X6+X4
          SB4      B4-B7
          NE       B4,B0,START
          SA6      B2+FORBUF
          MX6      0
          SB4      10
          SB2      B2+B7
          EQ       START
EOFT      LX6      6              END OF FORMAT
          BX6      X6+X4
EOFTL     SB4      B4-B7
          EQ       B4,B0,FST
          LX6      6
          EQ       EOFTL
FST       SA6      B2+FORBUF
          EQ       SETBWS
          EJECT
*
*
*         THE ROUTINE INITTP SEARCHES FOR FILE
*         IF THIS IS THE FIRST TIME THROUGH THEN OPEN FILE
*
INITTP    DATA     0
*
*         SEARCH FOR FILE AND STORE FET ADDRESS
*
+         RJ     =XGETFIT.
-         VFD    30/TRACE.
          BX6    X1           SAVE FIT ADDRESS
          SA0    X1
          SA6    FET
*
*         CHECK FOR FIRST TIME
*
          FETCH  A0,OC,X2
          NZ     X2,INITTP    EXIT, IF NOT FIRST TIME CALLED
*
*         REQUEST PAPER TAPE PUNCH FILE
*
          SA3    A0           FILENAME
          MX1    42
          BX6    X3*X1
          SA6    DSPRM       STORE LFN FOR DSP
          SX1    FIVE
          SX2    21B         SET FLAGS FOR DC
          SX5    2RPT
          SA4    MODE
          SX6    PS
          BX4    X4-X6
          NZ     X4,CORDC     JUMP IF 8 CHANNEL MODE
           SX5    2RPS
          SX1    TEN
CORDC     LX5    24          SHIFT MODE BITS
          BX7    X2+X5       COMBINE
          SA7    DSPRM+1
          BX6      X1
          SA6      PCC            SET PACKING LIMIT
          MX6      0
          SA6      PC             ZERO PACKING COUNTER
*
*  NOS/BE - ISSUE DEFERRED ROUTE TO SET APPROPRIATE DISP. CODE
*
*  NOS    - DO NOT ROUTE. FILE WILL BE LEFT LOCAL AT END OF JOB STEP
*
*IF -DEF,NOS,1
          ROUTE  DSPRM,RCL   SET DISPOSITION CODE FOR FILE
*
*         OPEN THE FILE
*
          STORE  A0,RT=U
          STORE  A0,BT=C           SCOPE STANDARD
          OPENM  A0,OUTPUT,N,SQ    OPEN THE FILE
          SB7    B1           RESET B7
*
          EQ       INITTP
*
NOFILE    SX1      NEMSG
          EQ       ERREX
BUFLER    SX1      BEMSG
          EQ       ERREX
          EJECT
*
*
*         THE ROUTINE FILBUF PACKS THE DATA INTO THE FILE
*
FILBUF    DATA     0
          SX6    A1           SAVE A1,X1 AND B1
          BX7    X1
          SA6    SAVEA1
          SA7    SAVEX1
          SX6    B1
          BX7    X0
          SA6    SAVEB1
          SA7    SAVEX0
          SX6    B2
          SA6    SAVEB2
          SA3    BUFFP
          SX4    10
          DX5    X3*X4        NO OF CHARACTERS IN BUFFER
          SA3    PC
          ZR     X3,FILB2
          SA4    PCC
          SX0    10
          IX6    X4-X3        NO OF CHARACTERS IN FINAL WORD
          IX5    X5+X6
          IX0    X4-X0
          ZR     X0,FILB1
          IX5    X5+X6
FILB1     MX6    0
          SA6    PC
FILB2     SA2    FET         X2 = FIT ADDRESS
          PUT    X2,BUFF,X5
          SB7    B1           RESET B7
          MX6    0
          SB6    9
FILB3     SA6    BUFF+B6
          SB6    B6-B7        ZERO OUT BUFFER
          GE     B6,B0,FILB3
          SA1    SAVEA1
          SA5    SAVEX1
          SA3    SAVEB1       RESTORE A1,X1 AND B1
          SA4    SAVEX0
          SA2    SAVEB2
          SA1    X1
          SB1    X3
          BX1    X5
          BX0    X4
          SB2    X2
          EQ       FILBUF         EXIT
          EJECT
*
*
*         THE ROUTINE GNFP GETS THE NEXT FORMAT PARAMETER
*
GNFP      DATA     0
          SB1      B0
          SB2      B0
          SB3      B0
          MX0      6
          LX0      6              X0 = CHARACTER MASK
          SA1      WDPOS          X1 = CURRENT FORMAT WORD POSITION
          SA2      X1+FORBUF      X2 = CURRENT FORMAT WORD
          SA3      CHPOS          X3 = CURRENT CHARACTER COUNTER
          SX4      B7             X4 = 1
BACKB     IX3      X3-X4          DECREMENT CHARACTER COUNT
          NZ       X3,SAMEW       HAS ALL THE CURRENT WORD BEEN READ
          BX6      X2
          SA6      A2             RESTORE FORMAT WORD
          SX3      TEN
          IX1      X1+X4          INCREMENT WORD COUNT
          SA2      X1+FORBUF      READ NEXT FORMAT WORD
SAMEW     LX2      6
          BX6      X2*X0          MASK OFF CHARACTER
          SX5      SPACE
          BX5      X6-X5
          ZR       X5,BACKB       IS IT A SPACE
          SX5      CLOSB          NO
          BX5      X6-X5
          ZR       X5,EOFO        IS IT A )
          SX5      COMM           NO
          BX5      X6-X5
          ZR       X5,COMMA       IS IT A ,
          SX5      ZERO           NO
          IX5      X6-X5
          NG       X5,LETT        IS IT A LETTER
          SX5      SPEC           NO
          IX5      X6-X5
          NG       X5,NUMB        IS IT A NUMBER
FERR      SX1      TEMSG          ILLEGAL CHARACTER EXIT
          EQ       ERREX
*
EOFO      IX3      X3-X4
          NZ       X3,MORES
          BX6      X2
          SA6      A2             RESET CURRENT FORMAT WORD
          SX3      ELEVEN         RESET CURRENT CHARACTER COUNTER
          MX1      0              RESET CURRENT FORMAT WORD POSITION
          NE       B2,B0,STUF
          SA2      X1+FORBUF
          EQ       BACKB          RESTART THE FORMAT
MORES     LX2      6
          EQ       EOFO
STUF      NE       B1,B0,GOONA
          SB1      B7
GOONA     NE       B3,B0,FGNFP
          SB3      B7
FGNFP     BX6      X1
          SA6      WDPOS          STORE CURRENT FORMAT WORD POSITION
          BX6      X3
          SA6      CHPOS          STORE CURRENT CHARACTER COUNTER
          BX6      X2
          SA6      A2             STORE CURRENT FORMAT WORD
          SX6      B1
          SA6      NIS            STORE NUMBER IN SEQUENCE
          SX6      B2
          SA6      FPTYPE         STORE PARAMETER TYPE
          SX6      B3
          SA6      FW             STORE FIELD WIDTH
          EQ       GNFP           EXIT
*
COMMA     NE       B2,B0,STUF
          EQ       FERR
*
LETT      SB6      0
LETTL     SA5      B6+LETLIST
          ZR       X5,FERR        IF AT THE END OF THE LIST, EXIT
          BX5      X6-X5
          ZR       X5,LETOK       IS THE LETTER OK
          SB6      B6+B7          NO, INCREMENT COUNTER
          EQ       LETTL
LETOK     SB2      X6             B2 = TYPE
          EQ       BACKB
*
NUMB      SX5      ZERO
          IX6      X6-X5
          NE       B2,B0,SECN
          SX5      B1
          LX5      3
          SX7      B1
          IX5      X5+X7
          IX5      X5+X7
          IX5      X5+X6
          SB1      X5
          EQ       BACKB
SECN      SX5      B3
          LX5      3
          SX7      B3
          IX5      X5+X7
          IX5      X5+X7
          IX5      X5+X6
          SB3      X5
          EQ       BACKB
          EJECT
*
*
*         STORAGE AND CONSTANTS
*
FWA       DATA     0              FWA OF USERS ARRAY
NWDS      DATA     0              NUMBER OF WORDS TO BE TRANSFERRED
MODE      DATA     0              PUNCHING MODE
BFADD     DATA     0              FWA OF USERS FORMAT
CONVA     DATA     0              FWA OF CONVERSION ARRAY
*
FET       DATA     0              PUNCH FILE FET ADDRESS
SWDCT     DATA     0              TEMPORARY STORE IN FILBUF
SAVEA1    DATA     0
SAVEX1    DATA     0
SAVEB1    DATA   0
SAVEX0    DATA   0
SAVEB2    DATA    0
*
WDPOS     DATA     0              CURRENT FORMAT WORD POSITION
CHPOS     DATA     0              CURRENT CHARACTER POSITION
NIS       DATA     0              NUMBER IN SEQUENCE
FPTYPE    DATA     0              FORMAT PARAMETER TYPE
FW        DATA     0              FIELD WIDTH
*
NWT       DATA     0              NUMBER OF WORDS ALREADY TRANSFERRED
PC        DATA     0              CURRENT PACKING POSITION
PCC       DATA     0              PACKING LIMIT
BUFFP     DATA     0              BUFFER POINTER
BUFF      BSSZ     10
*
FORBUF    BSSZ     20
*
MSGCALL   VFD      18/3LMSG,2/3B,40/0
PEMSG     DIS      ,*PTPUN - INCORRECT CALL*
NEMSG     DIS      ,*PTPUN - BUFFER NOT FOUND*
BEMSG     DIS      ,*PTPUN - BUFFER TOO SMALL*
TEMSG     DIS      ,*PTPUN - ILLEGAL FORMAT PARAMETER TYPE*
FEMSG     DIS      ,*PTPUN - ILLEGAL FORMAT DEFINITION*
*
FIVE      EQU      5
TEN       EQU      10
ELEVEN    EQU      11
AM33B     EQU      14B
ZERO      EQU      33B
SPEC      EQU      45B
MINUS     EQU      46B
ASTRX     EQU      47B
OPENB     EQU      51B
CLOSB     EQU      52B
SPACE     EQU      55B
COMM      EQU      56B
*
FWTA      DATA     0
          DATA     1
          DATA     10
          DATA     100
          DATA     1000
          DATA     10000
          DATA     100000
          DATA     1000000
          DATA     10000000
          DATA     100000000
          DATA     1000000000
          DATA     10000000000
          DATA     100000000000
          DATA     1000000000000
          DATA     10000000000000
          DATA     100000000000000
LETLIST   DATA     01B            A
          DATA     11B            I
          DATA     14B            L
          DATA     17B            O
          DATA     22B            R
          DATA     30B            X
          DATA     00B            END OF LETTER LIST
LETSW     EQ       FORMAL
+         EQ       FORMI
+         EQ       FORMAL
+         EQ       FORMO
+         EQ       FORMR
+         EQ       FORMX
*
PS        EQU      2023B
PSPAR     VFD      24/0,12/0021B,24/0
PTPAR     VFD      24/0,12/0023B,24/0
DSPRM     BSSZ   2            DSP PARAMETERS
          END
