*DECK QUARTIC
      SUBROUTINE QUARTIC(AA,RRE,RIM)
      DIMENSION AA(5),RRE(4),RIM(4),A(4)
    4 FORMAT (31H0ILLEGAL COEFFICIENT IN QUARTIC)
    5 FORMAT (37H0QUARTIC DID NOT OBTAIN FULL ACCURACY)
*CALL STATF
      IF (AA(5).EQ.0) GO TO 200
      DO 10 N=2,5
      I=N-1
   10 A(I)=AA(N)/AA(1)
      N=1
      P=1.13
      Q=0.97
   50 B1=A(1)-P
      B2=A(2)-P*B1-Q
      B3=A(3)-P*B2-Q*B1
      B4=A(4)-P*B3-Q*B2
      C1=B1-P
      C2=B2-P*C1-Q
      C3=-P*C2-Q*C1
      D=C2*C2-C3*C1
      DELTAP=(B3*C2-B4*C1)/D
      DELTAQ=(B4*C2-B3*C3)/D
      IF (P.EQ.0) GO TO 60
      IF (Q.EQ.0) GO TO 65
      PA=ABS(P)
      QA=ABS(Q)
      DPA=ABS(DELTAP)
      DQA=ABS(DELTAQ)
      TESTA=1.0E-13
      TESTB=1.0E-12
      IF (PA.LT.TESTB*QA) GO TO 60
      IF (QA.LT.TESTB*PA) GO TO 65
      IF (DPA.LE.TESTA*PA.AND.DQA.LE.TESTA*QA) GO TO 100
      GO TO 90
   60 IF (DPA.LE.TESTB   .AND.DQA.LE.TESTA*QA) GO TO 100
      GO TO 90
   65 IF (DPA.LE.TESTA*PA.AND.DQA.LE.TESTB   ) GO TO 100
   90 P=P+DELTAP
      Q=Q+DELTAQ
      N=N+1
      IF (N.GT.20) GO TO 99
      GO TO 50
   99 PRINT 5
  100 S=A(4)/Q
      R=A(1)-P
      B=P
      C=Q
      M=0
      GO TO 500
  105 RRE(1)=RR1
      RIM(1)=RI1
      RRE(2)=RR2
      RIM(2)=RI2
      B=R
      C=S
      M=5
      GO TO 500
  110 RRE(3)=RR1
      RIM(3)=RI1
      RRE(4)=RR2
      RIM(4)=RI2
      RETURN
  200 PRINT 4
      RETURN
  500 X=B*B-4.*C
      IF (X) 510,600,700
  700 RI1=RI2=0
      X=SQRT(X)
      BA=ABS(B)
      IF (BA.EQ.B) GO TO 250
      RR1=(-B+X)/2.
      GO TO 260
  250 RR1=(-B-X)/2.
  260 RR2=C/RR1
      GO TO 800
  510 RR1=RR2=-B/2.
      RI1=SQRT(ABS(X))/2.
      RI2=-RI1
      GO TO 800
  600 RI1=RI2=0
      RR1=RR2=-B/2.
  800 IF (M) 105,105,110
      END
