*DECK RESET
          IDENT RESET
*
*     CALL RESET(A,B,I,J)    SET A BLOCK OF CORE FROM A TO B WITH THE
*             SET PATTERN 60000 00000 40040 0000 + IJKLMN
*             WHERE IJKLMN IS THE ADDRESS OF THAT WORD
*
*             I =0 IF A IS A VARIABLE  , 1 IF A IS NUMERIC ADDRESS
*             J =0 IF B IS A VARIABLE  , 1 IF ADDRESS  ,  -1 IF COUNT
*
*                     M B CARVER MAY 1972
*                     MODIFIED BY D.G. STEWART 1982
*
          ENTRY RESET
          VFD 42/0LRESET,18/RESET
RESET     DATA 0
          SB1 1
          SA2 A1+B1          SET UP PARAMETERS
          SA3 A2+B1
          SA4 A3+B1
          SA3 X3                   X3 CONTAINS I
          SA4 X4                   X4 CONTAINS J
          ZR X4,L1
          SA2 X2                   X2 = STARTING ADDRESS OF B
L1        ZR X3,L2
          SA1 X1                   X1 = STARTING ADDRESS OF A
L2        PL X4,L3                 IF B IS A COUNT
          IX2 X1+X2                ADDRESS OF A + COUNT
          SX2 X2-1                 -1
L3        SA3 SETPAT
          SX4 B1
*    X1  =  STARTING ADDRESS TO BE SET
*    X2  =  LAST ADDRESS TO BE SET
*    FILL THE BLOCK FROM BOTH ENDS
SET       BX6 X3+X1                SET PATTERN + TOP ADDRESS
          IX5 X2-X1
          SA6 X1
          BX7 X3+X2                SET PATTERN + BOTTOM ADDRESS
          IX1 X1+X4                ADD ONE TO THE TOP ADDRESS
          SA7 X2
          IX2 X2-X4                SUBTRACT ONE FROM THE BOTTOM ADDRESS
          ZR X5,RESET              IF X5 = 0 WE ARE FINISHED
          PL X5,SET                IF NEGATIVE MORE TO SET
          EQ RESET                 ELSE IF POSITIVE ALSO FINISHED
SETPAT    DATA 60000000000400400000B
          END
