*DECK SORTAG
      SUBROUTINE SORTAG(A,II,JJ,TAG)
C  SORTS ARRAY A INTO INCREASING ORDER, FROM A(II) TO A(JJ)
C  ARRAY TAG IS PERMUTED THE SAME AS ARRAY A
C  ORDERING IS BY INTEGER SUBTRACTION, THUS FLOATING POINT
C    NUMBERS MUST BE IN NORMALIZED FORM.
C  ARRAYS IU(K) AND IL(K) PERMIT SORTING UP TO 2**(K+1)-1 ELEMENTS
      DIMENSION A(1),IU(16),IL(16),TAG(1)
      INTEGER A,T,TT
*CALL  STATF
      IFLAG=1
      GO TO 2
*IF -DEF,AELIB5
      ENTRY DESORT
*ENDIF
*IF DEF,AELIB5
      ENTRY DESORT(A,II,JJ,TAG)
*ENDIF
C  SORTS ARRAY A INTO DESCENDING ORDER,FROM A(JJ) TO A(II)
      IFLAG=-1
    2 M=1
      I=II
      J=JJ
    5 IF (I .GE. J) GO TO 70
   10 K=I
      IJ=(J+I)*.5
      T=A(IJ)
      IF (A(I) .LE. T) GO TO 20
      A(IJ)=A(I)
      A(I)=T
      T=A(IJ)
      TG=TAG(IJ)
      TAG(IJ)=TAG(I)
      TAG(I)=TG
   20 L=J
      IF (A(J) .GE. T) GO TO 40
      A(IJ)=A(J)
      A(J)=T
      T=A(IJ)
      TG=TAG(IJ)
      TAG(IJ)=TAG(J)
      TAG(J)=TG
      IF (A(I) .LE. T) GO TO 40
      A(IJ)=A(I)
      A(I)=T
      T=A(IJ)
      TG=TAG(IJ)
      TAG(IJ)=TAG(I)
      TAG(I)=TG
      GO TO 40
   30 A(L)=A(K)
      A(K)=TT
      TG=TAG(L)
      TAG(L)=TAG(K)
      TAG(K)=TG
   40 L=L-1
      IF(A(L) .GT. T) GO TO 40
      TT=A(L)
   50 K=K+1
      IF(A(K) .LT. T) GO TO 50
      IF (K .LE. L) GO TO 30
      IF (L-I .LE. J-K) GO TO 60
      IL(M)=I
      IU(M)=L
      I=K
      M=M+1
      GO TO 80
   60 IL(M)=K
      IU(M)=J
      J=L
      M=M+1
      GO TO 80
   70 M=M-1
      IF(M .EQ. 0) GO TO 110
      I=IL(M)
      J=IU(M)
   80 IF (J-I .GE. 11) GO TO 10
      IF(I .EQ. II) GO TO 5
      I=I-1
   90 I=I+1
      IF(I .EQ. J) GO TO 70
      T=A(I+1)
      IF (A(I) .LE. T) GO TO 90
      TG=TAG(I+1)
      K=I
  100 A(K+1)=A(K)
      TAG(K+1)=TAG(K)
      K=K-1
      IF(T .LT. A(K)) GO TO 100
      A(K+1)=T
      TAG(K+1)=TG
      GO TO 90
 110  IF (IFLAG .GT. 0) GO TO 130
 120  J=II+(JJ-II-1)*.5
      J1=JJ
      DO 140 I=II,J
      T=A(J1)
      A(J1)=A(I)
      A(I)=T
      TG=TAG(J1)
      TAG(J1)=TAG(I)
      TAG(I)=TG
 140  J1=J1-1
  130 RETURN
      END
