*DECK TIMEIO
          IDENT    TIMEIO
*        TIMEIO - RETURNS IO TIME USED BY THE PROGRAM AS A REAL NUMBER (
*
*        OR IO TIME LEFT IN THE PROGRAM AS A REAL NUMBER(N=2)
*
*             IE TL=TIMEIO(N)
*
*             DEFAULT(N=1)
*
*             AUTHOR D.G. STEWART
*             DATE NOVEMBER,1974
*
*             REVISED 28/04/81 BY D.G. STEWART
*             TO RETURN TIME LEFT = 32767. WHEN
*             IO0 OR IO32767 ON JOB CARD.
*
*
          ENTRY TIMEIO
TIMEIO    DATA 0
          SA4 X1
          SB2 X4                   PARAMETER FROM CALL TIMEIO IN B2
          SB6 2
*
*   ON NOS/BE USE IOTIME MACRO TO GET JOB CARD IO AND ELAPSED IO
*
*   ON NOS, USE GETJA MACRO TO GET MS UNITS; USE KILO-UNITS AS
*   ANALOGUE OF NOS/BE IO TIME; SET *IO TIME LEFT* TO 32767
*
*IF -DEF,NOS
*
          IOTIME LIST1
          MX2 12
          SA5 LIST1
          LX2 12
          BX3 X2*X5                IO MILLISECONDS USED IN X3
          PX2 B0,X3
          NX3 B0,X2                IO MILLISECONDS(DECIMAL) USED
          SA4 =.001
          FX6 X3*X4                MILLISECONDS * .001 = SECONDS
          MX2 24
          AX5 12
          LX2 24
          BX4 X2*X5                IO SECONDS USED IN X4
          PX2 B0,X4
          NX4 B0,X2                IO SECONDS(DECIMAL) USED
          FX3 X4+X6                ADD TO GET TOTAL SECONDS USED
*ENDIF
*IF DEF,NOS
          GETJA   LIST1
          SA5     LIST1+2
          MX0     20
          BX5     X0*X5
          LX5     20
          PX2     B0,X5
          SA4     =.001
          NX3     B0,X2
          FX3     X4*X3
*ENDIF
          EQ B6,B2,TLEF            GO TO TLEF TO OUTPUT TIME REMAINING
          BX6 X3                   OUTPUT IO TIME USED IN SECONDS
          EQ TIMEIO
TLEF      AX5 24                   IO ON JOB CARD LEFT IN X5
          SB5 X5
          SB4 32767                IF  IO32767
          EQ B4,B5,INF                OR
          NZ X5,NOZERO             IO0 ON JOB CARD FOR INFINITE TIME
          SX5 B4                   SET IO TIME LEFT TO 32767(77777B)
INF       PX2 B0,X5
          NX6 B0,X2
          EQ TIMEIO
NOZERO    PX2 B0,X5
          NX1 B0,X2                DECIMAL OF IO TIME ON JOB CARD IN X1
          FX6 X1-X3                X6 = IO TIME LIMIT - IO TIME USED
          EQ TIMEIO
LIST1     VFD 24/0,24/0,12/0
*IF DEF,NOS,1
          BSS     3
          END
