*DECK TRIEQN
      SUBROUTINE TRIEQN (DIAG,SUP,SUB,B,N)
C    SUBROUTINE SOLVES AX=B FOR THE VECTOR X(WHERE A IS TRIDIAGONAL)
C   M=ORDER OF SYSTEM
C   MN=DIMENSION OF SYSTEM IN CALLING PROGRAM
C   SUP=SUPER DIAGONAL OF A
C   SUB=SUB DIAGONAL OF A
C   DIAG=MAIN DIAGONAL OF A
C   B=CONSTANT VECTOR
C   SUP AND DIAG ARE DESTROYED.  THE SOLUTION VECTOR IS RETURNED IN B.
      DIMENSION DIAG(1),SUP(1),SUB(1),B(1)
*CALL  STATF
      NN=N-1
      SUP(1)=SUP(1)/DIAG(1)
      B(1)=B(1)/DIAG(1)
      DO 10 I=2,NN
C   DECOMPOSE A TO FORM A=LU WHERE L IS LOWER TRIANGULAR,U IS UPPER
C   TRIANGULAR
      DIAG(I)=1./(DIAG(I)-SUP(I-1)*SUB(I-1))
      SUP(I)=SUP(I)*DIAG(I)
C   COMPUTE Z WHERE LZ=B
   10 B(I)=(B(I)-SUB(I-1 )*B(I-1))*DIAG(I)
      B(N)=(B(N)-SUB(NN)*B(NN))/(DIAG(N)-SUP(NN)*SUB(NN))
C   COMPUTE X BY BACK SUBSTITUTION WHERE UX=Z
      DO 20 II=1,NN
      I=N-II
   20 B(I)=B(I)-SUP(I)*B(I+1)
      RETURN
      END
