*DECK XPI
      DOUBLE PRECISION FUNCTION XPI(X)
C
C X----REAL
C
C THIS FUNCTION COMPUTES THE PRODUCT X*PI TO DOUBLE PRECISION WHERE
C X IS A REAL VARIABLE. IF X IS EXACTLY REPRESENTIBLE INTERNALLY IN
C SINGLE PRECISION, FOR EXAMPLE 1.0, 0.5, OR 0.25, THE RESULT IS CORRECT
C TO DOUBLE PRECISION. IF NOT, IT IS ONLY CORRECT TO SINGLE PRECISION.
C TO OBTAIN THE DOUBLE PRECISION RESULT, THE CALLING PROGRAM MUST
C DECLARE XPI TO BE DOUBLE PRECISION. IF IT DOES NOT, THE RESULT IS
C TRUNCATED TO SINGLE PRECISION, NOT ROUNDED.
C
C PROGRAMMED BY J.M.BLAIR   MARCH, 1974
C
C EXAMPLE TO OBTAIN PI TO DOUBLE PRECISION, USE THE STATEMENTS
C             DOUBLE PRECISION PI,XPI
C             PI=XPI(1.0)
C
*CALL  STATF
      XPI=DBLE(X)*3.14159265358979323846264338328D0
      RETURN
      END
