*DECK AELERTX
          IDENT AELERTX
           STEXT
*
*   THIS TEXT CONTAINS ERROR MESSAGES FOR AELIB ROUTINES
*
*   TO SET UP ERROR MESSAGES USE MACRO ERMSG -
*XXX      ERMSG   (THIS IS AN ERROR MESSAGE)
*
*   ACTUAL ERROR MESSAGE NUMBER ASSIGNED WILL BE XXX.
*
           MACRO   ERMSG,NO,PP
ERR_NO     EQU     NO
ERR_NO     MICRO   1,,$_PP_$
           ENDM
           SPACE   4,8
*    LIST ERROR MESSAGES HERE          USE ' FOR REPLACEMENT CHARACTER.
          SPACE  2
*     ERROR NUMBERS 1 TO 49 ARE FOR GENERAL MESSAGES
01        ERMSG    ( ERROR NUMBER ' IN AELIB ROUTINE ')
02    ERMSG   (1THE FOLLOWING AELIB NON-FATAL ERRORS WERE ENCOUNTERED)
03        ERMSG  ( TIMES ENCOUNTERED                    ERROR)
04        ERMSG  ( UNUSEABLE OUTPUT FILE WHEN PRINTING AELIB ERROR SUMMA
,RY)
05        ERMSG  ( NO OUTPUT FILE FOUND WHEN PRINTING AELIB ERROR SUMMAR
,Y)
19    ERMSG   ( ***AELERR TEST-NO INSERTIONS)
20    ERMSG   ( ***AELERR TEST-1 INSERTION-')
21    ERMSG   ( ***AELERR TEST-2 INSERTIONS- ', ')
22    ERMSG   ( ***AELERR TEST-3 INSERTIONS- ', ', ')
23    ERMSG   ( ***AELERR TEST-4 INSERTIONS- ', ', ', ')
24    ERMSG   ( ***AELERR TEST-5 INSERTIONS- ', ', ', ', ')
*     MATHEMATICAL CONSTANTS ERROR MESSAGES - NUMBER 50 TO 99
*     FLPT    1-01-01
50    ERMSG   ( ***ILLEGAL VALUE FOR I : 1@I@4)
      SPACE    2,8
*     SPECIAL MATHEMATICAL AND STATISTICAL FUNCTIONS- NUMBERS 100 TO 299
      SPACE   1
*     GAMMA   1-4-20  (A-5-7)
0120  ERMSG   ( ***ARGUMENT OUTSIDE BOUNDS FOR GAMMA FUNCTION : -164.1@X
,@177.8)
0121  ERMSG   ( ***GAMMA FUNCTION FAILS FOR ARGUMENT ZERO OR A NEGATIVE
,INTEGER. YOUR ARGUMENT = ' )
      SPACE    2
0200  ERMSG   ( ***ILLEGAL ARGUMENT FOR BESSEL FUNCTION)
*     BESGEN  1-4-48 (A-8-6)
205   ERMSG   ( ***BESGEN HAS ONLY CALCULATED THE FIRST NCALC ELEMENTS.
, ALL OTHER ELEMENTS ARE SET TO INFINITY.)
206   ERMSG   ( ***ILLEGAL ARGUMENT SENT TO BESGEN . VALID ARGUMENTS ARE
, N \ 2 , 0. @ X @ 677.5 , M= +1 OR M= -1 )
*     AKI1  1-4-60 (A-8-20), AKI3  1-4-61 (A-8-21), KIN  1-4-62 (A-8-22)
0250  ERMSG   ( ***ILLEGAL ARGUMENT FOR BICKLEY FUNCTION)
      SPACE   2,8
*   PHYSICS FUNCTIONS ERROR MESSAGES - NUMBER 300 TO 399
      SPACE   1
*     GLINT   1-5-01  (A-9-6)
305   ERMSG   ( ***ILLEGAL VARIABLE FOR GLINT)
306   ERMSG   ( ***THIS BRANCH OF GLINT GIVES REL. ACCURACY BETTER THAN
,1 IN 10**7)
      SPACE   2,8
*   MATRIX MANIPULATION ERROR MESSAGES - NUMBERS 500 TO 599
      SPACE   1
*     JACOB   1-7-11 (C-4-14)
0550  ERMSG   ( ***ERROR RETURN FROM JACOB BECAUSE IA IS TOO SMALL)
      SPACE   2,8
*   LINEAR SYSTEMS ERROR MESSAGES - NUMBERS  600 TO 799
      SPACE   1
*     OCSOLVE 1-8-04  (C-4-26)
0650  ERMSG   ( ***SINGULAR MATRIX IN OCSOLVE)
0651  ERMSG   ( ***ILLEGAL ARGUMENT IN OCSOLVE, INFINITE OR INDEFINITE
,IN MATRIX OR RIGHT HAND SIDE)
      SPACE   2,8
*   NONLINEAR SYSTEMS ERROR MESSAGES - NUMBERS 1000 TO 1199
      SPACE   1
*     NLSPAR  1-10-31 (C-4-18)
1100  ERMSG   ( ***MORE THAN MAXFUN CALLS OF FUNCTION NEEDED )
1101  ERMSG   ( ***WORKSPACE W IS TOO SMALL )
1102  ERMSG   ( ***CALL OF NLSPAR WITH IE=0 DOES NOT PRECEDE THE IE"0 CA
,LL )
1105  ERMSG   ( ***INTEGER WORD LENGTH LIMITATION RENDERS THIS PROBLEM U
,NSOLVABLE)
      SPACE   1
*     PDSPARL 1-8-23  (C-4-19)
1110  ERMSG   ( ***THE ELEMENT HELD IN A( ' ) IS OUT OF ORDER )
1111  ERMSG   ( ***ZERO PIVOT FOUND IN ROW '  )
1112  ERMSG   ( ***IA IS TOO SMALL. SPACE RAN OUT WHEN ELIMINATING ON PI
,VOT '  )
1113  ERMSG   ( ***THE 'TH DIAGONAL ELEMENT IS NOT PRESENT )
1114  ERMSG   ( ***RESULT MAY BE UNRELIABLE SINCE THERE IS A NEG PIVOT I
,N ROW '  )
1115  ERMSG   ( ***PREVIOUS ENTRY GAVE ERROR RETURN )
1116  ERMSG   ( ***RESULT MAY BE UNRELIABLE SINCE THERE IS A NEG PIVOT )
1117  ERMSG   ( ***WARNING: IENT"1/2/3; EXECUTION PROCEEDS AS IF IENT=1)
      SPACE   2,8
*     FITTING USER SPECIFIED FUNCTIONS TO DATA - NUMBERS 1200 TO 1399
      SPACE   1
*     MLSQQ   1-11-21 (C-6-4)
1300  ERMSG   ( ***INVALID OPTION SELECTED - IOPT=0 ASSUMED.)
1301  ERMSG   ( ***NO CONVERGENCE AFTER ' ITERATIONS. RELATIVE CHANGE IN
, PARAMETERS IS ' .)
1302  ERMSG   ( ***WEIGHTS ARE ZERO, NEGATIVE OR UNDEFINED.)
1303  ERMSG   ( ***TRIANGULAR DECOMPOSITION REQUIRES SQUARE ROOT OF ' IN
, ROW '.)
      SPACE   2,8
*     FITTING SMOOTH CURVES TO DATA ERROR MESSAGES- NUMBERS 1400 TO 1599
      SPACE   1
*     SMOOTH  1-12-01 (C-6-10)
1400  ERMSG   ( ***ESTIMATE FOR N IS TOO SMALL - NEXT ITERATION REQUIRES
, ' KNOTS)
1401  ERMSG   ( ***SOME DATA POINTS HAVE BEEN DELETED)
1402  ERMSG   ( ***INSUFFICIENT DATA TO DEFINE THE SPLINE UNIQUELY - RES
,ULTS UNRELIABLE)
1403  ERMSG   ( ***INITIAL ESTIMATE FOR N IS LESS THAN 5)
1404  ERMSG   ( ***ABSCISSA OF FIRST DATA POINT MUST BE LESS THAN ABSCIS
,SA OF LAST DATA POINT)
      SPACE   2,8
*     INTERPOLATION ERROR MESSAGES - NUMBERS 1800 TO 1999
      SPACE   1
*     AIKINT  1-14-02 (C-1-5)
1830  ERMSG   ( ***ERROR IN PROGRAM. N IS LESS THAN OR EQUAL TO 2)
1831  ERMSG   ( ***THE ACCURACY REQUESTED WAS NOT OBTAINED FOR ARGUMENT
,' )
*   QUADRATURE ROUTINES--NUMBERS 2200 TO 2399
*     SPLINT  1-16-30  (C-2-30)
2200  ERMSG   ( ***N= ' IN SPLINT. AT LEAST 3 POINTS REQUIRED)
2201  ERMSG   ( ***X ' AND ' NOT IN ASCENDING ORDER IN SPLINT)
*     COSIMP  1-16-01  (C-2-1)
*     AGAUSS  1-16-02 (C-2-2)
*     QUAD    1-16-03  (C-2-3)
2250  ERMSG   ( ***TROUBLE INTEGRATING OVER ( ' , ' ). EST.INTEGRAL AND
, ERROR ARE ' AND ' )
*     CADRE   1-16-00  (C-2-0)
2260  ERMSG   ( ***TOO MANY FUNCTION EVALUATIONS REQUIRED IN INTERVAL
, (', '))
2261  ERMSG   ( ***TOO SMALL A SUBINTERVAL REQUIRED IN INTERVAL (', '))
*     GALA    1-16-11  (C-2-11)
2300  ERMSG   ( ***REQUESTED ERROR NOT ATTAINED. ERROR IN GALA PROBABLY
, LESS THAN ' )
*     GAHER   1-16-12  (C-2-12)
2301  ERMSG   ( ***REQUESTED ERROR NOT ATTAINED. ERROR IN GAHER PROBABLY
, LESS THAN ' )
*     GAJAC   1-16-13  (C-2-13)
2302  ERMSG   ( ***REQUESTED ERROR NOT ATTAINED. ERROR IN GAJAC PROBABLY
, LESS THAN ' )
*     FILON   1-16-10  (C-2-10)
2303  ERMSG   ( ***FILON FAILED TO CONVERGE TO REQUIRED TOLERANCE IN 2**
,' SUBDIVISIONS)
*     DUBLINT 1-16-20   (C-2-20)
2310  ERMSG   ( ***ERROR IN SPECIFYING NO, NO=4 IS ASSUMED)
2311  ERMSG   ( ***ERROR IN SPECIFYING NI, NI=4 IS ASSUMED)
      SPACE   2,8
*   ORDINARY DIFFERENTIAL EQNS ERROR MESSAGES - NUMBERS 2400 TO 2599
      SPACE   1
*     RKFINT 1-17-10
2420  ERMSG   ( *** STEPS AT DTMAX EFFECT EFFICIENCY)
2421  ERMSG   ( *** ERROR TEST FAILED AT DTMIN)
2422  ERMSG   ( *** REQUIRED STEP TOO SMALL FOR ALGORITHM INTEGRITY)
2423  ERMSG   ( *** 10 CONSECUTIVE ERROR FAILURES)
2424  ERMSG   ( *** ILLEGAL INPUT N,EPS,DTMIN OR DTMAX)
2425  ERMSG   ( *** ENTERED RKFINT WITH PREVIOUS FATAL ERROR - JOB ABORT
,ED)
*     STIFFZ 1-17-20
2450  ERMSG   ( *** STEPS AT DTMAX EFFECT EFFICIENCY)
2451  ERMSG   ( *** ERROR TEST FAILED AT DTMIN)
2452  ERMSG   ( *** CORRECTOR CONVERGENCE FAILED)
2453  ERMSG   ( *** SPARSITY DECREASING - STRUCTURE FROZEN)
2454  ERMSG   ( *** 10 CONSECUTIVE ERROR FAILURES)
2455  ERMSG   ( *** ILLEGAL INPUT N,EPS OR MF)
2456  ERMSG   ( *** SPARSE MATRIX STORAGE EXCEEDED)
2457  ERMSG   ( *** ENTERED STIFFZ WITH PREVIOUS FATAL ERROR - JOB ABORT
,ED)
*     STIFFS  1-17-20  (C-5-6)
2500  ERMSG   ( ***JACOBIAN REQUIRES ' STORAGE. YOU HAVE ONLY INDICATED
,' - THIS MAY CAUSE AN OVERFLOW)
2501  ERMSG   ( ***KFLAG=-1 FROM STIFF AT T= ' , ERROR TEST FAILED WITH
, ABS(H)=HMIN)
2502  ERMSG   ( ***H HAS BEEN REDUCED TO ' ,AND STEP WILL BE RETRIED)
2503  ERMSG   ( ***PROBLEM APPEARS UNSOLVABLE WITH GIVEN INPUT)
2504  ERMSG   ( ***KFLAG=-2 FROM STIFF AT T= ' , H= ' . THE REQUESTED ER
,ROR IS SMALLER THAN CAN BE HANDLED)
2505  ERMSG   ( ***KFLAG=-3 FROM STIFF AT T= ' ,CORRECTOR CONVERGENCE CO
,ULD NOT BE ACHIEVED)
2506  ERMSG   ( ***INSUFFICIENT STORAGE FOR SPARSE MATRIX ROUTINES TO MA
,NIPULATE JACOBIAN- INCREASE ML AND SIZE OF YJAC ARRAY)
2507  ERMSG   ( ***STIFF WAS CALLED WITH PREVIOUS ERRORS- THE PROGRAM WI
,LL BE STOPPED)
      SPACE   2,8
          SPACE  2
*     PLOTTING ERROR MESSAGES - NUMBERS 3500 TO 3699
      SPACE   2,8
*     PLOT  2-1-00 (B-7-0)
      SPACE  1
3500  ERMSG   ( ***BAD MODE PARAMETER IN CALL TP PLOT OR PLOTM)
3501  ERMSG   ( ***FIRST CALL TO PLOT OR PLOTM MUST BE MODE 1)
3502  ERMSG   ( ***ZERO, NEGATIVE OR HUGE VALUE FOR XL)
3503  ERMSG   ( ***ZERO, NEGATIVE OR HUGE VALUE FOR YL)
3504  ERMSG   ( ***X OR Y MAX AND MIN VALUES EQUAL)
3505  ERMSG   ( ***ZERO VALUE FOR NUMBER OF X,Y PAIRS)
3506  ERMSG   ( ***FIRST 40 CHARACTERS OF MESSAGE ARE BLANK)
3507  ERMSG   ( ***ILLEGAL NUMBER OF PARAMETERS)
3508  ERMSG   ( ***ERROR IN MODE 6 CALL - BAD DISPOSITION PARAMETER)
3509  ERMSG   ( ***ATTEMPT TO RELEASE EMPTY PLOT FILE)
3511  ERMSG   ( ***ERROR IN MODE 1 CALL - BADLY SCALED PLOT)
3512  ERMSG   ( ***ILLEGAL VALUE FOR ' IN CALL TO PLOT OR PLOTM)
3513  ERMSG   ( ***CAN ONLY CHANGE SYSTEM OF DIMENSIONS ON MODE 1 CALL O
,F PLOT OR PLOTM)
3514  ERMSG   ( ***ERROR IN ATTEMPT TO SET TIME LIMIT. SEE DAYFILE)
      SPACE  2,8
*     PLOG  2-1-01 (B-7-1)
      SPACE  1
3520  ERMSG   ( ***MODE NOT 1,2,3 OR 4)
3521  ERMSG   ( ***INVALID LOG SCALE TIC VALUE SPECIFIED - DEFAULT IS 3)
3522  ERMSG   ( ***NO MODE 1 CALL BEFORE MODE 2,3 OR 4 CALL)
3523  ERMSG   ( ***ILLEGAL VALUES SPECIFIED FOR LOGARITHMIC SCALE)
      SPACE   1
*     PLODAM  2-1-03 (B-7-13)
3525  ERMSG   ( ***WORKING STORAGE PROVIDED IS NOT LONG ENOUGH)
3526  ERMSG   ( ***LESS THAN TWO INPUT DATA POINTS)
3527  ERMSG   ( ***INPUT DATA NOT IN ASCENDING ORDER OF X)
      SPACE  2,8
*     AXLIN  2-1-10 (B-7-11)
      SPACE  1
3530  ERMSG   ( ***' CALL NOT PRECEEDED BY ' MODE 1 CALL)
*        SUBSTITUTIONS - AXLGX, PLOGX
*                        AXLGY, PLOGY
*                        AXLGXY, PLOGXY
3531  ERMSG   ( ***NEGATIVE VALUE SPECIFIED FOR NUMBER OF CHARACTERS - D
,EFAULT IS 0)
*     VARSIZM  2-1-02
3535  ERMSG   ( ***VALUE OUT-OF-RANGE FOR SIZE - DEFAULT IS 3)
3536  ERMSG   ( ***ILLEGAL VALUE FOR LENGTH - MUST BE \1)
3537  ERMSG   ( ***VALUE OUT-OF-RANGE FOR DIRECTION - DEFAULT IS 0)
3538  ERMSG   ( ***ILLEGAL VALUE FOR MODE - MUST BE 3 OR 13)
3539  ERMSG   ( ***ILLEGAL CODE CHARACTER)
      SPACE  2,8
*     SIMPLT  2-1-21 (B-7-12)
      SPACE  1
3580  ERMSG   ( ***JOBOPT 2 OR 3 CALL NOT PRECEEDED BY JOBOPT 0 OR 1 CAL
,L - DEFAULT IS JOBOPT 1)
3581  ERMSG   ( ***INVALID VARIABLE NAME PRECEEDING POINTER)
3582  ERMSG   ( ***INVALID SUBSCRIPT PRECEEDING POINTER)
3583  ERMSG   ( ***ONE OF (=, WAS EXPECTED AT POINTER)
3584  ERMSG   ( ***INVALID NUMERIC CONSTANT PRECEEDING POINTER)
3585  ERMSG   ( ***INVALID REPEAT FACTOR IN CONSTANT PRECEEDING POINTER)
3586  ERMSG   ( ***TOO MANY CONSTANTS FOR PRESENT VARIABLE)
3587  ERMSG   ( ***VARIABLE FORMAT CONSTANT PRECEEDING POINTER IS TOO LO
,NG)
3588  ERMSG   ( ***JOBOPT NOT 0,1,2,3 OR 4)
3589  ERMSG   ( ***LOGOPT NOT 0,1,2 OR 3)
*        SIMPLT ALSO USES: PLOT ERROR MESSAGES 3502, 3503, 3505
*                          PLOG ERROR MESSAGE 3523
      SPACE   2,8
*     CONTOUR 2-1-35
3650  ERMSG   ( ***THE CONTOUR VALUE ' IS EQUAL TO Z(','). THAT CONTOUR
,MAY BE MISSED.)
      SPACE   1
*     PLT  2-1-63 (B-7-18), SYMBOL  2-1-64 (B-7-19)
*     NUMBER  2-1-65 (B-7-20), AXIS  2-1-67 (B-7-22)
3670  ERMSG   ( ***ILLEGAL PEN COORDINATES)
*     LINE  2-1-68 (B-7-23)
3671  ERMSG   ( ***ILLEGAL SCALING PARAMETERS)
      SPACE   2,8
*   TABULAR DATA MANIPULATION ERROR MESSAGES - NUMBERS 3800 TO 3849
      SPACE   1
*     LOCRL   2-3-01  (A-1-7A)
3802  ERMSG   ( ***ILLEGAL ARGUMENT - FUNCTION VALUE SET TO ZERO)
      SPACE   1
*     PRESET  2-3-30  (B-9-3)
3830  ERMSG   ( ***NUMBER OF WORDS TO PRESET LE 0 - FIRST PARAMETER RETU
,RNED INDEFINITE)
      SPACE   2,8
*   FIELD LENGTH MANAGEMENT ERROR MESSAGES - NUMBERS 3930 TO 3939
      SPACE   1
*     CHNGSCM 2-5-30  (B-14-1)
3930  ERMSG   ( ***ILLEGAL FIELD LENGTH= 'B. PARAMETER IS EITHER NEGATIV
,E, REAL, TOO LARGE OR LESS THAN CHNGSCM MEMORY LOCATION)
           END
