*DECK ALERDM
      SUBROUTINE ALERDM
C     ROUTINE ALERDM: DUMP THE CONTENTS OF THE WORKING TABLES
C                     IN A MORE OR LESS READABLE FORM
C
C     AUTHOR & REVISION HISTORY
C     -------------------------
C     MAY 1979     - WRITTEN, P. BUMBULIS
C
*CALL ALRCOM
C     FOR A COMPLETE DESCRIPTION OF THE COMMON BLOCKS, PLEASE SEE THE
C     WRITE UP IN "ALEROF".
C
C     VARIABLES USED/FUNCTIONS CALLED:
C     -------------------------------
C     SORTAG/DESORT - QUICKSORT WITH TAGGED ELEMENTS
C     SP     - STARTING POINTER INTO TABLES        -!
C     MP     - MIDDLE (TEMPORARY) POINTER IN TABLES !- FOR A ROUTINE
C     LP     - LAST (ENDING) POINTER INTO TABLES   -!
C     ROUTNE - ROUTINE UNDER SCRUITINY
C     DEFALT - DEFAULT AS TO PRINT OR NOT TO PRINT
C     PRT/NOPRT - A1 LITERALS (FOR PORTABILITY)
C
      INTEGER SP,MP,LP,ROUTNE,DEFALT(8),PRT(8),NOPRT(8),I
      DATA PRT,NOPRT /"P","R","I","N","T"," "," "," ",
     *                "N","O","-","P","R","I","N","T"/
C
*CALL STATF
      IF (NLAST .LE. 0) GO TO 180
         CALL DESORT(ROUTAB,1,NLAST,ERRTAB)
         PRINT 5
*IF -DEF,AELIB5
   5     FORMAT(/,
     *          "          AELIB MESSAGES AFFECTED BY USER CONTROL",/,
     *          "          ---------------------------------------",/,
     *          " ROUTINE   DEFAULT",/,
     *          " NUMBER .. STATUS ....  .  .   EXCEPTIONS   .  .  .")
*ENDIF
*IF DEF,AELIB5
   5     FORMAT(/,
     *          '          AELIB MESSAGES AFFECTED BY USER CONTROL',/,
     *          '          ---------------------------------------',/,
     *          ' ROUTINE   DEFAULT',/,
     *          ' NUMBER .. STATUS ....  .  .   EXCEPTIONS   .  .  .')
*ENDIF
C
C        FOR EACH ROUTINE, FIND INFO ABOUT IT AND PRINT THAT
C
         SP = 1
   10    IF (SP .GT. NLAST) GO TO 150
         IF (ROUTAB(SP) .EQ. 0) GO TO 150
            ROUTNE = ROUTAB(SP)
C
C           FIND THE LAST ENTRY IN TH TABLES FOR THE CURRENT ROUTINE
C
            LP = SP
   20       IF (LP .GT. NLAST) GO TO 30
            IF (ROUTAB(LP) .NE. ROUTNE) GO TO 30
               LP = LP + 1
            GO TO 20
   30       CONTINUE
            LP = LP - 1
C
C           ORDER THE ENTRIES FOR THE CURRENT ROUTINE AND FETCH
C           THE DEFAULT (AS TO PRINT OR NOT TO PRINT)
C
            CALL SORTAG(ERRTAB,SP,LP,ROUTAB)
            ROUTNE = ROUTAB(SP)
            IF (ERRTAB(SP) .NE. 0) GO TO 50
               DO 40 I = 1,8
                  DEFALT(I) = NOPRT(I)
   40          CONTINUE
               SP = SP + 1
            GO TO 70
   50          DO 60 I = 1,8
                  DEFALT(I) = PRT(I)
   60          CONTINUE
   70       CONTINUE
C
C           PRINT RESULTS OF SEARCH
C
            IF (SP .LE. LP) GO TO 90
               PRINT 80, ROUTNE,DEFALT
*IF -DEF,AELIB5
   80          FORMAT("  ",I5,"   ",8A1,"    NONE")
*ENDIF
*IF DEF,AELIB5
   80          FORMAT('  ',I5,'   ',8A1,'    NONE')
*ENDIF
            GO TO 140
   90          MP = SP + MIN0(LP - SP,17)
               PRINT 100, ROUTNE,DEFALT,(ERRTAB(I),I = SP,MP)
*IF -DEF,AELIB5
  100          FORMAT("  ",I5,"   ",8A1,"   ",18(I5," "))
*ENDIF
*IF DEF,AELIB5
  100          FORMAT('  ',I5,'   ',8A1,'   ',18(I5,' '))
*ENDIF
               SP = MP + 1
  110          IF (SP .GT. LP) GO TO 130
                  MP = SP + MIN0(LP - SP,17)
                  PRINT 120, (ERRTAB(I), I = SP,MP)
*IF -DEF,AELIB5
  120             FORMAT("  ",5X,"   ",8X,"   ",18(I5," "))
*ENDIF
*IF DEF,AELIB5
  120             FORMAT('  ',5X,'   ',8X,'   ',18(I5,' '))
*ENDIF
                  SP = MP + 1
               GO TO 110
  130          CONTINUE
  140       CONTINUE
         GO TO 10
  150    CONTINUE
C
C        REMOVE ANY BLANK ENTRIES AT THE END OF THE TABLE
C
         IF (SP .GT. NLAST) GO TO 170
            NLAST = SP - 1
  170    CONTINUE
      GO TO 200
  180    PRINT 190
*IF -DEF,AELIB5
  190    FORMAT(/," NO AELIB MESSAGES AFFECTED BY USER CONTROL")
*ENDIF
*IF DEF,AELIB5
  190    FORMAT(/,' NO AELIB MESSAGES AFFECTED BY USER CONTROL')
*ENDIF
  200 CONTINUE
      RETURN
      END
