*DECK ALERPR
      LOGICAL FUNCTION ALERPR(ROUTNE,ERROR)
C
C     ******************************************************************
C     *                                                                *
C     *   ALERPR IS WRITTEN IN MODULAR FORM USING THE ADDITIONAL       *
C     * ROUTINES:                                                      *
C     *                      ALRINI                                    *
C     *                      ALRTST                                    *
C     *                      TRACEB                                    *
C     * ALRINI THROUGH ALRTST ACCOMPANY ALEROF ON THE AELIB SOURCE     *
C     * TAPE UNDER THE DECK NAME ALEROF.  TRACEB IS STORED ON THE      *
C     * AELIB SOURCE TAPE UNDER THE DECK NAME TRACEB.                  *
C     *                                                                *
C     ******************************************************************
C     ROUTINE ALERPR: ROUTINE TO RETURN WHETHER OR NOT TO PRINT
C                     ERROR MESSAGE "ERROR" IN "ROUTNE".
C
C     VARIABLES USED/FUNCTIONS CALLED:
C     -------------------------------
C (A) ROUTNE,ERROR - DESCRIBES ERROR MESSAGE TO TEST
C     ALRTST - AELIB "SYSTEM" ROUTINE TO DO MORE OR LESS SAME JOB
C     ALRINI - INITIALIZATION ROUTINE
C *** (A) DENOTES THAT THE VARIABLE IS A FORMAL PARAMETER (ARGUMENT)
C
C     ERROR EXITS
C     -----------
C     "ALERPR" HAS ONE ERROR EXIT:
C     (1)  IF "ALERPR" IS CALLED WITH ROUTNE = 0, THEN THE CALL
C          IS IGNORED (I.E. .TRUE. IS RETURNED), AND A MESSAGE
C          IS PRINTED.  CONTROL IS RETURNED TO THE USERS PROGRAM.
      INTEGER ROUTNE,ERROR
      LOGICAL ALRTST
C
*CALL STATF
      CALL ALRINI
C
      IF (ROUTNE .NE. 0) GO TO 20
         PRINT 10
*IF -DEF,AELIB5
   10    FORMAT(" ***INVALID ARGUMENT - ROUTINE NUMBER IS ZERO")
*ENDIF
*IF DEF,AELIB5
   10    FORMAT(' ***INVALID ARGUMENT - ROUTINE NUMBER IS ZERO')
*ENDIF
         CALL TRACEB(0)
         ALERPR = .TRUE.
      GO TO 30
   20    ALERPR = ALRTST(ROUTNE,ERROR,JUNK)
   30 CONTINUE
      RETURN
      END
