*DECK COULOMB
      SUBROUTINE COULOMB(RHO,ETA,LP,F,FP,G,GP)
      DIMENSION F(LP),FP(LP),G(LP),GP(LP)
      DIMENSION ALPHA(51),BETA(51),H(51)
      REAL N
*CALL  STATF
      L=LP-1
      IF (ETA.GT.12.) GO TO 10
      IF (RHO.NE.0) GO TO 20
      IF (ETA.NE.0) GO TO 10
      IF (L.EQ.0) GO TO 20
   10 PRINT 11,RHO,ETA,L
*IF -DEF,AELIB5
   11 FORMAT (14H0COULOMB FAILS,3X,3HRHO,X,E12.5,3X,3HETA,X,E12.5,
     1         3X,1HL,I3)
*ENDIF
*IF DEF,AELIB5
   11 FORMAT (14H0COULOMB FAILS,3X,3HRHO,1X,E12.5,3X,3HETA,1X,E12.5,
     1           3X,1HL,I3)
*ENDIF
      DO 12 I=1,LP
   12 F(I)=FP(I)=G(I)=GP(I)=0
      RETURN
   20 GO TO 20000
   50 IF (L.NE.0) GO TO 21
      RETURN
   21 IF((RHO+11.)-(L+10)) 22,22,23
   22 NE=L+10
      GO TO 25
   23 NE=RHO+11
   25 ESQ=ETA**2
      HOLD=0
      AB=(NE+1)**2
      A1=SQRT(AB+ESQ)
      B1=AB/RHO+ETA
      LL=NE
   27 IF (LL.LT.L) GO TO 30
      AL=SQRT(LL**2+ESQ)
      BL=LL**2/RHO+ETA
      HNEW=(LL+1)*AL/(LL*B1+(LL+1)*BL-(LL*A1*HOLD))
      A1=AL
      B1=BL
      HOLD=HNEW
      LL=LL-1
      GO TO 27
   30 ALPHA(L+1)=AL
      BETA(L+1)=BL
      H(L+1)=HNEW
      LL=L-1
   32 IF(LL.LT.1) GO TO 35
      ALPHA(LL+1)=SQRT(LL**2+ESQ)
      BETA(LL+1)=LL**2/RHO+ETA
      H(LL+1)=(LL+1)*ALPHA(LL+1)/(LL*BETA(LL+2)+(LL+1)*BETA(LL+1)-
     1    (LL*ALPHA(LL+2)*H(LL+2)))
      LL=LL-1
      GO TO 32
   35 DO 40 I=2,LP
      LL=I-1
      F(I)=H(I)*F(I-1)
      FP(I)=(-BETA(I)*F(I)+ALPHA(I)*F(I-1))/LL
      G(I)=(BETA(I)*G(I-1)-LL*GP(I-1))/ALPHA(I)
   40 GP(I)=(-BETA(I)*G(I)+ALPHA(I)*G(I-1))/LL
      RETURN
20000 IF(ETA.NE.0) GO TO 20010
      F(1)=SIN(RHO)
      FP(1)=G(1)=COS(RHO)
      GP(1)=-F(1)
      GO TO 50
20010 ESQ=ETA**2
      RSQ=RHO**2
      IF (ETA.GT.7.) GO TO 20011
      IF((RHO-2.*ETA).GE.4.) GO TO 2000
20012 IF (RHO*ETA.LE.1.5) GO TO 1000
      IF (RHO.LT.7.*ETA) GO TO 3000
      IF (RHO.GE.5.) GO TO 2000
      GO TO 1000
20011 IF((RHO-5.*ETA).GT.-17.) GO TO 2000
      GO TO 20012
 1000 NSWIT=1
*IF -DEF,AELIB5
 1001 GO TO (100,200) NSWIT
*ENDIF
*IF DEF,AELIB5
 1001 GO TO (100,200) NSWIT
      CALL GOTOER
*ENDIF
  100 IF (ETA.GT.2.) GO TO 150
      FETA=((((((9./(9.+ESQ)*7.06581820203E-8*ESQ
     1    -6.43035078486E-7)*ESQ+5.90735411945E-6)*ESQ
     2    -5.52678260820E-5)*ESQ+5.36777381917E-4)*ESQ
     3    -5.67775514307E-3)*ESQ+7.70569029243E-2)*ESQ
     4    +.4227843351-(1./(1.+ESQ))+(ESQ/(8.+2.*ESQ))
      GO TO 175
  150 FETA=ALOG(ETA)+(((((.02109279609280/ESQ
     1    +.007575757575757)/ESQ+.004166666666667)/ESQ
     2    +.003968253968254)/ESQ+.008333333333333)/ESQ
     4    +.08333333333333)/ESQ
  175 OMEGA=ALOG(2.*RHO)+FETA+.1544313298
  200 B1=1.
      B2=S=ETA*RHO
      TER=2.*B2
      B=B1+B2
      N=2
      OLD=ABS(B)+ABS(S)
*IF -DEF,AELIB5
      GO TO (300,4100) NSWIT
  300 BETA=TER*OMEGA
      Q1=BETA+1.
      Q2=V=BETA*B2
*ENDIF
*IF DEF,AELIB5
      GO TO (300,4100) NSWIT
      CALL GOTOER
  300 BETA(1)=TER*OMEGA
      Q1=BETA(1)+1.
      Q2=V=BETA(1)*B2
*ENDIF
      Q=Q1+Q2
      OLD=OLD+ABS(Q)+ABS(V)
 4100 B3=(TER*B2-RSQ*B1)/(N*(N+1))
      B=B+B3
      S=S+N*B3
      FNEW=ABS(B)+ABS(S)
*IF -DEF,AELIB5
      GO TO (400,500) NSWIT
  400 Q3=(TER*Q2-RSQ*Q1-(2*N-1)*TER*B2-2.*BETA*N*B3)/(N*(N-1))
*ENDIF
*IF DEF,AELIB5
      GO TO (400,500) NSWIT
      CALL GOTOER
  400 Q3=(TER*Q2-RSQ*Q1-(2*N-1)*TER*B2-2.*BETA(1)*N*B3)/(N*(N-1))
*ENDIF
      Q=Q+Q3
      V=V+N*Q3
      FNEW=FNEW+ABS(Q)+ABS(V)
  500 IF (FNEW.EQ.OLD) GO TO 4200
      OLD=FNEW
      N=N+1
      B1=B2
      B2=B3
      Q1=Q2
      Q2=Q3
      GO TO 4100
 4200 TPE=6.28318530718*ETA
      C=SQRT(TPE/(EXP(TPE)-1.))
      F(1)=C*RHO*B
      FP(1)=C*(B+S)
*IF -DEF,AELIB5
      GO TO (600,5000) NSWIT
  600 T=(TER+BETA)*B+V
*ENDIF
*IF DEF,AELIB5
      GO TO (600,5000) NSWIT
      CALL GOTOER
  600 T=(TER+BETA(1))*B+V
*ENDIF
      G(1)=Q/C
      GP(1)=T/(C*RHO)
      GO TO 50
 2000 IF (ETA.GT.1.5) GO TO 2075
      SIGMA=(((((((.4710545468E-8*ESQ-.4946423680E-7)*ESQ
     1    +.5370321926E-6)*ESQ-.6140869564E-5)*ESQ+.7668248312E-4)*ESQ
     2    -1.135551028E-3)*ESQ+2.568563430E-2)*ESQ+.9227843351)*ETA
     3    -ATAN(ETA)-ATAN(ETA/2.)
      GO TO 2005
 2075 SIGMA=((((-.8417508417508E-3/ESQ-.5952380952381E-3)/ESQ
     1    -.7936507936508E-3)/ESQ-.2777777777778E-2)/ESQ
     2    -.08333333333333)/ETA+(ETA*(ALOG(ETA)-1.))+.7853981633974
 2005 THETA=RHO-ETA*ALOG(2.*RHO)+SIGMA
      SS1=SSS=1.
      TS1=SL1=TSS=SLS=0
      TL1=TLS=1.-ETA/RHO
      AN=ETA/RHO*.5
      BN=AN*ETA
      N=1
      OLDB=1.0E50
 4300 SS2=AN*SS1-BN*TS1
      TS2=AN*TS1+BN*SS1
      SL2=AN*SL1-BN*TL1-SS2/RHO
      TL2=AN*TL1+BN*SL1-TS2/RHO
      FNEWB=ABS(SS2)+ABS(TS2)+ABS(SL2)+ABS(TL2)
      IF (FNEWB.GT.OLDB) GO TO 4400
      IF (N.EQ.20) GO TO 4400
      SSS=SSS+SS2
      TSS=TSS+TS2
      SLS=SLS+SL2
      TLS=TLS+TL2
      SS1=SS2
      TS1=TS2
      SL1=SL2
      TL1=TL2
      OLDB=FNEWB
      AN=(2*N+1)/(2*N+2)*ETA/RHO
      BN=(ESQ-(N*(N+1)))/((2*N+2)*RHO)
      N=N+1
      GO TO 4300
 4400 COSINE=COS(THETA)
      SINE=SIN(THETA)
      F(1)=TSS*COSINE+SSS*SINE
      FP(1)=TLS*COSINE+SLS*SINE
      G(1)=SSS*COSINE-TSS*SINE
      GP(1)=SLS*COSINE-TLS*SINE
      GO TO 50
 3000 NSWIT=2
      GO TO 1001
 5000 IF (ETA.LT.2.4) GO TO 700
      GETA=(((((((-.27924038E-8*ETA+.18360270E-6)*ETA-.52754014E-5)*ETA
     1    +.87263110E-4)*ETA-.92290016E-3)*ETA+.65755340E-2)*ETA
     2    -.032712015)*ETA+.12129400)*ETA-.55396721
      GO TO 800
  700 GETA=((((((((-.0037236582*ETA+.053759300)*ETA-.34131398)*ETA
     1    +1.2549620)*ETA-2.9615354)*ETA+4.6925935)*ETA-5.0545034)*ETA
     2    +3.6119367)*ETA-1.5022880)*ETA-.20667845
  800 RHON=2.*ETA
      FL3=0
      IF (RHO.GT.3.75*ETA) GO TO 900
      DELTA=RHO-RHON
      IF (ABS(DELTA).GT.1.0E-7) GO TO 6000
      GC=1.
      GCP=GETA
      GO TO 4600
 6000 MMM=1
      GO TO 30000
  900 DELTA=1.75*ETA
      MMM=2
      GO TO 30000
30020 RHON=3.75*ETA
      DELTA=RHO-RHON
      GETA=GCP/GC
      FL3=-.5*(1.-(2.*ETA/RHON))*DELTA**2
      MMM=3
      GO TO 30000
 4600 DENOM=FP(1)*GC-F(1)*GCP
      G(1)=GC/DENOM
      GP(1)=GCP/DENOM
      GO TO 50
30000 DSQ=DELTA**2
      FL1=1.
      FL2=GETA*DELTA
      N=3
      GC=FL1+FL2+FL3
      GCP=GETA+2./DELTA*FL3
 4500 FL4=(-DELTA/RHON*((N-1)*(N-2)*FL3+DSQ*FL1)-((1.-2.*ETA/RHON)*DSQ
     1    *FL2))/(N*(N-1))
      GC=FL4+GC
      FMU=FL4*N/DELTA
      GCP=FMU+GCP
      IF (ABS(FMU)/ABS(GCP).LT.1.0E-6) GO TO 4700
      N=N+1
      FL1=FL2
      FL2=FL3
      FL3=FL4
      GO TO 4500
 4700 IF (MMM.EQ.2) GO TO 30020
      GO TO 4600
      END
