*DECK CUBIC
      SUBROUTINE CUBIC(AA,RRE,RIM)
      DIMENSION AA(4),RRE(3),RIM(3)
*CALL STATF
      B=AA(2)/3.
      D=B*B
      C=AA(3)/3.
      E=AA(1)*C-D
      F=.5*(3.*AA(1)*B*C-AA(1)*AA(1)*AA(4))-D*B
      G=F*F
      H=E**3+G
      IF (H.GE.0) GO TO 100
      FI=SQRT(ABS(E))
      IF (F) 10,15,10
   15 E=1.570796326794897
      GO TO 20
   10 E=ATAN(SQRT(ABS(H))/F)
   20 IF (F) 25,30,30
   25 E=E+3.141592653589793
   30 E=E/3.
      D=C=FI*COS(E)
      FI=FI*SIN(E)
      E=-FI
      GO TO 200
  100 G=SQRT(ABS(H))
      C=F+G
      M=0
      GO TO 500
  105 D=SUBR
      FI=E=0
      C=F-G
      M=5
      GO TO 500
  110 C=SUBR
  200 RRE(1)=(D+C-B)/AA(1)
      RIM(1)=0
      H=-.5*(D+C)
      C= .866025403784438*(D-C)
      FI=.866025403784438*(FI-E)
      RRE(2)=(H-FI-B)/AA(1)
      RIM(2)=C/AA(1)
      RRE(3)=(H+FI-B)/AA(1)
      RIM(3)=-RIM(2)
      RETURN
  500 IF (C.EQ.0) GO TO 505
      SUBR   =C/ABS(C)*(ABS(C)**.3333333333333333)
      GO TO 510
  505 SUBR=0
  510 IF (M) 105,105,110
      END
