*DECK DATPAK
      SUBROUTINE DPVERFY
C
C
C   REVISION HISTORY :  REVISED AUGUST 1982  BY W.J. IRVING
C
C                       REVISION MODIFIES DPREAD ROUTINE TO CORRECT
C                       INTERNAL FILE POSITIONING PROBLEM CAUSED BY
C                       SYSTEM BUG IN BACKSPACING.  BACKSPACING
C                       REPLACED WITH A REWIND AND A SKIP FORWARDS.
C
C
      IMPLICIT INTEGER (C-Z)
      EXTERNAL DPERROR,DPREPV
      COMMON/YYBUFF/BUFF(512)
      COMMON/YYFIT/FIT(35,2),ITYPE,OUT,ENF,EDB,PEVAL,W
      COMMON/YYCTRL/CW(2),KT(2),NF(2),NDB(2),BPI(2),LFN(2),KWIC(2),
     ,              RL(2),LC,IBLK,NCOM,ISIZE,NFITS,IWCT,NREC,ERL
      COMMON/YYSCTH/I,J,K,L,M,N
*IF DEF,AELIB5
C
      CHARACTER * 10  TIME, DATE, ATIME, ADATE
C
*ENDIF
      DATA RL,KWIC,NFITS,ERL,BPI,OUT,NF,NDB,LFN/4*0,2,5,2*80.,6,6*1H /
      DATA W/1/
*CALL   STATF
C
C     VERIFY DATPAK AND/OR SET W FLAG
C
C     I MUST BE SET TO VALUE OF IOT BEFORE CALLING DPVERFY
C
      IOT = I
      IF(LFN(W).EQ.IOT) RETURN
C
      DO 1 I = 1, NFITS
               W=I
               IF(LFN(I).EQ.IOT) GO TO 11
               IF(LFN(I).EQ." ") GO TO 5
1     CONTINUE
C
C     NO MORE FITS AVAILABLE
C
      WRITE(OUT,42) IOT
*IF -DEF,AELIB5
      STOP "TOO MANY DATPAK TAPES"
*ENDIF
*IF DEF,AELIB5
      STOP 'TOO MANY DATPAK TAPES'
*ENDIF
C
C     IF USER IS ATTEMPTING TO RE-LABEL A TAPE
C
11    IF(ITYPE.EQ.0) CALL REWND(FIT(1,W))
C
C     HAS TAPE BEEN VERIFIED AS BEING A DATPAK TAPE
C
      IF(NF(W).EQ." ") GO TO 35
      RETURN
C
C     INITIALIZE DATPAK TAPE AND VERIFY IT
C
C
5     LFN(W)=J=IOT
C
C     RECOVERY AFTER USER PROGRAM ABORTS, VIA DPREPRV
*IF -DEF,AELIB5
      IF(W.EQ.1) CALL RECOVR(DPREPV,77B,0)
*ENDIF
*IF DEF,AELIB5
      IF(W.EQ.1) CALL RECOVR(DPREPV,O"77",0)
*ENDIF
C     CHECK LOWER 18 BITS AND IF THEY ARE ZERO, IOT IS IN "L" FORMAT
C
*IF -DEF,AELIB5
      IF(IOT.AND.777777B) 14,30,14
*ENDIF
*IF DEF,AELIB5
      IF(IOT.AND.O"777777") 14,30,14
*ENDIF
C     MUST PUT J IN "L" FORMAT
C     FIRST IS IOT A VALID UNIT NUMBER (1-99)
C
14    I = -1
      IF(IOT.GE.1.AND.IOT.LE.9) I=0
      IF(IOT.GE.10.AND.IOT.LE.99) I=1
      IF(I) 16,20,20
16    WRITE(OUT,39) IOT,IOT,IOT
*IF -DEF,AELIB5
      STOP "INVALID LFN FOR DATPAK TAPE"
*ENDIF
*IF DEF,AELIB5
      STOP 'INVALID LFN FOR DATPAK TAPE'
*ENDIF
C
C     SET K TO PROPER MASK AND L TO EITHER 5L OR 6L
C
20    ENCODE(2,40,J) IOT
*IF -DEF,AELIB5
      K=770000000000B
*ENDIF
*IF DEF,AELIB5
      K=O"770000000000"
*ENDIF
      M=-18
      IF(I) 25,25,26
26    M=-24
*IF -DEF,AELIB5
      K=777700000000B
*ENDIF
*IF DEF,AELIB5
      K=O"777700000000"
*ENDIF
*IF -DEF,AELIB5
25    J=SHIFT(J,M).AND.K.OR.4LTAPE
*ENDIF
*IF DEF,AELIB5
25    J=SHIFT(J,M).AND.K.OR.L"TAPE"
*ENDIF
C
C     J SHOULD NOW CONTAIN THE DATPAK LFN IN "L" FORMAT
C
C     INITIALIZE DATPAK WI FILE FIT
C
C
*IF -DEF,AELIB5
30    CALL FILESQ(FIT(1,W),2LRT,1LW,2LBT,1LI,3LWSA,BUFF,3LLFN,J,3LMRL,
     ,            5120,3LSDS,3LYES,3LMNR,30,3LERL,ERL,2LEO,1LA,2LEX,
     ,            DPERROR,3LBFS,1600)
*ENDIF
*IF DEF,AELIB5
30    CALL FILESQ(FIT(1,W),L"RT",L"W",L"BT",L"I",L"WSA",BUFF,L"LFN",J,L"
     ,MRL",              5120,L"SDS",L"YES",L"MNR",30,L"ERL",ERL,L"EO",L
     ,"A",L"EX",                DPERROR,L"BFS",1600)
*ENDIF
C
C     NOTE DPERROR IS AN ERROR HANDLING ROUTINE AND MAY BE USER SUPPLIED
C
C     CHECK IF INSIDE DPBUFST (ITYPE=-2)
C
      IF(ITYPE.NE.-2) GO TO 63
C
C     IF K = 0  OR  L = 2LNO USE DEFAULT VALUES FOR BUFFER SIZE AND BUFF
      IF(K.EQ.0) GO TO 60
*IF -DEF,AELIB5
      CALL STOREF(FIT(1,W),3LBFS,K)
*ENDIF
*IF DEF,AELIB5
      CALL STOREF(FIT(1,W),L"BFS",K)
*ENDIF
      WRITE(OUT,61) K
*IF -DEF,AELIB5
 61   FORMAT("0*",T15,"DATPAK BUFFER SIZE SET TO ",I6," WORDS")
*ENDIF
*IF DEF,AELIB5
 61   FORMAT('0*',T15,'DATPAK BUFFER SIZE SET TO ',I6,' WORDS')
*ENDIF
*IF -DEF,AELIB5
60    IF(L.EQ.2LNO) GO TO 63
*ENDIF
*IF DEF,AELIB5
60    IF(L.EQ.L"NO") GO TO 63
*ENDIF
*IF -DEF,AELIB5
      CALL STOREF(FIT(1,W),3LFWB,LOCF(L))
*ENDIF
*IF DEF,AELIB5
      CALL STOREF(FIT(1,W),L"FWB",LOCF(L))
*ENDIF
      WRITE(OUT,62)
*IF -DEF,AELIB5
 62   FORMAT("0*",T15,"DATPAK USER BUFFER SPECIFIED")
*ENDIF
*IF DEF,AELIB5
 62   FORMAT('0*',T15,'DATPAK USER BUFFER SPECIFIED')
*ENDIF
 63   CONTINUE
*IF -DEF,AELIB5
      CALL OPENM(FIT(1,W),3LI-O,1LR)
*ENDIF
*IF DEF,AELIB5
      CALL OPENM(FIT(1,W),L"I-O",L"R")
*ENDIF
C
      IF(W.NE.1) GO TO 35
*IF -DEF,AELIB5
      CALL TIME(ATIME)
*ENDIF
*IF DEF,AELIB5
      ATIME = TIME()
*ENDIF
*IF -DEF,AELIB5
      CALL DATE(ADATE)
*ENDIF
*IF DEF,AELIB5
      ADATE = DATE()
*ENDIF
      WRITE(OUT,10) ATIME,ADATE
35    IF(ITYPE.LE.0) RETURN
      CALL GETREC
      IF(NF(W)+NDB(W).EQ.0) RETURN
      WRITE(OUT,15) J
*IF -DEF,AELIB5
      STOP "NOT DATPAK TAPE FORMAT"
*ENDIF
*IF DEF,AELIB5
      STOP 'NOT DATPAK TAPE FORMAT'
*ENDIF
*IF -DEF,AELIB5
 10   FORMAT("1*",T15,"DATPAK  C.R.N.L.    (VERS. 2.0 28/01/77)",T80,
     ,"TIME OF RUN ",A10,T105,"DATE ",A10,/)
*ENDIF
*IF DEF,AELIB5
 10   FORMAT('1*',T15,'DATPAK  C.R.N.L.    (VERS. 2.0 28/01/77)',T80,
     ,'TIME OF RUN ',A10,T105,'DATE ',A10,/)
*ENDIF
*IF -DEF,AELIB5
15    FORMAT("0***LOGICAL FILE NAME ",A7," IS NOT A PROPER DATPAK TAPE**
     ,*")
*ENDIF
*IF DEF,AELIB5
15    FORMAT('0***LOGICAL FILE NAME ',A7,' IS NOT A PROPER DATPAK TAPE**
     ,*')
*ENDIF
*IF -DEF,AELIB5
39    FORMAT("0*",T15,"INVALID LOGICAL FILE NAME, IOT  ",O20,5X,A10,5X,
     ,I10)
*ENDIF
*IF DEF,AELIB5
39    FORMAT('0*',T15,'INVALID LOGICAL FILE NAME, IOT  ',O20,5X,A10,5X,
     ,I10)
*ENDIF
40    FORMAT(I2)
*IF -DEF,AELIB5
42    FORMAT("0*",T15,"DATPAK CAN ONLY SUPPORT TWO DATPAK TAPES, THIRD T
     ,APE ",A6," CANNOT BE USED")
*ENDIF
*IF DEF,AELIB5
42    FORMAT('0*',T15,'DATPAK CAN ONLY SUPPORT TWO DATPAK TAPES, THIRD T
     ,APE ',A6,' CANNOT BE USED')
*ENDIF
      END
      SUBROUTINE DPREPV(IXCHNG,IFLAG,IFLDLN)
      IMPLICIT INTEGER (C-Z)
      DIMENSION IXCHNG(17),IFLDLN(1)
C
C     CLOSE ALL DATPAK FILES WHEN ABNORMAL TERMINATION OCCURS,
C     AND ISSUE MESSAGE ABOUT RESET IN QUICK ADD MODE
C
      COMMON/YYFIT/FIT(35,2),ITYPE,OUT,ENF,ENB,PEVAL,W
      COMMON/YYCTRL/CW(2),KT(2),NF(2),NDB(2),BPI(2),LFN(2),KWIC(2),
     ,              RL(2),LC,IBLK,NCOM,ISIZE,NFITS,IWCT,NREC,ERL
      COMMON/YYSCTH/I,J,K,L,M,N
C
      IFLAG=0
      DO 1 I = 1, NFITS
           IF(LFN(I).EQ." ") GO TO 1
           CALL CLOSEM(FIT(1,I))
*IF -DEF,AELIB5
         J = LFN(I) .AND. 77B
*ENDIF
*IF DEF,AELIB5
         J = LFN(I) .AND. O"77"
*ENDIF
*IF -DEF,AELIB5
         IF ( J .NE. 00B ) WRITE(OUT,3) LFN(I)
*ENDIF
*IF DEF,AELIB5
         IF ( J .NE. O"00" ) WRITE(OUT,3) LFN(I)
*ENDIF
*IF -DEF,AELIB5
         IF ( J .EQ. 00B ) WRITE(OUT,2) LFN(I)
*ENDIF
*IF DEF,AELIB5
         IF ( J .EQ. O"00" ) WRITE(OUT,2) LFN(I)
*ENDIF
           IF(KWIC(I).EQ.1) WRITE(OUT,4)
 1    CONTINUE
*IF -DEF,AELIB5
 2    FORMAT("0*",T15,"LOGICAL FILE ",A7," CLOSED BY DATPAK REPRIEVE")
*ENDIF
*IF DEF,AELIB5
 2    FORMAT('0*',T15,'LOGICAL FILE ',A7,' CLOSED BY DATPAK REPRIEVE')
*ENDIF
*IF -DEF,AELIB5
 3    FORMAT("0*",T15,"LOGICAL FILE TAPE",I2," CLOSED BY DATPAK REPRIEVE
     ,")
*ENDIF
*IF DEF,AELIB5
 3    FORMAT('0*',T15,'LOGICAL FILE TAPE',I2,' CLOSED BY DATPAK REPRIEVE
     ,')
*ENDIF
*IF -DEF,AELIB5
 4    FORMAT("+",T65,"(THIS FILE WAS IN KWIC ADD MODE, MUST DPRESET)")
*ENDIF
*IF DEF,AELIB5
 4    FORMAT('+',T65,'(THIS FILE WAS IN KWIC ADD MODE, MUST DPRESET)')
*ENDIF
      RETURN
      END
      SUBROUTINE GETREC
      IMPLICIT INTEGER (C-Z)
      EQUIVALENCE (AREEL,INT)
      EXTERNAL DPERROR,DPREPV
      COMMON/YYBUFF/BUFF(512)
      COMMON/YYFIT/FIT(35,2),ITYPE,OUT,ENF,EDB,PEVAL,W
      COMMON/YYCTRL/CW(2),KT(2),NF(2),NDB(2),BPI(2),LFN(2),KWIC(2),
     ,              RL(2),LC,IBLK,NCOM,ISIZE,NFITS,IWCT,NREC,ERL
      COMMON/YYSCTH/I,J,K,L,M,N
      DATA RL,KWIC,NFITS,ERL,BPI,OUT,NF,NDB,LFN/4*0,2,5,2*80.,6,6*1H /
      DATA W/1/
C
      CALL GET(FIT(1,W),BUFF)
*IF -DEF,AELIB5
      M=IFETCH(FIT(1,W),2LFP)
*ENDIF
*IF DEF,AELIB5
      M=IFETCH(FIT(1,W),L"FP")
*ENDIF
C
C     IF END OF PARTITION (40B) OR END OF INFORMATION (100B) RETURN
C
*IF -DEF,AELIB5
      IF(M.NE.100B) GO TO 2
*ENDIF
*IF DEF,AELIB5
      IF(M.NE.O"100") GO TO 2
*ENDIF
      IF(ITYPE.EQ.1.OR.ITYPE.EQ.5) RETURN
      WRITE(OUT,1) LFN(W)
      RETURN
*IF -DEF,AELIB5
 2    IF(M.EQ.40B) RETURN
*ENDIF
*IF DEF,AELIB5
 2    IF(M.EQ.O"40") RETURN
*ENDIF
*IF -DEF,AELIB5
 1    FORMAT("0*",T15,"***SCOPE EOI READ ON LFN ",A7," , CONTACT DATPAK
     ,EXPERT IMMEDIATELY***")
*ENDIF
*IF DEF,AELIB5
 1    FORMAT('0*',T15,'***SCOPE EOI READ ON LFN ',A7,' , CONTACT DATPAK
     ,EXPERT IMMEDIATELY***')
*ENDIF
C
C     CRACK THE DATPAK CONTROL WORD
C
*IF -DEF,AELIB5
      AREEL=BUFF(1) $ KT(W)=INT
*ENDIF
*IF DEF,AELIB5
      AREEL=BUFF(1)
      KT(W)=INT
*ENDIF
*IF -DEF,AELIB5
      AREEL=BUFF(2) $ CW(W)=INT
*ENDIF
*IF DEF,AELIB5
      AREEL=BUFF(2)
      CW(W)=INT
*ENDIF
*IF -DEF,AELIB5
      NF(W)=SHIFT(INT,12).AND.7777B
*ENDIF
*IF DEF,AELIB5
      NF(W)=SHIFT(INT,12).AND.O"7777"
*ENDIF
*IF -DEF,AELIB5
      NDB(W)=SHIFT(INT,27).AND.77777B
*ENDIF
*IF DEF,AELIB5
      NDB(W)=SHIFT(INT,27).AND.O"77777"
*ENDIF
*IF -DEF,AELIB5
      ISIZE=SHIFT(INT,-18).AND.77777B
*ENDIF
*IF DEF,AELIB5
      ISIZE=SHIFT(INT,-18).AND.O"77777"
*ENDIF
*IF -DEF,AELIB5
      NCOM=SHIFT(INT,-9).AND.777B
*ENDIF
*IF DEF,AELIB5
      NCOM=SHIFT(INT,-9).AND.O"777"
*ENDIF
*IF -DEF,AELIB5
      IBLK=SHIFT(INT,-3).AND.77B
*ENDIF
*IF DEF,AELIB5
      IBLK=SHIFT(INT,-3).AND.O"77"
*ENDIF
*IF -DEF,AELIB5
      LC=INT.AND.7B
*ENDIF
*IF DEF,AELIB5
      LC=INT.AND.O"7"
*ENDIF
      RETURN
      END
      SUBROUTINE DPERROR
      IMPLICIT INTEGER (C-Z)
      COMMON/YYBUFF/BUFF(512)
      COMMON/YYFIT/FIT(35,2),ITYPE,OUT,NFF,NDD,IVAL,W
      DIMENSION MESSAGE(13)
      DATA MESSAGE/"DPLIST","DPVERIFY","DPREADL","DPREAD-SKP","DPREAD-SE
     ,Q","DPREAD","DPADD-READ","DPFILE-RD","DPEOI-SRCH","DPRESET","DPBUF
     ,ST","DPEROPT","DPREAD-SKR"/
      DATA IR,IW/"READ","WRITE"/
      MSG="NON-FATAL"
*IF -DEF,AELIB5
      FNF=IFETCH(FIT(1,W),3LFNF) $ FNF=SHIFT(FNF,1).AND.7B
*ENDIF
*IF DEF,AELIB5
      FNF=IFETCH(FIT(1,W),L"FNF")
      FNF=SHIFT(FNF,1).AND.O"7"
*ENDIF
      IF(FNF.EQ.1) MSG="FATAL"
*IF -DEF,AELIB5
      EO=IFETCH(FIT(1,W),2LEO)
*ENDIF
*IF DEF,AELIB5
      EO=IFETCH(FIT(1,W),L"EO")
*ENDIF
*IF -DEF,AELIB5
      M=IFETCH(FIT(1,W),3LIRS)
*ENDIF
*IF DEF,AELIB5
      M=IFETCH(FIT(1,W),L"IRS")
*ENDIF
      IF(ITYPE.GT.0) WRITE(OUT,10) M,MESSAGE(ITYPE),MSG
      J="DPSETUP"
      IF(ITYPE.LE.0) WRITE(OUT,10) M,J,MSG
*IF -DEF,AELIB5
      CALL STOREF(FIT(1,W),3LPEF,0)
*ENDIF
*IF DEF,AELIB5
      CALL STOREF(FIT(1,W),L"PEF",0)
*ENDIF
*IF -DEF,AELIB5
      CALL STOREF(FIT(1,W),3LIRS,0) $ J=IFETCH(FIT(1,W),3LSES)
*ENDIF
*IF DEF,AELIB5
      CALL STOREF(FIT(1,W),L"IRS",0)
      J=IFETCH(FIT(1,W),L"SES")
*ENDIF
*IF -DEF,AELIB5
      CALL STOREF(FIT(1,W),2LES,0)
*ENDIF
*IF DEF,AELIB5
      CALL STOREF(FIT(1,W),L"ES",0)
*ENDIF
C
C     READ PARITY ERRORS
C
*IF -DEF,AELIB5
      IF(M.NE.137B) GO TO21 $ WRITE(OUT,11) IR,J $ GO TO 20
*ENDIF
*IF DEF,AELIB5
      IF(M.NE.O"137") GO TO21
      WRITE(OUT,11) IR,J
      GO TO 20
*ENDIF
C
C     WRITE PARITY ERRORS
C
*IF -DEF,AELIB5
21    IF(M.NE.140B) GO TO22 $ WRITE(OUT,11) IW,J
*ENDIF
*IF DEF,AELIB5
21    IF(M.NE.O"140") GO TO22
      WRITE(OUT,11) IW,J
*ENDIF
C
C     DECREMENT TRIVAL ERROR COUNT ONLY FOR PARITY ERRORS
C
*IF -DEF,AELIB5
20    N=IFETCH(FIT(1,W),3LECT) $ N=N-1 $ CALL STOREF(FIT(1,W),3LECT,N)
*ENDIF
*IF DEF,AELIB5
20    N=IFETCH(FIT(1,W),L"ECT")
      N=N-1
      CALL STOREF(FIT(1,W),L"ECT",N)
*ENDIF
C
C     ATTEMPT TO DECODE NF AND NDB
C
*IF -DEF,AELIB5
22    NF=SHIFT(BUFF(2),12).AND.7777B $ NDB=SHIFT(BUFF(2),27).AND.77777B
*ENDIF
*IF DEF,AELIB5
22    NF=SHIFT(BUFF(2),12).AND.O"7777"
      NDB=SHIFT(BUFF(2),27).AND.O"77777"
*ENDIF
*IF -DEF,AELIB5
      IBLK=SHIFT(BUFF(2),57).AND.77B
*ENDIF
*IF DEF,AELIB5
      IBLK=SHIFT(BUFF(2),57).AND.O"77"
*ENDIF
*IF -DEF,AELIB5
      N=IFETCH(FIT(1,W),3LLFN)
*ENDIF
*IF DEF,AELIB5
      N=IFETCH(FIT(1,W),L"LFN")
*ENDIF
      WRITE(OUT,14) NF,NDB,IBLK,N
C
C     IMMEDIATELY ABORT RUN IF CRM ERROR 130 - CONTROL WORD PARITY
C
      N=0
*IF -DEF,AELIB5
      IF(M.EQ.130B) M=M/N
*ENDIF
*IF DEF,AELIB5
      IF(M.EQ.O"130") M=M/N
*ENDIF
C
C
C     SINCE SYSTEM ROUTINE DOES NOT EXIST TO LIST ON ZZZZZEF
C             IF EO IS GREATER OR = 4 ATTEMPT TO LIST
C
      IF(EO.GE.4) GO TO 23
      IF((NF.EQ.NFF).AND.(NDB.EQ.NDD)) GO TO 23
      RETURN
*IF -DEF,AELIB5
23    N=IFETCH(FIT(1,W),2LRL) $ N=N/10 $ MSG="DATA BLOCK"
*ENDIF
*IF DEF,AELIB5
23    N=IFETCH(FIT(1,W),L"RL")
      N=N/10
      MSG="DATA BLOCK"
*ENDIF
C
C     IF SES IS SET TO 1, 2 OR 3 SET IVAL = 1
C     IF SES = 4 SET IVAL = 2
C
      IF(J.GT.0.AND.J.LT.4) IVAL = 1
      IF(J.EQ.4) IVAL = 2
      WRITE(OUT,12) MSG,(BUFF(M),M=1,N)
C
C     WRITE OUT FIT
C
*IF -DEF,AELIB5
      MSG="FIT" $ WRITE(OUT,12) MSG,(FIT(M),M=1,18) $ WRITE(OUT,13)
*ENDIF
*IF DEF,AELIB5
      MSG="FIT"
      WRITE(OUT,12) MSG,(FIT(M,1),M=1,18)
      WRITE(OUT,13)
*ENDIF
C
*IF -DEF,AELIB5
10    FORMAT("0*",T15,"*** CYBER RECORD MANAGER ERROR ",O3," ENCOUNTERED
     , IN DATPAK ROUTINE ",A10," ***",5X,"ERROR CONDITION IS ",A10,/)
*ENDIF
*IF DEF,AELIB5
10    FORMAT('0*',T15,'*** CYBER RECORD MANAGER ERROR ',O3,' ENCOUNTERED
     , IN DATPAK ROUTINE ',A10,' ***',5X,'ERROR CONDITION IS ',A10,/)
*ENDIF
*IF -DEF,AELIB5
11    FORMAT(" *",T19,A5," PARITY ERROR, SEVERITY LEVEL IS ",O2,/)
*ENDIF
*IF DEF,AELIB5
11    FORMAT(' *',T19,A5,' PARITY ERROR, SEVERITY LEVEL IS ',O2,/)
*ENDIF
*IF -DEF,AELIB5
12    FORMAT("0*",T15,"CONTENTS OF ",A10,/,(6(2X,O20)),/)
*ENDIF
*IF DEF,AELIB5
12    FORMAT('0*',T15,'CONTENTS OF ',A10,/,(6(2X,O20)),/)
*ENDIF
*IF -DEF,AELIB5
13    FORMAT("0*",T15,"FOR AN EXPLANATION CONTACT A DATPAK EXPERT, OR CO
     ,NSULT CRM VERS 1 REFERENCE MANUAL, APP B - 60307300",/)
*ENDIF
*IF DEF,AELIB5
13    FORMAT('0*',T15,'FOR AN EXPLANATION CONTACT A DATPAK EXPERT, OR CO
     ,NSULT CRM VERS 1 REFERENCE MANUAL, APP B - 60307300',/)
*ENDIF
*IF -DEF,AELIB5
14    FORMAT(" *",T19,"CURRENT POSITION IS FILE ",I3,"  DATA BLOCK ",I5,
     ,"  BUFFER NUMBER ",I2,5X,"LOGICAL FILE ",A7,/)
*ENDIF
*IF DEF,AELIB5
14    FORMAT(' *',T19,'CURRENT POSITION IS FILE ',I3,'  DATA BLOCK ',I5,
     ,'  BUFFER NUMBER ',I2,5X,'LOGICAL FILE ',A7,/)
*ENDIF
      RETURN
      END
      SUBROUTINE DPLABEL(IOT,LCOMS,LAB)
      IMPLICIT INTEGER (C-Z)
      EQUIVALENCE (AREEL,INT)
      EXTERNAL DPERROR,DPREPV
      COMMON/YYBUFF/BUFF(512)
      COMMON/YYFIT/FIT(35,2),ITYPE,OUT,ENF,EDB,PEVAL,W
      COMMON/YYCTRL/CW(2),KT(2),NF(2),NDB(2),BPI(2),LFN(2),KWIC(2),
     ,              RL(2),LC,IBLK,NCOM,ISIZE,NFITS,IWCT,NREC,ERL
      COMMON/YYSCTH/I,J,K,L,M,N
      INTEGER LAB(1)
      DATA RL,KWIC,NFITS,ERL,BPI,OUT,NF,NDB,LFN/4*0,2,5,2*80.,6,6*1H /
      DATA W/1/
C
      ITYPE=0
      I=IOT
      CALL DPVERFY
      WRITE(OUT,25)
C
C     J IS USED TO ACCUMULATE TOTAL WORDS OF COMMENTS
C
      J=0
      DO 45 I = 1, LCOMS
               J=J+1
               INT=LAB(I)
               BUFF(J+8)=AREEL
45    CONTINUE
      KT(W)=J+7
      INT=CW(W)=0
      DO 46 I = 3, 8
               BUFF(I)=AREEL
46    CONTINUE
C
C     SET UP DATPAK CONTROL WORD CW
C
*IF -DEF,AELIB5
      CW(W)=SHIFT(J,18).OR.SHIFT(J,9).OR.11B
*ENDIF
*IF DEF,AELIB5
      CW(W)=SHIFT(J,18).OR.SHIFT(J,9).OR.O"11"
*ENDIF
      NF(W)=NDB(W)=0
      RL(W)=(KT(W)+1)*10
      CALL PUTREC
C
C     SET UP DATPAK END OF INFORMATION RECORD
C
      IWCT=KT(W)+6
*IF -DEF,AELIB5
      CW(W)= 0001 00001 00000 000 00 0B.OR.IWCT
*ENDIF
*IF DEF,AELIB5
      CW(W)= O"0001 00001 00000 000 00 0".OR.IWCT
*ENDIF
      NREC=2
      NF(W)=NDB(W)=1
      WRITE(OUT,16)
      WRITE(OUT,17) (LAB(I),I=1,LCOMS)
      WRITE(OUT,26)
      CALL ENDFILE(FIT(1,W))
C
C     WRITE OUT DATPAK END OF INFORMATION
C
      CALL  DPEOI
      RETURN
*IF -DEF,AELIB5
16    FORMAT("0*",T5,"DATPAK TAPE LABEL")
*ENDIF
*IF DEF,AELIB5
16    FORMAT('0*',T5,'DATPAK TAPE LABEL')
*ENDIF
*IF -DEF,AELIB5
17    FORMAT("+",(T33,8A10,/))
*ENDIF
*IF DEF,AELIB5
17    FORMAT('+',(T33,8A10,/))
*ENDIF
*IF -DEF,AELIB5
25    FORMAT("0*",T15,"INITIATE DATPAK LABEL")
*ENDIF
*IF DEF,AELIB5
25    FORMAT('0*',T15,'INITIATE DATPAK LABEL')
*ENDIF
*IF -DEF,AELIB5
26    FORMAT("0*",T15,"DATPAK LABEL COMPLETE")
*ENDIF
*IF DEF,AELIB5
26    FORMAT('0*',T15,'DATPAK LABEL COMPLETE')
*ENDIF
      END
      SUBROUTINE DPREADL(IOT,LCOMS,LAB,LOUT)
      IMPLICIT INTEGER (C-Z)
      EQUIVALENCE (AREEL,INT)
      EXTERNAL DPERROR,DPREPV
      COMMON/YYBUFF/BUFF(512)
      COMMON/YYFIT/FIT(35,2),ITYPE,OUT,ENF,EDB,PEVAL,W
      COMMON/YYCTRL/CW(2),KT(2),NF(2),NDB(2),BPI(2),LFN(2),KWIC(2),
     ,              RL(2),LC,IBLK,NCOM,ISIZE,NFITS,IWCT,NREC,ERL
      COMMON/YYSCTH/I,J,K,L,M,N
      INTEGER LAB(1)
*IF DEF,AELIB5
C
      CHARACTER * 10  TIME, DATE, ATIME, ADATE
C
*ENDIF
      DATA RL,KWIC,NFITS,ERL,BPI,OUT,NF,NDB,LFN/4*0,2,5,2*80.,6,6*1H /
      DATA W/1/
      ITYPE=3
      IF(LOUT.GT.0.AND.LOUT.LT.99) OUT=LOUT
      I=IOT
      CALL DPVERFY
      IF(KWIC(W).NE.1) GO TO 1
      KWIC(W)=0
      CALL DPEOI
C
C     IF CURRENT POSITION IS FILE 0 THEN BUFF ALREADY CONTAINS LABEL
C
1     IF(NF(W).EQ.0) GO TO 2
C
      CALL REWND(FIT(1,W))
      CALL GETREC
*IF -DEF,AELIB5
      CALL TIME(ATIME)
*ENDIF
*IF DEF,AELIB5
      ATIME = TIME()
*ENDIF
*IF -DEF,AELIB5
      CALL DATE(ADATE)
*ENDIF
*IF DEF,AELIB5
      ADATE = DATE()
*ENDIF
      WRITE(OUT,10) ATIME,ADATE
C
2     J=NCOM+8
      IF(LCOMS.GT.0.AND.LCOMS.LT.NCOM) J=LCOMS+8
      WRITE(OUT,19)
      K=0
      DO 3 I = 9,J
           AREEL=BUFF(I)
           K=K+1
           LAB(K)=INT
3     CONTINUE
C
      WRITE(OUT,20)
      LCOMS=K
C
C     SINCE NEXT OPERATION ON LFN(W) MAY BE A SEQUENTIAL LIST
C     SKIP OVER PARTITION
C
      CALL SKIP(FIT(1,W),1)
      NF(W)=1
      NDB(W)=0
      RETURN
*IF -DEF,AELIB5
 10   FORMAT("1*",T15,"DATPAK  C.R.N.L.    (VERS. 2.0 28/01/77)",T80,
     ,"TIME OF RUN ",A10,T105,"DATE ",A10,/)
*ENDIF
*IF DEF,AELIB5
 10   FORMAT('1*',T15,'DATPAK  C.R.N.L.    (VERS. 2.0 28/01/77)',T80,
     ,'TIME OF RUN ',A10,T105,'DATE ',A10,/)
*ENDIF
*IF -DEF,AELIB5
19    FORMAT("0*",T15,"ENTER DPREAD LABEL")
*ENDIF
*IF DEF,AELIB5
19    FORMAT('0*',T15,'ENTER DPREAD LABEL')
*ENDIF
*IF -DEF,AELIB5
20    FORMAT("0*",T15,"DATPAK LABEL SUCCESSFULLY READ")
*ENDIF
*IF DEF,AELIB5
20    FORMAT('0*',T15,'DATPAK LABEL SUCCESSFULLY READ')
*ENDIF
      END
      SUBROUTINE PUTREC
      IMPLICIT INTEGER (C-Z)
      EQUIVALENCE (AREEL,INT)
      EXTERNAL DPERROR,DPREPV
      COMMON/YYBUFF/BUFF(512)
      COMMON/YYFIT/FIT(35,2),ITYPE,OUT,ENF,EDB,PEVAL,W
      COMMON/YYCTRL/CW(2),KT(2),NF(2),NDB(2),BPI(2),LFN(2),KWIC(2),
     ,              RL(2),LC,IBLK,NCOM,ISIZE,NFITS,IWCT,NREC,ERL
      COMMON/YYSCTH/I,J,K,L,M,N
      DATA RL,KWIC,NFITS,ERL,BPI,OUT,NF,NDB,LFN/4*0,2,5,2*80.,6,6*1H /
      DATA W/1/
C
      INT=CW(W)
      BUFF(2)=AREEL
      INT=KT(W)
      BUFF(1)=AREEL
C
C     WRITE OUT RL CHARACTERS FROM BUFF
C
      CALL PUT(FIT(1,W),BUFF,RL(W))
C
C     WAIT UNTIL PUT IS COMPLETED
C
      CALL CHECK(FIT(1,W))
C
      RETURN
      END
      SUBROUTINE DPEOI
      IMPLICIT INTEGER (C-Z)
      EQUIVALENCE (AREEL,INT)
      EXTERNAL DPERROR,DPREPV
      COMMON/YYBUFF/BUFF(512)
      COMMON/YYFIT/FIT(35,2),ITYPE,OUT,ENF,EDB,PEVAL,W
      COMMON/YYCTRL/CW(2),KT(2),NF(2),NDB(2),BPI(2),LFN(2),KWIC(2),
     ,              RL(2),LC,IBLK,NCOM,ISIZE,NFITS,IWCT,NREC,ERL
      COMMON/YYSCTH/I,J,K,L,M,N
      DATA RL,KWIC,NFITS,ERL,BPI,OUT,NF,NDB,LFN/4*0,2,5,2*80.,6,6*1H /
      DATA W/1/
      INT=NREC
      BUFF(3)=AREEL
      KT(W)=2
      RL(W)=30
      IF(KWIC(W).EQ.1) GO TO 98
C
C     KWIC MODE DOES NOT WRITE EOI RECORD
C
      CALL PUTREC
      CALL SKIP(FIT(1,W),-1)
C
C     CALCULATE FOOTAGE WITH WORD ACCUMULATE IWCT
C
98    AFTG=(((IWCT+NREC*.8)/BPI(W))+(NREC*.75))/12.
      WRITE(OUT,18) AFTG
*IF -DEF,AELIB5
18    FORMAT("0*",T5,"APPROXIMATE AMOUNT OF MAGNETIC TAPE USED IS ",F6.1
     ,," FEET")
*ENDIF
*IF DEF,AELIB5
18    FORMAT('0*',T5,'APPROXIMATE AMOUNT OF MAGNETIC TAPE USED IS ',F6.1
     ,,' FEET')
*ENDIF
      RETURN
      END
      SUBROUTINE DPADD(IOT,LCOMS,LAB,LDAT,ARR,NFF,NDD,MODE,IVAL)
      IMPLICIT INTEGER (C-Z)
      EQUIVALENCE (AREEL,INT)
      EXTERNAL DPERROR,DPREPV
      COMMON/YYBUFF/BUFF(512)
      COMMON/YYFIT/FIT(35,2),ITYPE,OUT,ENF,EDB,PEVAL,W
      COMMON/YYCTRL/CW(2),KT(2),NF(2),NDB(2),BPI(2),LFN(2),KWIC(2),
     ,              RL(2),LC,IBLK,NCOM,ISIZE,NFITS,IWCT,NREC,ERL
      COMMON/YYSCTH/I,J,K,L,M,N
      INTEGER LAB(1)
      REAL ARR(1)
      DATA RL,KWIC,NFITS,ERL,BPI,OUT,NF,NDB,LFN/4*0,2,5,2*80.,6,6*1H /
      DATA W/1/
      ITYPE=7
      I=IOT
      CALL DPVERFY
      KWIC(W)=0
      IF(RL(W).NE.30) CALL FINDEOI
      ITYPE=0
      IBLK=1
      IF(MODE.EQ.1) WRITE(OUT,27)
C
C     START TO WRITE INFORMATION TO DATA BLOCK
C
      ISIZE=LCOMS+LDAT
*IF -DEF,AELIB5
      CW(W)=CW(W).AND. 7777 77777 00000 000 00 0B
     ,      .OR.SHIFT(ISIZE,18).OR.SHIFT(LCOMS,9)
*ENDIF
*IF DEF,AELIB5
      CW(W)=CW(W).AND. O"7777 77777 00000 000 00 0"
     ,        .OR.SHIFT(ISIZE,18).OR.SHIFT(LCOMS,9)
*ENDIF
C
C     TRANSFER COMMENTS
C     J IS BUFF INDEX POINTER
C
      J=2
      RL(W)=5120
      IF(LCOMS.EQ.0) GO TO 105
      DO 103 I= 1, LCOMS
               INT=LAB(I)
               J=J+1
               BUFF(J)=AREEL
103   CONTINUE
      KT(W)=LCOMS+1
      IF(LDAT.EQ.0) GO TO 106
C
C     J IS FIRST LOCATION FOR DATA
C
105   DO 104 I = 1, LDAT
               J=J+1
               BUFF(J)=ARR(I)
               IF(J.NE.512) GO TO 104
*IF -DEF,AELIB5
               CW(W)=CW(W).AND. 7777 77777 77777 777 00 0B
     ,                .OR.SHIFT(IBLK,3)
*ENDIF
*IF DEF,AELIB5
               CW(W)=CW(W).AND. O"7777 77777 77777 777 00 0"
     ,                  .OR.SHIFT(IBLK,3)
*ENDIF
               KT(W)=511
               CALL PUTREC
C
C     A FULL BUFFER ADDS AN EXTRA CONTROL WORD
C
               J=2
               IWCT=IWCT+5
               IBLK=IBLK+1
C
C     IWCT CONTAINS 2 WORDS OF WI + KT + CW
C
104   CONTINUE
      KT(W)=J-1
C
C     WRITE LAST BLOCK
C
*IF -DEF,AELIB5
106   CW(W)=CW(W).AND. 7777 77777 77777 777 00 0B
     ,      .OR.SHIFT(IBLK,3) + 1B
*ENDIF
*IF DEF,AELIB5
106   CW(W)=CW(W).AND. O"7777 77777 77777 777 00 0"
     ,        .OR.SHIFT(IBLK,3) + O"1"
*ENDIF
      IWCT=IWCT+4
      RL(W)=J*10
      CALL PUTREC
      IWCT=IWCT+ISIZE
C
C     IS THIS A KWIC MODE ADD
C
      IF(IVAL.EQ.1) KWIC(W)=1
      NFF=NF(W)
      NDD=NDB(W)
      NDB(W)=NDB(W)+1
      CW(W)=SHIFT(NF(W),48).OR.SHIFT(NDB(W),33).OR.IWCT
      IF(LCOMS.GT.0.AND.MODE.EQ.1) WRITE(OUT,17) (LAB(I),I=1,LCOMS)
C
C     WRITE DATPAK END OF INFORMATION
C
      WRITE(OUT,28) NFF,NDD
      NREC=NF(W)+1
      CALL DPEOI
      RETURN
*IF -DEF,AELIB5
17    FORMAT("+",(T33,8A10,/))
*ENDIF
*IF DEF,AELIB5
17    FORMAT('+',(T33,8A10,/))
*ENDIF
*IF -DEF,AELIB5
27    FORMAT("0*",T5,"ADD NEW DATPAK DATA BLOCK - ")
*ENDIF
*IF DEF,AELIB5
27    FORMAT('0*',T5,'ADD NEW DATPAK DATA BLOCK - ')
*ENDIF
*IF -DEF,AELIB5
28    FORMAT("0*",T5,"ADD COMPLETE FOR FILE ",I4,"   DATA BLOCK ",I5)
*ENDIF
*IF DEF,AELIB5
28    FORMAT('0*',T5,'ADD COMPLETE FOR FILE ',I4,'   DATA BLOCK ',I5)
*ENDIF
      END
      SUBROUTINE FINDEOI
      IMPLICIT INTEGER (C-Z)
      EXTERNAL DPERROR,DPREPV
      COMMON/YYBUFF/BUFF(512)
      COMMON/YYFIT/FIT(35,2),ITYPE,OUT,ENF,EDB,PEVAL,W
      COMMON/YYCTRL/CW(2),KT(2),NF(2),NDB(2),BPI(2),LFN(2),KWIC(2),
     ,              RL(2),LC,IBLK,NCOM,ISIZE,NFITS,IWCT,NREC,ERL
      COMMON/YYSCTH/I,J,K,L,M,N
      DATA RL,KWIC,NFITS,ERL,BPI,OUT,NF,NDB,LFN/4*0,2,5,2*80.,6,6*1H /
      DATA W/1/
C
C     THIS ROUTINE WILL POSITION DATPAK TAPE AT END OF INFORMATION
C
      JTYPE=ITYPE
      ITYPE=9
1     CALL GETREC
*IF -DEF,AELIB5
      IF(M.EQ.100B) STOP "NO DPEOI FOUND, MUST RESET"
*ENDIF
*IF DEF,AELIB5
      IF(M.EQ.O"100") STOP 'NO DPEOI FOUND, MUST RESET'
*ENDIF
*IF -DEF,AELIB5
      RL(W)=IFETCH(FIT(1,W),2LRL)
*ENDIF
*IF DEF,AELIB5
      RL(W)=IFETCH(FIT(1,W),L"RL")
*ENDIF
      IF(RL(W).NE.30) GO TO 1
*IF -DEF,AELIB5
      IWCT=CW(W).AND. 7777777777B
*ENDIF
*IF DEF,AELIB5
      IWCT=CW(W).AND. O"7777777777"
*ENDIF
      CALL SKIP(FIT(1,W),-1)
      ITYPE=JTYPE
      RETURN
      END
      SUBROUTINE DPFILE(IOT)
      IMPLICIT INTEGER (C-Z)
      EXTERNAL DPERROR,DPREPV
      COMMON/YYBUFF/BUFF(512)
      COMMON/YYFIT/FIT(35,2),ITYPE,OUT,ENF,EDB,PEVAL,W
      COMMON/YYCTRL/CW(2),KT(2),NF(2),NDB(2),BPI(2),LFN(2),KWIC(2),
     ,              RL(2),LC,IBLK,NCOM,ISIZE,NFITS,IWCT,NREC,ERL
      COMMON/YYSCTH/I,J,K,L,M,N
      DATA RL,KWIC,NFITS,ERL,BPI,OUT,NF,NDB,LFN/4*0,2,5,2*80.,6,6*1H /
      DATA W/1/
C
C     WRITE AN ENDFILE AT CURRENT END OF INFORMATION
C
      ITYPE=8
      I=IOT
      CALL DPVERFY
      KWIC(W)=0
      IF(RL(W).NE.30) CALL FINDEOI
      IWCT=IWCT+3
      NF(W)=NF(W)+1
      NDB(W)=1
      NREC=NF(W)+1
      CW(W)=SHIFT(NF(W),48).OR.SHIFT(NDB(W),33).OR.IWCT
      WRITE(OUT,29)
      CALL ENDFILE(FIT(1,W))
      CALL DPEOI
*IF -DEF,AELIB5
29    FORMAT("0*",T5,"DATPAK END-OF-FILE WRITTEN")
*ENDIF
*IF DEF,AELIB5
29    FORMAT('0*',T5,'DATPAK END-OF-FILE WRITTEN')
*ENDIF
      RETURN
      END
      SUBROUTINE DPLIST(IOT,LCOMS)
      IMPLICIT INTEGER (C-Z)
      EQUIVALENCE (AREEL,INT)
      EXTERNAL DPERROR,DPREPV
      COMMON/YYBUFF/BUFF(512)
      COMMON/YYFIT/FIT(35,2),ITYPE,OUT,ENF,EDB,PEVAL,W
      COMMON/YYCTRL/CW(2),KT(2),NF(2),NDB(2),BPI(2),LFN(2),KWIC(2),
     ,              RL(2),LC,IBLK,NCOM,ISIZE,NFITS,IWCT,NREC,ERL
      COMMON/YYSCTH/I,J,K,L,M,N
*IF DEF,AELIB5
C
      CHARACTER * 10  TIME, DATE, ATIME, ADATE
C
*ENDIF
      DATA RL,KWIC,NFITS,ERL,BPI,OUT,NF,NDB,LFN/4*0,2,5,2*80.,6,6*1H /
      DATA W/1/
C
C     LIST DATPAK FILE AND DATA BLOCK NUMBERS AND COMMENTS IF ANY
C
      IF(LCOMS.GT.0.AND.LCOMS.LT.99) OUT=LCOMS
      ITYPE=1
      I=IOT
      CALL DPVERFY
C
C     IF IN KWIC MODE WRITE END OF INFORMATION BEFORE LISTING
C
      IF(KWIC(W).NE.1) GO TO 1
      KWIC(W)=0
      CALL DPEOI
      GO TO 2
C
1     IF(NF(W).EQ.0) GO TO 7
2     CALL REWND(FIT(1,W))
*IF -DEF,AELIB5
      CALL TIME(ATIME)
*ENDIF
*IF DEF,AELIB5
      ATIME = TIME()
*ENDIF
*IF -DEF,AELIB5
      CALL DATE(ADATE)
*ENDIF
*IF DEF,AELIB5
      ADATE = DATE()
*ENDIF
      WRITE(OUT,10) ATIME,ADATE
      CALL GETREC
C
C     LIST LABEL
C
7     WRITE(OUT,14)
      J=NCOM+8
      I=9
      WRITE(OUT,16)
C
C     "FM" IS USED TO CHECK FOR CONSECUTIVE FILE MARKS AND WARN USER
C
      FM=0
      IF(NCOM) 3,3,8
C
3     CALL GETREC
*IF -DEF,AELIB5
      IF(M.NE.40B) GO TO 4
*ENDIF
*IF DEF,AELIB5
      IF(M.NE.O"40") GO TO 4
*ENDIF
      FM=FM+1
      IF(FM.GT.1) WRITE(OUT,19)
      WRITE(OUT,11)
      GO TO 3
*IF -DEF,AELIB5
4     IF(M.NE.100B) GO TO 5
*ENDIF
*IF DEF,AELIB5
4     IF(M.NE.O"100") GO TO 5
*ENDIF
      WRITE(OUT,12)
*IF -DEF,AELIB5
99    IWCT=BUFF(2).AND. 7777777777B
*ENDIF
*IF DEF,AELIB5
99    IWCT=BUFF(2).AND. O"7777777777"
*ENDIF
      AREEL=BUFF(3)
      NREC=INT
      AFTG=(((IWCT+NREC*.8)/BPI(W))+(NREC*.75))/12.
      WRITE(OUT,18) AFTG
      RETURN
C
C     COMMENTS FOUND ONLY IN BLOCK 1 (IBLK=1)
C
5     IF(IBLK.NE.1) GO TO 3
      FM=0
C
C     NOW LIST OUT COMMENTS  BUFF(3-NCOM+2)
C
      WRITE(OUT,13) NF(W),NDB(W)
C
C     IF NO COMMENTS CONTINUE
C
      IF(NCOM) 3,3,9
9     J=NCOM+2
      I=3
8     WRITE(OUT,17) (BUFF(K),K=I,J)
      GO TO 3
*IF -DEF,AELIB5
 10   FORMAT("1*",T15,"DATPAK  C.R.N.L.    (VERS. 2.0 28/01/77)",T80,
     ,"TIME OF RUN ",A10,T105,"DATE ",A10,/)
*ENDIF
*IF DEF,AELIB5
 10   FORMAT('1*',T15,'DATPAK  C.R.N.L.    (VERS. 2.0 28/01/77)',T80,
     ,'TIME OF RUN ',A10,T105,'DATE ',A10,/)
*ENDIF
*IF -DEF,AELIB5
11    FORMAT(/," FILE MARK",/)
*ENDIF
*IF DEF,AELIB5
11    FORMAT(/,' FILE MARK',/)
*ENDIF
*IF -DEF,AELIB5
12    FORMAT(/," END-OF-INFORMATION",/)
*ENDIF
*IF DEF,AELIB5
12    FORMAT(/,' END-OF-INFORMATION',/)
*ENDIF
*IF -DEF,AELIB5
13    FORMAT(/," FILE ",I3,"     DATA BLOCK ",I4)
*ENDIF
*IF DEF,AELIB5
13    FORMAT(/,' FILE ',I3,'     DATA BLOCK ',I4)
*ENDIF
*IF -DEF,AELIB5
14    FORMAT(" *",T15,"LIST DATPAK TAPE",//)
*ENDIF
*IF DEF,AELIB5
14    FORMAT(' *',T15,'LIST DATPAK TAPE',//)
*ENDIF
*IF -DEF,AELIB5
16    FORMAT("0*",T5,"DATPAK TAPE LABEL")
*ENDIF
*IF DEF,AELIB5
16    FORMAT('0*',T5,'DATPAK TAPE LABEL')
*ENDIF
*IF -DEF,AELIB5
17    FORMAT("+",(T33,8A10,/))
*ENDIF
*IF DEF,AELIB5
17    FORMAT('+',(T33,8A10,/))
*ENDIF
*IF -DEF,AELIB5
18    FORMAT("0*",T5,"APPROXIMATE AMOUNT OF MAGNETIC TAPE USED IS ",F6.1
     ,," FEET")
*ENDIF
*IF DEF,AELIB5
18    FORMAT('0*',T5,'APPROXIMATE AMOUNT OF MAGNETIC TAPE USED IS ',F6.1
     ,,' FEET')
*ENDIF
*IF -DEF,AELIB5
 19   FORMAT("0*** VACUOUS FILE ***")
*ENDIF
*IF DEF,AELIB5
 19   FORMAT('0*** VACUOUS FILE ***')
*ENDIF
      END
      SUBROUTINE DPUNIT(IOT,LCOMS,LAB)
      IMPLICIT INTEGER (C-Z)
      EXTERNAL DPERROR,DPREPV
      COMMON/YYBUFF/BUFF(512)
      COMMON/YYFIT/FIT(35,2),ITYPE,OUT,ENF,EDB,PEVAL,W
      COMMON/YYCTRL/CW(2),KT(2),NF(2),NDB(2),BPI(2),LFN(2),KWIC(2),
     ,              RL(2),LC,IBLK,NCOM,ISIZE,NFITS,IWCT,NREC,ERL
      COMMON/YYSCTH/I,J,K,L,M,N
      DATA RL,KWIC,NFITS,ERL,BPI,OUT,NF,NDB,LFN/4*0,2,5,2*80.,6,6*1H /
      DATA W/1/
C
C     CHANGE DEFAULT (6) OUTPUT UNIT TO IOT
C
      OUT=IOT
      RETURN
C
C     CHANGE DEFAULT (800) TAPE DENSITY FOR FOOTAGE CALCULATION TO IOT
C
*IF -DEF,AELIB5
      ENTRY DPDNSTY
*ENDIF
*IF DEF,AELIB5
      ENTRY DPDNSTY(IOT,LCOMS,LAB)
*ENDIF
      I=IOT
      ITYPE=-1
      CALL DPVERFY
      IF(LCOMS.EQ.1600.OR.
     ,   LCOMS.EQ. 556.OR.
     ,   LCOMS.EQ. 200)  GO TO 130
      BPI(W)=80.
      WRITE(OUT,23) LCOMS
      RETURN
130   BPI(W)=LCOMS/10.
      WRITE(OUT,24) LCOMS,LFN(W)
      RETURN
*IF -DEF,AELIB5
23    FORMAT("0*",T15,"DATPAK RECORDING DENSITY ",I4," IS INVALID, DEFAU
     ,LT REMAINS AT 800 BPI")
*ENDIF
*IF DEF,AELIB5
23    FORMAT('0*',T15,'DATPAK RECORDING DENSITY ',I4,' IS INVALID, DEFAU
     ,LT REMAINS AT 800 BPI')
*ENDIF
*IF -DEF,AELIB5
24    FORMAT("0*",T15,"DATPAK RECORDING DENSITY IS ",I4," BPI, ON LFN ",
     ,A7)
*ENDIF
*IF DEF,AELIB5
24    FORMAT('0*',T15,'DATPAK RECORDING DENSITY IS ',I4,' BPI, ON LFN ',
     ,A7)
*ENDIF
C
C
*IF -DEF,AELIB5
      ENTRY DPWEOI
*ENDIF
*IF DEF,AELIB5
      ENTRY DPWEOI(IOT,LCOMS,LAB)
*ENDIF
C
C     WRITE DATPAK END OF INFORMATION IN KWIC MODE ADD ONLY
C
      I=IOT
      CALL DPVERFY
      IF(KWIC(W).NE.1) RETURN
      KWIC(W)=0
      WRITE(OUT,34)
      NREC=NF(W)+1
      CALL DPEOI
*IF -DEF,AELIB5
34    FORMAT("0*",T15,"WRITE DATPAK END OF INFORMATION COMPLETE")
*ENDIF
*IF DEF,AELIB5
34    FORMAT('0*',T15,'WRITE DATPAK END OF INFORMATION COMPLETE')
*ENDIF
      RETURN
C
C     CHOOSE ERROR OPTION LCOMS, AND ERROR LIMIT LAB
C
*IF -DEF,AELIB5
      ENTRY DPEROPT
*ENDIF
*IF DEF,AELIB5
      ENTRY DPEROPT(IOT,LCOMS,LAB)
*ENDIF
      I=IOT
      ITYPE=-1
      CALL DPVERFY
C
C     LCOMS IS ERROR OPTION
C
*IF -DEF,AELIB5
      IF(LCOMS.EQ.1LT.OR.
     ,   LCOMS.EQ.1LA.OR.
     ,   LCOMS.EQ.1LD.OR.
     ,   LCOMS.EQ.2LTD.OR.
     ,   LCOMS.EQ.2LDD.OR.
     ,   LCOMS.EQ.2LAD) GO TO 84
*ENDIF
*IF DEF,AELIB5
      IF(LCOMS.EQ.L"T".OR.
     ,    LCOMS.EQ.L"A".OR.
     ,     LCOMS.EQ.L"D".OR.
     ,      LCOMS.EQ.L"TD".OR.
     ,       LCOMS.EQ.L"DD".OR.
     ,        LCOMS.EQ.L"AD") GO TO 84
*ENDIF
      WRITE(OUT,38) LCOMS
      GO TO 85
*IF -DEF,AELIB5
84    CALL STOREF(FIT(1,W),2LEO,LCOMS)
*ENDIF
*IF DEF,AELIB5
84    CALL STOREF(FIT(1,W),L"EO",LCOMS)
*ENDIF
C
C     LAB IS TRIVAL ERROR LIMIT
C
85    IF(LAB.LT.0.OR.LAB.GT.511) GO TO 87
      ERL=LAB
*IF -DEF,AELIB5
      CALL STOREF(FIT(1,W),3LERL,ERL)
*ENDIF
*IF DEF,AELIB5
      CALL STOREF(FIT(1,W),L"ERL",ERL)
*ENDIF
87    WRITE(OUT,37) LCOMS,LAB
      RETURN
*IF -DEF,AELIB5
37    FORMAT("0*",T15,"DATPAK ERROR OPTION CHANGED TO ",A2,5X,"TRIVIAL E
     ,RROR LIMIT IS ",I3)
*ENDIF
*IF DEF,AELIB5
37    FORMAT('0*',T15,'DATPAK ERROR OPTION CHANGED TO ',A2,5X,'TRIVIAL E
     ,RROR LIMIT IS ',I3)
*ENDIF
*IF -DEF,AELIB5
38    FORMAT("0*",T15,"INVALID DATPAK ERROR OPTION ",A2," DEFAULT REMAIN
     ,S")
*ENDIF
*IF DEF,AELIB5
38    FORMAT('0*',T15,'INVALID DATPAK ERROR OPTION ',A2,' DEFAULT REMAIN
     ,S')
*ENDIF
C
C     ALLOW USER TO SPECIFY BUFFER SIZE AND FWA OF BUFFER
C
*IF -DEF,AELIB5
      ENTRY DPBUFST
*ENDIF
*IF DEF,AELIB5
      ENTRY DPBUFST(IOT,LCOMS,LAB)
*ENDIF
C
C     SET USER BUFFER LOCATION AND/OR SIZE
C
      I=IOT
      ITYPE=-2
C
C     LCOMS IS NEW BUFFER SIZE
C     LAB(1) IS FWA OF BUFFER
C     PASS THESE F.P. TO DPVERFY
C
      K=LCOMS
      L=LAB
      CALL DPVERFY
      RETURN
C
C
C     ALLOW USER TO CLOSE/UNLOAD DATPAK TAPE FILE
C
*IF -DEF,AELIB5
      ENTRY DPCLOSE
*ENDIF
*IF DEF,AELIB5
      ENTRY DPCLOSE(IOT,LCOMS,LAB)
*ENDIF
      I=IOT
      CALL DPVERFY
      J=LCOMS
C
C     CHECK FOR CORRECT CLOSE FLAG
C
*IF -DEF,AELIB5
      IF(J.EQ.1LU.OR.J.EQ.1LR.OR.J.EQ.1LN) GO TO 50
*ENDIF
*IF DEF,AELIB5
      IF(J.EQ.L"U".OR.J.EQ.L"R".OR.J.EQ.L"N") GO TO 50
*ENDIF
*IF -DEF,AELIB5
      J=1LU
*ENDIF
*IF DEF,AELIB5
      J=L"U"
*ENDIF
*IF -DEF,AELIB5
 50   CALL CLOSEM(FIT(1,W),J,4LFILE)
*ENDIF
*IF DEF,AELIB5
 50   CALL CLOSEM(FIT(1,W),J,L"FILE")
*ENDIF
      WRITE(OUT,51) LFN(W)
*IF -DEF,AELIB5
 51   FORMAT("0*",T15,"CLOSE DATPAK FILE ",A7," COMPLETE")
*ENDIF
*IF DEF,AELIB5
 51   FORMAT('0*',T15,'CLOSE DATPAK FILE ',A7,' COMPLETE')
*ENDIF
      LFN(W)=NF(W)=NDB(W)=" "
      RL(W)=KWIC(W)=0
      BPI(W)=80.
      RETURN
      END
      SUBROUTINE DPRESET(IOT,LCOMS,LAB)
      IMPLICIT INTEGER (C-Z)
      EXTERNAL DPERROR,DPREPV
      COMMON/YYBUFF/BUFF(512)
      COMMON/YYFIT/FIT(35,2),ITYPE,OUT,ENF,EDB,PEVAL,W
      COMMON/YYCTRL/CW(2),KT(2),NF(2),NDB(2),BPI(2),LFN(2),KWIC(2),
     ,              RL(2),LC,IBLK,NCOM,ISIZE,NFITS,IWCT,NREC,ERL
      COMMON/YYSCTH/I,J,K,L,M,N
      DATA RL,KWIC,NFITS,ERL,BPI,OUT,NF,NDB,LFN/4*0,2,5,2*80.,6,6*1H /
      DATA W/1/
C
C     RESET DATPAK END OF INFORMATION
C
      ITYPE=10
      I=IOT
      CALL DPVERFY
      IF(KWIC(W).NE.1) GO TO 60
      KWIC(W)=0
      CALL DPEOI
60    NFF=LCOMS
      NDD=LAB
      IF ( NFF .GT. 0 ) GO TO 65
C
C     INVALID FILE, MUST BE GREATER THAN 0
C
      WRITE(OUT,31) NFF
      RETURN
 65   CONTINUE
C
C     MUST REWIND DATPAK TAPE TO ACCUMULATE NEW WORD COUNT
C
      CALL REWND(FIT(1,W))
      WRITE(OUT,30) NFF,NDD
      IWCT=6
62    CALL GETREC
*IF -DEF,AELIB5
      IF(M.EQ.40B) GO TO 61
*ENDIF
*IF DEF,AELIB5
      IF(M.EQ.O"40") GO TO 61
*ENDIF
*IF -DEF,AELIB5
      IF(M.EQ.100B) GO TO 64
*ENDIF
*IF DEF,AELIB5
      IF(M.EQ.O"100") GO TO 64
*ENDIF
C
C     CHECK THIS DATA BLOCK
C
      IWCT=IWCT+4
      IF(LC.NE.1) GO TO 62
      IWCT=IWCT+ISIZE
      IF(NF(W).EQ.NFF.AND.NDB(W).EQ.NDD) GO TO 69
      IF(NF(W).LE.NFF) GO TO 62
      GO TO 64
C
C     PREPARE TO WRITE NEW EOI
C
69    NF(W)=NFF
      NDB(W)=NDD+1
      NREC=NFF+1
      CW(W)=SHIFT(NFF,48).OR.SHIFT(NDB(W),33).OR.IWCT
      WRITE(OUT,32)
      CALL DPEOI
      RETURN
C
C     PARTITION READ, CHECK IF NDD = 0
C
61    IWCT=IWCT+3
      IF(NDD.EQ.0.AND.NF(W)+1.EQ.NFF) GO TO 69
      IF(NF(W).LE.NFF) GO TO 62
C
C     FILE AND/OR DATA BLOCK COULD NOT BE FOUND
C
64    WRITE(OUT,33)
      RETURN
*IF -DEF,AELIB5
 31   FORMAT("0*",T15,"DPRESET COULD NOT RESET EOI AT FILE ",I2," WILL C
     ,ONTINUE")
*ENDIF
*IF DEF,AELIB5
 31   FORMAT('0*',T15,'DPRESET COULD NOT RESET EOI AT FILE ',I2,' WILL C
     ,ONTINUE')
*ENDIF
*IF -DEF,AELIB5
30    FORMAT("0*",T15,"ENTER DATPAK RESET,  FILE ",I4," DATA BLOCK ",I5)
*ENDIF
*IF DEF,AELIB5
30    FORMAT('0*',T15,'ENTER DATPAK RESET,  FILE ',I4,' DATA BLOCK ',I5)
*ENDIF
*IF -DEF,AELIB5
32    FORMAT("0*",T15,"DATPAK RESET COMPLETE")
*ENDIF
*IF DEF,AELIB5
32    FORMAT('0*',T15,'DATPAK RESET COMPLETE')
*ENDIF
*IF -DEF,AELIB5
33    FORMAT("0*",T15,"DPRESET FAILED TO LOCATE FILE AND/OR DATA BLOCK")
*ENDIF
*IF DEF,AELIB5
33    FORMAT('0*',T15,'DPRESET FAILED TO LOCATE FILE AND/OR DATA BLOCK')
*ENDIF
      END
      SUBROUTINE DPREAD(IOT,LCOMS,LAB,LDAT,ARR,NFF,NDD,MODE,IVAL)
      IMPLICIT INTEGER (C-Z)
      EQUIVALENCE (AREEL,INT)
      EXTERNAL DPERROR,DPREPV
      COMMON/YYBUFF/BUFF(512)
      COMMON/YYFIT/FIT(35,2),ITYPE,OUT,ENF,EDB,PEVAL,W
      COMMON/YYCTRL/CW(2),KT(2),NF(2),NDB(2),BPI(2),LFN(2),KWIC(2),
     ,              RL(2),LC,IBLK,NCOM,ISIZE,NFITS,IWCT,NREC,ERL
      COMMON/YYSCTH/I,J,K,L,M,N
      INTEGER LAB(1)
      REAL ARR(1)
      DATA RL,KWIC,NFITS,ERL,BPI,OUT,NF,NDB,LFN/4*0,2,5,2*80.,6,6*1H /
      DATA W/1/
      ENF=NFF
      EDB=NDD
C
C     IVAL WILL BE SET TO PEVAL BEFORE RETURNING TO CALLING PROGRAM
C
C     IVAL = 0     DATA SUCCESSFULLY READ - NO ERRORS
C     IVAL = 1     PARITY ERROR, ROUTINE ABLE TO RECOVER (SET IN DPERROR
C     IVAL = 2     PARITY ERROR, ROUTINE WILL ACCEPT (DEFAULT) DATA EO=A
C     IVAL = 3     END OF FILE ENCOUNTERED IN SEQUENTIAL MODE
C     IVAL = 4     DATA COULD NOT BE FOUND OR SCOPE EOI READ
C
      PEVAL = 0
      ITYPE=4
      I=IOT
      CALL DPVERFY
      IF(KWIC(W).NE.1) GO TO 55
      KWIC(W)=0
      CALL DPEOI
55    IF(NF(W)-NFF) 58,56,58
C
C     NOT IN PROPER FILE, MUST SKIP FORWARD OR BACKWARD "I" PARTITIONS
C
58    I=NFF-NF(W)
      K=1
      ASSIGN 61 TO J
      IF (I) 69,56,49
  69  CALL REWND (FIT(1,W))
      I=NF(W)+I
      NF(W)=0
      NDB(W)=0
49    CONTINUE
      DO 59 L = 1, I
60          CALL SKIP(FIT(1,W),K)
*IF -DEF,AELIB5
            M=IFETCH(FIT(1,W),2LFP)
*ENDIF
*IF DEF,AELIB5
            M=IFETCH(FIT(1,W),L"FP")
*ENDIF
*IF -DEF,AELIB5
            IF(M.EQ.40B) GO TO J,(61,68)
*ENDIF
*IF DEF,AELIB5
            IF(M.EQ.O"40") GO TO J,(61,68)
*ENDIF
            IF(ITYPE.EQ.13) GO TO 59
*IF -DEF,AELIB5
            IF(M.EQ.100B)  GO TO 77
*ENDIF
*IF DEF,AELIB5
            IF(M.EQ.O"100")  GO TO 77
*ENDIF
            GO TO 60
 61   NF(W)=NF(W)+1
      NDB(W)=0
59    CONTINUE
C
C
C     NOW FIND OUT WHERE YOU ARE.
C
57    CALL GETREC
C
C     CHECK FOR DATPAK EOI RETRIEVED (RL=30)
C
*IF -DEF,AELIB5
      RL(W)=IFETCH(FIT(1,W),2LRL)
*ENDIF
*IF DEF,AELIB5
      RL(W)=IFETCH(FIT(1,W),L"RL")
*ENDIF
      IF(RL(W).EQ.30) GO TO 79
*IF -DEF,AELIB5
      IF(M.EQ.40B) GO TO 72
*ENDIF
*IF DEF,AELIB5
      IF(M.EQ.O"40") GO TO 72
*ENDIF
      IF(NF(W).EQ.NFF) GO TO 56
C
C     MUST BE PASSED NON-EXISTANT DATA FILE, SET IVAL TO 4 AND RETURN
C
      IF(NF(W).GT.NFF) GO TO 77
C
C     MUST NOT BE FAR ENOUGH DOWN TAPE
C
      I=1
      K=1
      GO TO 49
C
  56  IF(NDB(W).EQ.0) GO TO 57
      I=NDD-NDB(W)
      IF (I) 30,70,31
  30  I=0
      GO TO 69
  31  IF (I.EQ.1) GO TO 57
      I=I-1
      ITYPE=13
      K=1
      ASSIGN 68 TO J
      GO TO 49
C
C     COULD NOT FIND DATA BLOCK, POSITION AS BEFORE IF K LT 0
C
68    IF(K.GT.0) GO TO 72
      CALL SKIP(FIT(1,W),1)
      NF(W)=NF(W)-1
      GO TO 72
C
C     DATA IS FOUND - IS MODE = 1 (SEQUENTIAL)
C
70    ITYPE=5
      IF(MODE.NE.1) GO TO 73
71    CALL GETREC
*IF -DEF,AELIB5
      IF(M.NE.40B) GO TO 73
*ENDIF
*IF DEF,AELIB5
      IF(M.NE.O"40") GO TO 73
*ENDIF
C
C     END OF PARTITION IN SEQUENTIAL MODE
C
72    IVAL=3
C
C     POSITONED BEFORE FIRST DATA BLOCK OF FILE NF
C     SET NDB = 0 FOR NEXT SEQUENTIAL READ, IE MODE = 1
C
      NF(W)=NF(W)+1
      NDB(W)=0
      RETURN
C
C     END OF INFORMATION READ
C
 77   IF(MODE.EQ.1) GO TO 79
      IVAL=4
      WRITE(OUT,78) NFF,NDD,NF(W),NDB(W)
*IF -DEF,AELIB5
 78   FORMAT("0*",T15,"FILE ",I4," DATA BLOCK ",I5,"  NOT FOUND, CURRENT
     , POSITION IS FILE ",I4," DBLK ",I5)
*ENDIF
*IF DEF,AELIB5
 78   FORMAT('0*',T15,'FILE ',I4,' DATA BLOCK ',I5,'  NOT FOUND, CURRENT
     , POSITION IS FILE ',I4,' DBLK ',I5)
*ENDIF
      RETURN
C
C     THIS IS DPEOI READ IN SEQUENTIAL MODE
C
 79   IVAL=4
      WRITE(OUT,23)
*IF -DEF,AELIB5
 23   FORMAT("0*",T15,"DATPAK END OF INFORMATION READ")
*ENDIF
*IF DEF,AELIB5
 23   FORMAT('0*',T15,'DATPAK END OF INFORMATION READ')
*ENDIF
      RETURN
*IF -DEF,AELIB5
73    IF(M.EQ.100B) GO TO 77
*ENDIF
*IF DEF,AELIB5
73    IF(M.EQ.O"100") GO TO 77
*ENDIF
74    IF(IBLK.EQ.1) GO TO 75
C
C     MAY BE ATTEMPTING TO READ END OF INFORMATION IN SEQUENTIAL MODE
C
*IF -DEF,AELIB5
      RL(W)=IFETCH(FIT(1,W),2LRL)
*ENDIF
*IF DEF,AELIB5
      RL(W)=IFETCH(FIT(1,W),L"RL")
*ENDIF
      IF(RL(W).EQ.30) GO TO 71
      IF(MODE.NE.1) CALL SKIP(FIT(1,W),-2)
      GO TO 71
C
C     THIS IS ACTUAL BLOCK TO TRANSFER
C
C     CHECK IF DATA BLOCK CONTAINS ANY COMMENTS
C
75    IF(NCOM.EQ.0) GO TO 80
      J=NCOM+2
      I=3
C
C     USER MAY ONLY WANT LCOMS WORDS OF COMMENTS
C
      IF(LCOMS.GT.0.AND.LCOMS.LE.NCOM) J=LCOMS+2
C
C     L IS COMMENT/DATA POINTER
C
      L=0
      DO 76 K= I,J
            AREEL=BUFF(K)
            L=L+1
            LAB(L)=INT
76    CONTINUE
      LCOMS=L
80    L=0
      NDAT=ISIZE-NCOM
      IF(NDAT.EQ.0) GO TO 88
      ITYPE=6
      IF(LDAT.GT.0.AND.LDAT.LE.NDAT) NDAT=LDAT
      J=NCOM+3
82    I=KT(W)+1
      DO 81 K = J, I
            L=L+1
            ARR(L)=BUFF(K)
            IF(L.EQ.NDAT) GO TO 88
81    CONTINUE
      J=3
      CALL GETREC
      GO TO 82
C
C     ALL DATA + COMMENTS TRANSFERED
C
88    LDAT=L
      NFF=NF(W)
      NDD=NDB(W)
      IVAL=PEVAL
      WRITE(OUT,22) NFF,NDD
      WRITE(OUT,21) LCOMS,LDAT
      RETURN
*IF -DEF,AELIB5
21    FORMAT("0*",T15,I3," WORDS OF COMMENTS AND ",I5," WORDS OF DATA RE
     ,AD")
*ENDIF
*IF DEF,AELIB5
21    FORMAT('0*',T15,I3,' WORDS OF COMMENTS AND ',I5,' WORDS OF DATA RE
     ,AD')
*ENDIF
*IF -DEF,AELIB5
22    FORMAT("0*",T15,"RETURN AFTER DPREAD ON FILE ",I4," DATA BLOCK ",I
     ,5)
*ENDIF
*IF DEF,AELIB5
22    FORMAT('0*',T15,'RETURN AFTER DPREAD ON FILE ',I4,' DATA BLOCK ',I
     ,5)
*ENDIF
      END
