*DECK ICMMAGR
          IDENT  ICMMAGR
          TITLE    ICMMAGR - ALLOCATE A GROUP ID
          COMMENT       FTN-CMM - ALLOCATE GROUP ID
          SPACE  2
**        ICMMAGR
*
*         TITLE
*           ALLOCATE A GROUP ID
*
*         ENTRY
*           ID = ICMMAGR (ITYPE)
*
*           ITYPE - TYPE OF BLOCKS IN THIS GROUP
*                   = 0  - BLOCKS ARE LOCATED ABOVE HHA.
*                   = 1  - BLOCKS MAY BE LOCATED BELOW HHA.
*           ID    - FIELD FOR BLOCK ID.
*
*         EXIT
*           -ID- WILL CONTAIN AN INTEGER WHICH UNIQUELY IDENTIFIES
*         THE BLOCK. THIS INTEGER IS PROVIDED BY CMM.
*
*         CALLS
*           CMM.AGR (IN CMM)
*
*         METHOD
*           THE GROUP TYPE IS LOADED INTO X1. -CMM.AGR- IS CALLED,
*         AND THE BLOCK ID IS PUT INTO X6 FOR FUNCTION RETURN.
*
TRACE.    VFD    42/0LICMMAGR,18/ICMMAGR        FOR FORTRAN TRACE BACK
          ENTRY  ICMMAGR
ICMMAGR   DATA   0
          SA1    X1     GROUP-TYPE
+         RJ     =XCMM.AGR      CALL CMM
-         VFD    30/TRACE.
          BX6    X2     BLOCK ID FROM CMM
          EQ     ICMMAGR        RETURN
          END
