*DECK JBESCPX
      SUBROUTINE JBESCPX(P,X,Y,U,V)
      DIMENSION FACT1(50),TERMR(50),TERMI(50),FACT2(50),PROD1(50),
     CPROD2(50),FACT3(50),PULT1(50),PULT2(50)
      DATA MESNO1/200/
*CALL STATF
      IF(LEGVAR(P).NE.0.) GO TO 86
      IF(LEGVAR(X).NE.0..OR.LEGVAR(Y).NE.0.) GO TO 86
      IF(P.LT.0..OR.P.GT.1.) GO TO 86
      R=SQRT(X**2+Y**2)
      PI=3.14159265358979
      IF(R.EQ.0..AND.P.EQ.0.) GO TO 85
      IF (X.EQ.0) GO TO 1
      PHI=ATAN(Y/X)
      O=ABS(PHI)
      GO TO 2
    1 O=PI/2.
    2 IF (P.EQ. .50) GO TO 50
      IF (R.LT.10.) GO TO 55
      IF (P.EQ.0.0) GO TO 20
      IF (P.EQ.1.0) GO TO 20
      IF (R.GE.11.0) GO TO 11
      IF (O-.645771823237902) 60,60,55
   11 IF (R.GE.12.0) GO TO 12
      IF (O-.785398163397448) 60,60,55
   12 IF (R.GE.13.0) GO TO 13
      IF (O-.837758040957278) 60,60,55
   13 IF (R.GE.14.0) GO TO 14
      IF (O-.802851455917392) 60,60,55
   14 IF (R.GE.15.0) GO TO 15
      IF (O-.872664625997165) 60,60,55
   15 IF (R.GE.16.0 .OR. O.LE. .855211333477221) GO TO 60
      GO TO 55
   20 IF (R.GE.11.0) GO TO 21
      IF (O-.541052068118242) 60,60,55
   21 IF (R.GE.12.0) GO TO 22
      IF (O-.698131700797732) 60,60,55
   22 IF (R.GE.13.0) GO TO 23
      IF (O-.767944870877505) 60,60,55
   23 IF (R.GE.14.0) GO TO 24
      IF (O-.802851455917392) 60,60,55
   24 IF (R.GE.15.0) GO TO 25
      IF (O-.820304748437335) 60,60,55
   25 IF (R.GE.16.0 .OR. O.LE. .872664625997165) GO TO 60
      GO TO 55
C  EVALUATION FOR SMALL R
   55 GP=GAMMA(P+1)
      FACT1(1)=(R/2.)**P/GP
      RHS=(R/2.)**2
      FACT1(2)=-FACT1(1)*RHS/(P+1)
      K=2
   56 N=K
      IF (ABS(FACT1(K)) .LE.ABS(FACT1(1))*1.0E-14) GO TO 57
      FACT1(K+1)=-FACT1(K)*RHS/(K*(P+K))
      K=K+1
      GO TO 56
   57 DO 58 K=1,N
      TERMR(K)=FACT1(K)*COS((P+2*K-2)*O)
   58 TERMI(K)=FACT1(K)*SIN((P+2*K-2)*O)
      UP=0
      VP=0
      M=0
      NST1=N-1
      DO 59 L=M,NST1
      UP=UP+TERMR(N-L)
   59 VP=VP+TERMI(N-L)
      GO TO 80
C  EVALUATION FOR LARGE R
   60 F=2.0**6
      G=R**2
      H=P**2
      FACT2(1)=-(4.*H-1.)*(4.*H-9.)/(2.*F*G)
      FACT2(2)=-FACT2(1)*(4.*H-25.)*(4.*H-49.)/(12.*F*G)
      IF (R .LT. 19.5) GO TO 63
      K=2
   61 J=K
      IF (ABS(FACT2(K)) .LE. ABS(FACT2(1))*1.0E-14) GO TO 65
      FACT2(K+1)=-FACT2(K)*(4.*H-(4*K+1)**2)*(4.*H-(4*K+3)**2)/
     C ((2*K+2)*(2*K+1)*F*G)
      K=K+1
      GO TO 61
   63 K=2
   64 J=K-1
      IF (ABS(FACT2(K)) .GT. ABS(FACT2(K-1))) GO TO 65
      FACT2(K+1)=-FACT2(K)*(4.*H-(4*K+1)**2)*(4.*H-(4*K+3)**2)/
     C ((2*K+2)*(2*K+1)*F*G)
      K=K+1
      GO TO 64
   65 DO 66 K=1,J
      PROD1(K)=FACT2(K)*COS(2*K*O)
   66 PROD2(K)=FACT2(K)*SIN(2*K*O)
      SERAC=0
      SERAS=0
      M=0
      NST2=J-1
      DO 67 L=M,NST2
      SERAC=SERAC+PROD1(J-L)
   67 SERAS=SERAS+PROD2(J-L)
      FACT3(1)=(4.*H-1.)/(8.*R)
      FACT3(2)=-FACT3(1)*(4.*H-9.)*(4.*H-25.)/(6.*F*G)
      IF (R .LT. 19.5) GO TO 70
      K=2
   68 I=K
      IF (ABS(FACT3(K)) .LE. ABS(FACT3(1))*1.0E-14) GO TO 72
      FACT3(K+1)=-FACT3(K)*(4.*H-(4*K-1)**2)*(4.*H-(4*K+1)**2)/
     C (2*K*(2*K+1)*F*G)
      K=K+1
      GO TO 68
   70 K=2
   71 I=K-1
      IF (ABS(FACT3(K)) .GT. ABS(FACT3(K-1))) GO TO 72
      FACT3(K+1)=-FACT3(K)*(4.*H-(4*K-1)**2)*(4.*H-(4*K+1)**2)/
     C (2*K*(2*K+1)*F*G)
      K=K+1
      GO TO 71
   72 DO 73 K=1,I
      PULT1(K)=FACT3(K)*COS((2*K-1)*O)
   73 PULT2(K)=FACT3(K)*SIN((2*K-1)*O)
      SERBC=0
      SERBS=0
      M=0
      NST3=I-1
      DO 74 L=M,NST3
      SERBC=SERBC+PULT1(I-L)
   74 SERBS=SERBS+PULT2(I-L)
      ARGC=R*COS(O)-PI*(2.*P+1)/4.
      CSC=COS(ARGC)
      SNC=SIN(ARGC)
      ARGD=R*SIN(O)
      YY=EXP(ARGD)
      COSHD =(YY+1./YY)/2.
      SINHD =(YY-1./YY)/2.
      BRAK1=CSC*COSHD*(1.+SERAC)-SNC*SINHD*SERAS-SNC*COSHD*SERBC-CSC*
     C SINHD*SERBS
      BRAK2=SNC*SINHD*(1.+SERAC)+CSC*COSHD*SERAS+CSC*SINHD*SERBC-SNC*
     C COSHD*SERBS
      PREMULT=SQRT(2./(PI*R))
      OPRIME=O/2
      CSOP=COS(OPRIME)
      SNOP=SIN(OPRIME)
      UP=PREMULT*(CSOP*BRAK1-SNOP*BRAK2)
      VP=-PREMULT*(CSOP*BRAK2+SNOP*BRAK1)
      GO TO 80
C EVALUATION FOR P=1/2
   50 ARGCO=R*COS(O)
      ARGDO=R*SIN(O)
      CSCO=COS(ARGCO)
      SNCO=SIN(ARGCO)
      YY=EXP(ARGDO)
      COSHDO=(YY+1./YY)/2.
      SINHDO=(YY-1./YY)/2.
      OPRIME=O/2
      CSOP=COS(OPRIME)
      SNOP=SIN(OPRIME)
      PREMULT=SQRT(2./(PI*R))
      UP=PREMULT*(CSOP*SNCO*COSHDO+SNOP*CSCO*SINHDO)
      VP=PREMULT*(CSOP*CSCO*SINHDO-SNOP*SNCO*COSHDO)
C DETERMINATION OF CORRECT QUADRANT AND ASSOCIATED VALUES
   80 IF (X .EQ. 0.) GO TO 83
      IF (Y .EQ. 0.) GO TO 83
      CSPPI=COS(P*PI)
      SNPPI=SIN(P*PI)
      IF (X .GT. 0.) GO TO 82
      IF (Y .LT. 0.) GO TO 81
      U=CSPPI*UP+SNPPI*VP
      V=-CSPPI*VP+SNPPI*UP
      GO TO 84
   81 U=CSPPI*UP+SNPPI*VP
      V=CSPPI*VP-SNPPI*UP
      GO TO 84
   82 IF (Y .GT. 0.) GO TO 83
      U=UP
      V=-VP
      GO TO 84
   83 U=UP
      V=VP
   84 RETURN
   85 U=1.
      V=0.
      RETURN
C
C  ERROR SECTION FOR ILLEGAL ARGUMENTS.
C
*IF -DEF,AELIB5
   86 CALL AELERR(MESNO1,2HNF)
      U=17770000000000000000B
      V=17770000000000000000B
*ENDIF
*IF DEF,AELIB5
   86 CALL AELERR(MESNO1,'NF')
      U=O"17770000000000000000"
      V=O"17770000000000000000"
*ENDIF
      RETURN
      END
