*DECK PACKER
      SUBROUTINE PACKER(A,B,IRN,IP,M,N,IA)
C
C        SUBROUTINE TO PACK SPARSE MATRIX INTO STRUCTURE REQUIRED
C          BY HARWELL ROUTINES
C
C     A       ARRAY DIMENSION IA TO RECEIVE PACKED MATRIX
C      B    ARRAY DIMENSIONM,N CONTAINING MATRIX TO BE PACKEDF
C     IP      ARRAY DIMENSION NP [=N+1]  FOR POINTERS
C     IRN     ARRAY DIMENSION IA         FOR POINTERS
C     IA      MUST BE LARGER THAN THE NUMBER OF NON ZEROS
C
C      MATRIX B(I,J) IS STORED BY COLUMNS J IE B11 B31 B22 B42 B33  ETC
C      IRN  CONTAINS THE ROW NUMBERS I ABOVE  1 3 2 4 3   ETC
C      IP   CONTAINS THE POSITION IN A OF START OF EACH COLUMN J _ 1,3,5
C             IP(N+1) HOLDS NO OF NON ZEROS ON RETURN
C
C        M CARVER  DEC 74
C
      DIMENSION A(IA),IRN(IA),IP(1),B(M,N)
      COMMON/SPARS/LP,EPS,ISCALE,JSCALE
      DATA EPS,LP/1.E-14,6/
C
*CALL  STATF
      K=1
      DO 300 J=1,N
        IP(J)=K
        DO 300 I=1,M
          IF(ABS(B(I,J)).LT.EPS)GOTO300
            IRN(K)=I
            A(K)=B(I,J)
      IF(K.GE.IA)WRITE(LP,3)IA,K
            K=K+1
 300  CONTINUE
      IP(N+1)=K
*IF -DEF,AELIB5
   3  FORMAT(*0___ IA TOO SMALL IN PACKER [ IS *I3* SHOULD BE *I3* ]*)
*ENDIF
*IF DEF,AELIB5
   3  FORMAT('0___ IA TOO SMALL IN PACKER [ IS ',I3,' SHOULD BE ',I3,' ]
     +')
*ENDIF
      END
