*DECK PN
          IDENT PN
      ENTRY  PN$
      ENTRY PN
      VFD 42/0LPN,18/PN
*  FORTRAN CALLING SEQUENCE IS  PN(X,A,N+1)
*  REGISTERS B1 TO B4 AND X7 ARE NOT USED
*  FOR THE NEXT COMMENT N=N AND NOT N+1
*  NOTE THAT PN(X) IS EVALUATED IN THE FORM:
*          PN(X)=X*PN(N-1)+[X*P(N-1)-P(N-2)]*[(N-1)/N]
*  RATHER THAN IN THE EQUIVALENT FORM
*        N*PN(X)=(2*N-1)*X*P(N-1)-(N-1)*PN(N-2)
*  SINCE THE FIRST FORM MAY BE MORE EFFICIENT
*  WRITTEN BY J.H.SCHMIDT, NOV 1972
PN$   BSS  0
PN    DATA 0
      SX0  17204B
      SB7  1            B7 _ 1
      LX0  45           X0 _ 1.
      SA5  A1+2         ADDRESS OF N
      BX6  X0           TRANSFER 1. (=P0) TO X6
      SA5  X5           X5 _ N
      SA4  A1+B7        ADDRESS OF A(1)
      SB5  X5-1         B5 _ N   USE N INSTEAD OF N+1
      SA6  X4           P0=1.
      EQ B5,PN          IF (N = 0) RETURN
      SA1  X1           X1 _ X
      BX4  X0           X4 _ 1.  (=P(J-2))
      LX6  X1           X6 _ X  (=P(J-1))
      BX5  X0           X5 _ 1.
LOOP  SA6  A6+B7
      EQ  B5,B7,PN
      RX3  X1*X6        X3 _ X*P(J-1)
      RX2  X3-X4        X2 _ X*P(J-1)-P(J-2)
      NX2  X2
      RX2  X2*X5        X2 _ [X*P(J-1)-P(J-2)]*(J-1)
      SB5  B5-B7        COUNTER
      FX5  X5+X0        J=J+1
      RX2  X2/X5        X2 _ [(X*P(J-1)-P(J-2))*(J-1)]/J
      SA4  A6           X4 _ P(J-2)
      RX6  X2+X3        X6 _ X2+(X*P(J-1))
      NX6  X6           X6 _ P(N)
      EQ   LOOP
      END
