*DECK XTIME
          IDENT    XTIME
*
*
*   XTIME - RETURNS CP TIME USED BY THE PROGRAM AS A REAL NUMBER (N=1)
*        OR CP TIME LEFT IN PROGRAM AS A REAL NUMBER (N=2)
*        I.E.  TL = XTIME(N)
*
*   DEFAULT (N=1)
*
*   AUTHOR - D.B. GOULDING
*   DATE - JANUARY, 1971
*
*   RUN ENTRY REMOVED
*   DATE - NOVEMBER, 1972
*
*  REVISED 28/04/81 BY D.G. STEWART
*  TO RETURN TIME LEFT = 32767. WHEN
*  T0 OR T32767 ON JOB CARD.
*
*    REVISED 1982 JULY TO USE TIME MACRO INSTEAD OF MTR CALL TIM.
*    XTIME CAN THUS BE USED ON NOS, WITH WARNING THAT *TIME LEFT*
*    WILL ALWAYS BE REPORTED AS 32767.
*
*
*
          ENTRY    XTIME
AZERO    DATA      0
 TRACE.   VFD       42/0LXTIME,18/XTIME
XTIME     DATA     0
         SX6       A0
         SA6       AZERO          SAVE A0
         SA4       A1
         SA5       X4
         SB7       X5
         SB6       2
         RJ        DOIT           CALCULATE TIME (X6 = VALUE)
         SA1       AZERO
         SA0       X1             RESTORE A0
         EQ        XTIME          EXIT BACK TO MAIN PROGRAM
*
*
DOIT     DATA      0
          TIME      FDATE
         MX1       24
         SA2       FDATE
         BX3       X1*X2
         LX3       24
         SB1       X3             STORE TIME LIMIT IN B1
         MX1       24
         LX1       36
         BX3       X1*X2          CU MILLISECONDS USED IN X3
         LX3       48
         SB2       X3             CU SECONDS USED IN B2
         MX1       12
         LX1       12
         BX3       X1*X2
         PX4       B0,X3
         NX5       B0,X4
         SA1       =.001
         FX2       X5*X1      CONVERT MILLISECS TO SECONDS
         SX3       B2
         PX4       B0,X3
         NX5       B0,X4
         FX1       X2+X5          TOTAL TIME USED IN X1
         NX2       B0,X1
         EQ        B6,B7,TLEF
         BX6       X2
         EQ        DOIT
TLEF     SX3       B1
         SB3       32767           IF T32767
         EQ        B1,B3,INF          OR
         NZ        X3,NOZERO       T0 ON JOB CARD FOR INFINITE TIME
         SX3       B3              SET CP TIME LEFT TO 32767(77777B)
INF      PX4       B0,X3
         NX6       B0,X4
         EQ        DOIT
NOZERO   PX4       B0,X3
         NX5       B0,X4
         FX1       X5-X2          XLEFT = TIME LIMIT - TOTAL TIME USED
         NX6       B0,X1
         EQ        DOIT
CALLT    VFD       24/4HTIMP,36/FDATE
FDATE     DATA     0
         END
